2023-08-31 Tim Rühsen <tim.ruehsen@gmx.de>

     Release v2.1.0

2023-08-31 Tim Rühsen <tim.ruehsen@gmx.de>

     Update copyrights

2023-08-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/dns.c (resolve): Restrict socket type to SOCK_STREAM on Windows

2023-08-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix parsing HTMP/XML entities in URLs from HTML/XML
     
     * libwget/xml.c (wget_xml_decode_entities_inline): Fix decoding of &#dddd; and &#xhhhh;.
     * tests/test-base.c (main): Add test case for &#dddd; and &#xhhhh;.
     
     Reported-by: Michael Roosz

2023-08-13 Ander Juaristi <a@juaristi.eus>

     dns: Return all kinds of socket types available
     
     The resolve() function only returned SOCK_STREAM (TCP) sockets. We lift
     that limitation here, such that it will now return all socket types
     available in the system, both SOCK_STREAM and SOCK_DGRAM. And we let the
     calling function choose the socket type they want. We make this change
     to adapt for the upcoming QUIC code, which works entirely over UDP.
     
      * libwget/dns.c (resolve): Remove SOCK_STREAM constraint, return all
        kinds of sock types available.
      * libwget/net.c (wget_tcp_connect): select SOCK_STREAM socket types
        only
        (tcp_connect): new function to establish TCP connections.

2023-08-14 Mitch Capper <mitch.capper@gmail.com>

     gcc specific C constructor/destructors support for MSVC
     
     * libwget/private.h: Define INITIALIZER to support constructors with MSVC.
     * libwget/dns.c: Use INITIALIZER for library constructor.
     * libwget/http.c: Likewise.
     * libwget/init.c: Likewise.
     * libwget/random.c: Likewise.
     * libwget/ssl_gnutls.c: Likewise.
     * libwget/ssl_openssl.c: Likewise.
     * libwget/ssl_wolfssl.c: Likewise.
     
     Co-authored-by: Tim Rühsen <tim.ruehsen@gmx.e

2023-08-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Set Mitch Capper to ASSGN [skip ci]

2023-08-14 Mitch Capper <mitch.capper@gmail.com>

     Add better default cert/bundle paths for Windows
     
     * include/wget/wget.h: New function wget_ssl_default_cert_dir,
       new function wget_ssl_default_ca_bundle_path.
     * libwget/Makefile.am: Add ssl.c.
     * libwget/ssl.c: New file for common ssl/tls code.
     * libwget/ssl_gnutls.c (tls_init): Initialize cert paths.
     * libwget/ssl_openssl.c (tls_init): Likewise.
     * libwget/ssl_wolfssl.c (tls_init): Likewise.
     * src/options.c (struct config): Init ca_cert,
       (init): Allocate / dup config.ca_cert.
     
     Co-authored-by: Tim Rühsen <tim.ruehsen@gmx.d

2023-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (print_version): Work around MSVC preprocessor issue

2023-08-14 Mitch Capper <mitch.capper@gmail.com>

     Don't enable debug logging with wolfssl unless defined prior to including the options file
     
     * libwget/ssl_wolfssl.c: Test for DEBUG_WOLFSSL

2023-08-04 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: New stages

2023-08-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/io.c (wget_update_file): Fix file name generation for Windows

2023-08-04 Carles Pina i Estany <carles@pina.cat>

     * docs/wget2.md: Wrap short options with backtick
     
     Copyright-paperwork-exempt: Yes

2023-08-04 Carles Pina i Estany <carles@pina.cat>

     * docs/wget2.md: Wrap long options with backtick
     
     Copyright-paperwork-exempt: Yes

2023-08-04 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/io.c (wget_update_file): Fix MinGW compilation

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * cfg.mk: Disable several new syntax checks

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Call clone_wiki() early to init the wiki submodule

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update (Fixes -Wundef)

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap: Update

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (wget_ssl_init): Check for heap allocation failure

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_send_request): Remove unused variables

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Silence -Wvla in gnulib regex.h

2023-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Replace VLA in http2 code

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Enable VLA warnings

2023-07-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-timestamping.c: Replace VLA

2023-07-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-include-and-exclude-directories.c: Replace VLA

2023-07-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-metalink.c: Replace VLA

2023-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Replace VLA

2023-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hpkp_db.c: Replace VLA

2023-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashfile.c: Replace VLA

2023-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hash_printf.c: Replace VLA

2023-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/bar.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/io.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ocsp.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/tls_session.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/xml.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test-parse-html.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test-dl.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test-decompress.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/main.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/utils.c: Replace VLA

2023-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Replace VLA

2023-07-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/blacklist.c (get_local_filename_real): Replace VLA

2023-07-09 Tim Rühsen <tim.ruehsen@gmx.de>

     Silence -Wvla when including gettext.h
     
     * libwget/private.h: Disable -Wvla for #include <gettext.h>.
     * src/wget_main.h: Likewise.

2023-07-28 Mitch Capper <mitch.capper@gmail.com>

     Enable native VT support on windows (fixes cmdhost etc usages)
     
     * libwget/console.c: New function SetupConsoleHandle(),
       (wget_console_init): Call SetupConsoleHandle().
     * src/wget.c: New function is_tty(),
       (main): Call is_tty() instead of isatty().
     
     disable progress bar if VT mode is not supported (unless force is used)

2023-06-14 Mitch Capper <mitch.capper@gmail.com>

     Fix alternate port requests to proxies
     
     * include/wget/wget.h (wget_http_request_to_buffer): Add param 'port'.
     * libwget/http.c (wget_http_request_to_buffer): Likewise,
       (wget_http_send_request): Call wget_http_request_to_buffer with
       connection port.
     
     Copyright-paperwork-exempt: Yes

2023-06-12 Mitch Capper <mitch.capper@gmail.com>

     * libwget/private.h: Gate GCC pragma to avoid compiler warnings in MSVC
     
     Copyright-paperwork-exempt: Yes

2023-06-13 Mitch Capper <mitch.capper@gmail.com>

     Windows console width detection and update checks
     
     * libwget/utils.c (wget_get_screen_size): Add implementation for _WIN32.
     * src/bar.c (bar_update_thread): Add implementation for _WIN32.
     
     Copyright-paperwork-exempt: Yes
     Co-authored-by: Tim Rühsen <tim.ruehsen@gmx.de

2023-07-09 Mitch Capper <mitch.capper@gmail.com>

     * libwget/bar.c (bar_update_slot): Set filesize = bytes downloaded when completed
     
     Copyright-paperwork-exempt: Yes

2023-06-14 Mitch Capper <mitch.capper@gmail.com>

     bar: Reset filesize and bytes downloaded for one file in the slot
     
     * libwget/bar.c (wget_bar_slot_begin): Reset filesize and bytes_downloaded.
     
     Copyright-paperwork-exempt: Yes

2023-06-14 Mitch Capper <mitch.capper@gmail.com>

     Turn off WOLFSSL debugging if wget debugging is off
     
     * libwget/ssl_wolfssl.c (wget_ssl_init): Call wolfSSL_Debugging_OFF()
       if the debug flag is switched off.
     
     Copyright-paperwork-exempt: Yes

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Fix

2023-06-14 Mitch Capper <mitch.capper@gmail.com>

     Add a more reliable solution for Windows
     
     Fixes broken downloads on windows when poll returns early.
     
     * libwget/io.c (wget_ready_2_transfer): Call poll_retry on _WIN32,
       (poll_retry): New function.

2023-06-12 Mitch Capper <mitch.capper@gmail.com>

     Use after free fix around output document name (when colliding with existing)
     
     * src/wget.c (get_header): Correctly set dest and name.
     
     Copyright-paperwork-exempt: Yes

2023-06-12 Mitch Capper <mitch.capper@gmail.com>

     In debug mode warn if progress=bar that the info logstream is turned off
     
     * src/wget.c (main): Print info message if info logstream is turned off.
     
     Copyright-paperwork-exempt: Yes

2023-06-12 Mitch Capper <mitch.capper@gmail.com>

     Avoid setting non-supported options to remove log warnings
     
     * src/options.c (init): Avoid superfluous calls to wget_ssl_set_config_int().
     
     Copyright-paperwork-exempt: Yes

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c (ShowX509): Fix buffer overflow

2023-06-12 Mitch Capper <mitch.capper@gmail.com>

     WolfSSL: Only log certificate to console when debug is active
     
     * libwget/ssl_wolfssl.c (ShowX509): Check if debug logge ris active.
     
     Copyright-paperwork-exempt: Yes

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c (wget_tcp_connect): Use bool type

2023-06-12 Mitch Capper <mitch.capper@gmail.com>

     Fix wolfssl on windows by passing correct SOCKET descriptor
     
     * libwget/ssl_wolfssl.c: Use FD_TO_SOCKET where needed.
     
     Copyright-paperwork-exempt: Yes

2023-06-12 Mitch Capper <mitch.capper@gmail.com>

     Don't try to set file timestamps on ttys
     
     Avoids errors to console.
     
     * src/wget.c (set_file_mtime): Skip futimens if fd is a TTY.
     
     Copyright-paperwork-exempt: Yes

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     Improve DNS library initialization
     
     * libwget/dns.c (net_init): Rename to dns_init(),
       (net_exit): Rename to dns_exit(),
       (wget_dns_init): Call dns_init(),
       extend docs,
       (wget_dns_free): Call dns_exit(),
       extends docs.

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml (Full+VPATH/Debian): Make syntax-check

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/announce_template.txt: Fix sc_trailing_blank

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Fix sc_prohibit_empty_lines_at_EOF

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix code to silence sc_gettext_printf
     
     * libwget/http.c: Add _() around error messages where missing.
     * libwget/net.c: Likewise.
     * libwget/ssl_gnutls.c: Likewise.
     * libwget/ssl_openssl.c: Likewise.
     * src/wget.c: Likewise.

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * cfg.mk: Skip sc_error_message_uppercase

2023-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     tests/libtest.c (wget_test): Don't use backslash in path for MINGW32

2023-07-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Silence spell checker
     
     * contrib/spell-checker: Add 'anull' to exclude list.
     * libwget/ssl_gnutls.c: Fix verication to verification.
     * src/options.c: Fix pysical to physical.

2023-07-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (add_urls): Improve recursive RSS/Atom processing

2023-07-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c (wget_tcp_write): Fix missing argument of print_error()

2023-06-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (check_ocsp_response): Initialize time_t values

2023-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Makefile.am (fuzz-coverage): Exchange lcov --directory order

2023-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (options[]): Fix arguments for --filter-urls
     
     Reported as https://github.com/rockdaboot/wget2/issues/281 by @troy-daniel

2023-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c (wget_ssl_init): Explicitly set SSL_VERIFY_PEER

2023-06-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Add CIDR support in 'no_proxy' for IPv6
     
     * include/wget/wget.h: Fix http_get_no_proxy -> wget_http_get_no_proxy.
     * libwget/http.c: New function cidr_v6_match(),
       check for ipv6 CIDRs in wget_http_match_no_proxy().
     * unit-tests/test.c (test_match_no_proxy): Add IPv6 CIDR tests.

2023-06-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Silence clang-16+ warnings when using manywarnings
     
     * configure.ac: Add -Wno-unsafe-buffer-usage and
       -Wno-cast-function-type-strict to $WARN_CFLAGS

2023-05-29 Brahmajit Das <brahmajit.xyz@gmail.com>

     * libwget/thread.c (wget_thread_self): Fix build issues with clang-16
     
     With clang 16, specially on with musl libc, it would result in an
     incompatible pointer to integer conversion error. As clang 16 has made a
     few options default, including -Wincompatible-function-pointer-types.
     This patch fixes that error.
     
     First discovered on Gentoo's musl llvm profile. Please refer
     https://bugs.gentoo.org/898058.
     
     Signed-off-by: Brahmajit Das <brahmajit.xyz@gmail.com>
     
     Copyright-paperwork-exempt: Yes

2023-05-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-parse-css.c (main): Add data url to test

2023-05-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (queue_url_from_remote): info_printf() instead of debug_printf()

2023-05-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/decompressor.c: Explicitly include stdint.h before lzlib.h

2023-05-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (parse_no_proxies): Skip leading whitespace

2023-03-28 harshmohan07 <code.harshmohan@gmail.com>

     CIDR support added for no_proxy
     
     * libwget/http.c: Add function wget_http_cidr_match to support
       CIDR IP method for no_proxy
     * unit-tests/test.c: Add testcases to verify the functionality
       of the above function
     
     Fixes #615

2023-05-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Remove -Wstrict-flex-arrays for gcc-13

2023-04-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Use real destination port for DANE verification
     
     * libwget/net.h (struct wget_tcp_st): New member remote_port.
     * libwget/net.c (wget_tcp_connect): Set tcp->remote_port.
     * libwget/ssl_gnutls.c (struct session_context): New member port,
       (wget_ssl_open): Set ctx->port,
       (verify_certificate_callback): Use ctx->port for DANE verification.

2023-04-16 Tim Rühsen <tim.ruehsen@gmx.de>

     Either CA or DANE verification is required

2023-04-15 Tim Rühsen <tim.ruehsen@gmx.de>

     New option --dane
     
     * configure.ac: Enable DANE if libgnutls-dane is installed,
       add option --without-libdane.
     * docs/wget2.md: Add docs for option --dane.
     * include/wget/wget.h: Add WGET_SSL_DANE.
     * libwget/ssl_gnutls.c: Include include <gnutls/dane.h> if requested,
       (struct config): New member 'dane',
       (wget_ssl_set_config_int): Set value for dane via WGET_SSL_DANE,
       (wget_ssl_open): Call dane_verify_session_crt().
     * src/options.c (options): Add entry for --dane,
       (init): Set config.dane via wget_ssl_set_config_int().
     * src/wget_options.h (struct config): Add member 'dane'.

2023-02-22 kuukunen <kuukunen@kuukunen.net>

     Fix accidentally removing fragments when converting links.
     
     * src/wget.c (convert_links): Take the link fragment from the IRI
       instead of blacklist entry.
     
     Copyright-paperwork-exempt: Yes
     
     Fixes #623

2023-01-22 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix duplicate downloads for Link headers with rel=duplicate
     
     * src/wget.c (process_response_header): Remove check for 302+metalink,
       Use highest priority alternative link instead of Location,
       (process_response): Remove rel=duplicate code from metalink check.

2022-12-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (get_header): Fix segmentation fault (deref NULL)

2022-12-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new option --follow-sitemaps
     
     * docs/wget2.md: Add section for --follow-sitemaps.
     * src/options.c (struct config config): Set follow_sitemaps = true,
       (options[]): Add "follow-sitemaps".
     * src/wget.c (process_response): Only parse sitemaps if config.follow_sitemaps is set.

2022-12-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml (pages): Remove superfluous semicolons at EOL

2022-12-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Remove python->python3 symbolic link

2022-12-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Decode numeric XML entities
     
     * libwget/xml.c (wget_xml_decode_entities_inline): Decode numeric entities.
     * tests/test-base.c (main): Add test.

2022-11-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Use CONNECT for https_proxy
     
     * libwget/http.c (establish_proxy_connect): New function,
       (wget_http_open): Use CONNECT method for HTTPS proxying.
     
     Fixes #616

2022-10-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (queue_url_from_remote): Do some checks earlier

2022-10-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (init): Switch progress bar off when using -o/--output-file

2022-10-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (wget_ssl_read_timeout): Check for NULL error msg

2022-10-18 Ander Juaristi <a@juaristi.eus>

     Remove unused fields from vflags

2022-10-18 Ander Juaristi <a@juaristi.eus>

     Fix warnings

2022-10-14 Ander Juaristi <a@juaristi.eus>

     Remove unneeded ex_data indexes

2022-10-09 Ander Juaristi <a@juaristi.eus>

     Fix: Pass per-connection user data to OCSP callback

2022-10-09 Ander Juaristi <a@juaristi.eus>

     Check HPKP at the end

2022-10-09 Ander Juaristi <a@juaristi.eus>

     Fix memory leak

2022-09-30 Ander Juaristi <a@juaristi.eus>

     Rewrite find_issuer_cert
     
      * libwget/ssl_openss.c (find_issuer_cert): rewrite function to make it
        more concise

2022-09-30 Ander Juaristi <a@juaristi.eus>

     Remove unused variables

2022-08-07 Ander Juaristi <a@juaristi.eus>

     Do not request on-line OCSP for stapled responses

2022-08-03 Ander Juaristi <a@juaristi.eus>

     Better way to find issuer cert

2022-09-24 Ander Juaristi <a@juaristi.eus>

     Check OCSP at the end of handshake

2022-10-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Change arguments of wget_iri_compare to const
     
     * include/wget/wget.hi (wget_iri_compare): Add 'const' to arguments.
     * libwget/iri.c (wget_iri_compare): Likewise.

2022-10-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashmap.c (wget_hashmap_clear): Fix memory leak

2022-10-11 Tim Rühsen <tim.ruehsen@gmx.de>

     Extend network error messages with hostname and IP address
     
     * libwget/net.c: New function print_error(),
       new function print_error_host(),
       (wget_tcp_connect): Use new functions for error messages,
       (wget_tcp_read): Likewise,
       (wget_tcp_write): Likewise.

2022-10-11 Tim Rühsen <tim.ruehsen@gmx.de>

     Add host information to tcp structure
     
     * libwget/net.c (wget_tcp_connect): Set tcp.host,
       (wget_tcp_close): Free tcp.host.
     * libwget/net.h (struct wget_tcp_st): Add new member 'host'.

2022-10-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer_printf.c (read_precision,read_field_width): Use bool arg

2022-10-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer_printf.c (copy_string): Use strnlen if precision is given

2022-10-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer_printf.c (read_precision): Remove superfluous initialization

2022-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/Makefile.am: Add -lz to fuzzer libs

2022-09-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix spelling Warmup -> Warm-up
     
     * benchmarks/benches/http1.sh: Likewise
     * benchmarks/benches/http2.sh: Likewise

2022-09-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Introduce XML function to decode entities
     
     * include/wget/wget.h: Add wget_xml_decode_entities_inline().
     * libwget/iri.c (iri_unescape_inline): Remove decoding of XML entities.
     * libwget/xml.c: Add wget_xml_decode_entities_inline().
     * src/wget.c (normalize_uri): Call wget_xml_decode_entities_inline().

2022-08-10 Michael Lee <imichael2e2@gmail.com>

     Support compilation of wget.h from C++
     
     * include/wget/wget.h: Replace restrict with __restrict
     
     Copyright-paperwork-exempt: Yes

2022-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml (MinGW64): Set CFLAGS to $CFLAGS_DEFAULT

2022-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/bar.c (bar_deinit): Fix segfault (joining not initialized thread)

2022-07-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/valgrind-suppressions: Suppress memleak in gpgme_data_new_from_mem()

2022-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Remove obsolete module strpbrk

2022-07-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/spell-checker: Fix some shellcheck issues [skip ci]

2022-07-03 DalmeGNU <dalmemail@gmail.com>

     Implement --check-certificate=quiet
     
     * include/wget/wget.h: Add WGET_SSL_REPORT_INVALID_CERT macro
     * libwget/ssl_gnutls.c: Change certificate related error_printf() calls, for error_printf_check()
     * libwget/ssl_openssl.c: Consider the case WGET_SSL_REPORT_INVALID_CERT in wget_ssl_set_config_int()
     * libwget/ssl_wolfssl.c: Change certificate related error_printf() calls, for error_printf_check()
     * src/options.c: Admit quiet as a valid value on --check-certificate
     * src/wget_options.h: Move check_certificate from bool to an enum type (with enabled, disabled and log_disabled as values)

2022-07-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (verify_certificate_callback): Fix -Werror=dangling-else

2022-07-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml (Minimal/Debian): Fix configure flag

2022-07-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c (test_robots): Fix test error message [skip ci]

2022-07-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Handle comments in robots.txt correctly
     
     * libwget/robots.c (wget_robots_parse): Check for # as terminator.
     * unit-tests/test.c (test_robots): Fix tests, add new test for comments.

2022-07-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_highlevel.c (stream_callback): Log 'Failed to fwrite' instead of 'Failed to write'

2022-07-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c (wget_tcp_write): Log 'Failed to send' instead of 'Failed to write'

2022-07-01 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix status code for 5xx errors
     
     * src/wget.c (process_response_header): Set EXIT_STATUS_REMOTE on 5xx.
     * tests/test-i-https.c: New test to check 503 behavior.
     * tests/test-wget-1.c: Likewise.

2022-06-14 DalmeGNU <dalmemail@gmail.com>

     * libwget/bar.c: Redraw all slots of progress bar when resizing the window
     * libwget/bar.c: Set minimum width to bar decorations size, to avoid crashing when resizing terminal

2022-04-22 Avinash Sonawane <rootkea@gmail.com>

     * fuzz/libwget_http_client_fuzzer.c: Silence clang warning

2022-06-23 Avinash Sonawane <rootkea@gmail.com>

     * .gitlab-ci.yml: Add scan-build for `make check`

2022-04-27 Avinash Sonawane <rootkea@gmail.com>

     Fix wget_buffer_trim() for strings with only whitespaces
     
     * libwget/buffer.c: Don't access `start - 1`
     * unit-tests/test.c: Add tests
     
     Co-authored-by: Tim Rühsen <tim.ruehsen@gmx.de>

2022-04-28 Avinash Sonawane <rootkea@gmail.com>

     Remove redunadnt memcpy() calls and refactor
     
     * libwget/iri.c: Remove redundant memcpy() calls
     * libwget/iri.c: Refactor
     * libwget/dns_cache.c: Refactor

2022-04-27 Avinash Sonawane <rootkea@gmail.com>

     * examples/getstream.c: Initialize array to avoid strduping random memory

2022-04-27 Avinash Sonawane <rootkea@gmail.com>

     * libwget/http_parse.c: Fix sscanf return value check

2022-06-14 Avinash Sonawane <rootkea@gmail.com>

     * unit-tests/test.c (check): Exit if any of the basic tests fail
     
     Found-by: scan-build

2022-06-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c (test_buffer): Add new test

2022-04-28 Avinash Sonawane <rootkea@gmail.com>

     Refactor and fix code formatting
     
     * libwget/vector.c: Refactor
     * libwget/xml.c: Refactor
     * tests/test-include-and-exclude-directories.c: Refactor
     * tests/libtest.c: Fix code formatting

2022-04-28 Avinash Sonawane <rootkea@gmail.com>

     Remove redundant checks and update docs
     
     * libwget/list.c (wget_list_remove): Remove redundant checks
     * libwget/list.c (docs): Specify that it's a circular doubly linked list

2022-04-27 Avinash Sonawane <rootkea@gmail.com>

     * libwget/cookie.c: Don't call memset if cookie_db arg is NULL

2022-04-27 Avinash Sonawane <rootkea@gmail.com>

     Remove memset() calls
     
     * examples/batch_loader.c (main): Likewise
     * examples/check_url_types.c (main): Likewise
     * libwget/metalink.c (add_file_hash): Likewise
     * src/wget.c (program_init): Likewise

2022-04-21 Avinash Sonawane <rootkea@gmail.com>

     * .gitignore: Ignore all executables in libwget/

2022-06-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * examples/Makefile.am: Remove linking of libgnu.la

2022-06-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * Add -Wno-declaration-after-statement to clang-14+ manywarnings

2022-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (convert_links): Remove unused loop variable

2022-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Add -Wno-declaration-after-statement to clang-15 manywarnings

2022-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Drop -Wc90-c99-compat -Wlong-long from manywarnings (gcc-12)

2022-06-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/wget2.md (--progress): Fix the docs for --progress

2022-06-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (parse_progress_type): Improve Wget compatibility

2022-06-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (config): Use PROGRESS_TYPE_BAR as default

2022-06-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Add defines for PROGRESS_TYPE_(BAR|NONE)
     
     * src/bar.c: Make use of PROGRESS_TYPE defines.
     * src/wget.c: Likewise.
     * src/wget_bar.h: Define PROGRESS_TYPE_BAR and PROGRESS_TYPE_NONE.

2022-06-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/wget2.md: Fix .wgetrc to .wget2rc

2022-05-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/announce_template.txt: New file [skip ci]

2022-05-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Fix pages

2022-05-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Release v2.0.1

2022-05-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Move static wget2.exe to https://gnuwget.gitlab.io/wget2/wget2.exe

2022-05-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (wget_ssl_open): Silence sc_useless_cpp_parens

2022-05-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (wget_iri_get_escaped_resource): Fix escaping space in query part
     
     Examples and explanation in https://gitlab.com/gnuwget/wget/-/issues/10

2022-05-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: mkdir public for static MinGW build

2022-05-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: mkdir /public for static MinGW build

2022-05-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: unset CC for MinGW static

2022-05-08 Tim Rühsen <tim.ruehsen@gmx.de>

     i* .gitlab-ci.yml: Fix MinGW static build

2022-05-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Build static wget2.exe
     
     The static exe should be available from
       https://gnuwget.gitlab.io/wget2/wget2-latest.exe

2022-04-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (downloader_thread): Only set EXIT_STATUS_NETWORK on error for the try

2022-04-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Add tests for --level
     
     * tests/Makefile.am: Add test-level.c.
     * tests/test-level.c: New file with tests for --level.

2022-04-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-robots.c (main): Add a test for --no-robots

2022-04-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (add_urls): Amend info message

2022-03-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (wget_ssl_open): Check for X509_CHECK_FLAG_NEVER_CHECK_SUBJECT (introduced in OpenSSL >= 1.1)

2022-03-05 Tim Rühsen <tim.ruehsen@gmx.de>

     Disable building manylibs by default
     
     * .gitlab-ci.yml: Add --enable-manylibs to Full tests.
     * configure.ac: --disable-manylibs is default.

2022-03-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/Makefile.am: Use libwget_libadd for *_LIBADD

2022-03-04 Andreas Hubel <andreas.hubel@br.de>

     * libwget/Makefile.am: Add INTL_MACOSX_LIBS to LIBADDs
     
     Copyright-paperwork-exempt: Yes

2022-03-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * */Makefile.am: Reorder link libraries (libgnu.la first)

2022-03-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (print_help): Fix warning about missing case in switch

2022-03-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2022-02-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (print_help): Remove unreachable code

2022-02-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * gitlab-ci.yml: Switch off git CA verification on FreeBSD globally

2022-02-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * gitlab-ci.yml: Switch off git CA verification on FreeBSD

2022-02-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_get_response_cb): Extend error messages with URL

2022-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * cfg.mk: Skip sc_indent in 'make syntax-check'

2022-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (print_openssl_time): Use _() around error message

2022-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix storage files in help text and in the docs
     
     * docs/wget2.md: Fix ~/.wget-* to $XDG_DATA_HOME/wget/.wget-*
     * src/options.c: Likewise.

2022-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix copyright statements

2022-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Update copyright year

2022-02-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/dns.c (wget_dns_cache_ip): Put '' around host/ip in error message

2022-02-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix -k/--convert-links fragment
     
     * src/wget.c (convert_link_file_only): Use wget_debug_printf instead of wget_info_printf,
       (convert_links): Add fragment.
     * tests/test-k.c: Add fragment to test.

2022-02-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Properly escape URLs with -k/--convert-links
     
     * src/wget.c (convert_link_whole): Use wget_iri_escape_path() instead of wget_buffer_strcat().
     * tests/test-k.c (main): Add test of URL with query part including escaped characters.

2022-02-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test--*.c: Rename to test-*.c

2022-02-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix issue reported by scan-build
     
     * include/wget/wget.h: /// -> //.
     * libwget/netrc.c (unescape_password): Check wget_malloc() return against NULL.
     * libwget/xml.c (wget_xml_parse_file): Likewise.

2022-02-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c (test_cookies): Fix false reporting of a PSL error

2022-02-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix --directory-prefix with --content-disposition
     
     * src/blacklist.c (get_local_filename): Remove static from definition.
     * src/wget_blacklist.h (get_local_filename): Add declaration.
     * src/wget.c (process_response): Use get_local_filename() to process
       the filename from Content-Disposition,
       (get_header): Likewise.
     * tests/Makefile.am: Add new test file test-directory-prefix.c.
     * tests/test-directory-prefix.c: New test file.

2022-02-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Allow spaces and \ escaping in passwords in .netrc
     
     This is Wget1.x compatible.
     
     * docs/wget2.md: Document the new behavior.
     * libwget/netrc.c (wget_netrc_db_load): Amended the code to allow \ and "".
     * unit-tests/test.c (test_netrc): Add tests.

2022-01-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (prepare_file): Use wget_strdup instead of wget_asprintf

2022-01-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix obscure Windows (Win11) recv() issue (returns 0 without a reason)
     
     * libwget/http.c (wget_http_get_response_cb): Continue HTTP/2 loop if recv()
       return 0.
     
     Fixes https://github.com/rockdaboot/wget2/issues/256

2022-01-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_get_response_cb): Amend debug output [skip ci]

2022-01-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mingw.static: Add build instructions for zlib-ng [skip ci]

2022-01-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mingw.static: Add build instructions for nghttp2 [skip ci]

2022-01-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c (test_cookies): Check wget_cookie_db_load_psl() return value

2022-01-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c: Unlink output document when --unlink is given

2022-01-09 Tim Rühsen <tim.ruehsen@gmx.de>

     WolfSSL: Fix buffer overflow in SHA512 hashing
     
     * libwget/hashfile.c (wget_hash_deinit, WOLFSSL): Include wolfssl/options.h.

2022-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix deflate decompression when server omits the header
     
     * libwget/decompressor.c (gzip_decompress): Retry decompression without header

2022-01-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/Makefile.am: Remove -no-whole-archive (due to the previous commit reversion)

2022-01-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Revert "build: Use -Wl,--no-whole-archive"
     
     This reverts commit acfa50d31c453bca61620306e0aeeb577b4533c0.

2022-01-01 Ander Juaristi <a@juaristi.eus>

     OpenSSL: OCSP: Be more realistic with update times

2022-01-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update due to busybox sed issue

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Use Debian testing for the pages runner

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c: Comment out unneeded code

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c (wget_ssl_open): Fix memory leak

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/valgrind-suppressions: Suppress glibc false positive in dynnamic loading

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test): Add --gen-suppressions=all to valgrind options

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Use DEBIAN_TESTING_BUILD for Full+VPATH/Debian

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     Add support for unquoted HTML attribute values
     
     * libwget/xml.c (getHTMLValue): New function.
       (getValue): Call getHTMLValue if parsing HTML.
     * tests/test-base.c: Use an unquoted HREF value to trigger the new code.

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (check_ocsp_response): Print issue and update time

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Code cleanup

2022-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (check_ocsp_response): Fix OCSP checks

2021-12-30 Ander Juaristi <a@juaristi.eus>

      * libwget/ssl_openssl.c: Use SHA-1 for OCSP signature

2021-12-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Continue after OCSP failed other than REVOKED

2021-12-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (read_ocsp_uri_from_certificate): Free string stack after use

2021-12-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (read_ocsp_uri_from_certificate): Rewrite implementation of OCSP URI retrieval

2021-12-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Use Debian stable instead of Debian stretch

2021-12-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (check_cert_chain_for_ocsp): Fix number of ignored OCSP responses

2021-12-30 Ander Juaristi <a@juaristi.eus>

     openssl: Do not check max time in stapled OCSP

2021-12-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/utils.c: Enable debug logs if mkdir() fails, except for errno=EEXIST

2021-12-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/utils.c: Reduce debugging for calls to mkdir()

2021-12-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Do not treat 'Cannot resolve URI' as error

2021-12-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c (wget_http_parse_response_header): Use keep-alive for HTTP/1.1 and higher as default

2021-12-24 Tim Rühsen <tim.ruehsen@gmx.de>

      src/wget.c (nop): Call exit() instead abort() on SIGTERM

2021-12-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (nop): Call exit() instead abort() on 2nd CTRL-C

2021-12-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (http_create_request): Fix replacing Content-Type: headers

2021-12-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (process_response_header): Fix NULL pointer access

2021-12-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (iri_unescape_inline): Avoid harmless integer overflow

2021-12-05 Tim Rühsen <tim.ruehsen@gmx.de>

     Avoid function pointer casts to different type
     
     * libwget/hpkp_db.c (hpkp_save_pin, hpkp_save): Change parameter types.
     * libwget/hsts.c (hsts_save): Likewise.
     * libwget/ocsp.c (ocsp_save_fingerprint, ocsp_save_host): Likewise.
     * libwget/tls_session.c (tls_session_save): Likewise.
     * src/host.c (_search_host_for_free_job): Likewise.

2021-12-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (ssl_writev): Suppress clang's -Wcast-function-type

2021-12-05 Tim Rühsen <tim.ruehsen@gmx.de>

     Use sa_handler instead of sa_sigaction
     
     * examples/batch_loader.c (main): Use sa_handler instead of sa_sigaction.
     * examples/check_url_types.c (main): Likewise.
     * src/wget.c (program_init): Likewise.

2021-12-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Amend warnings for clang 12+ and 13+

2021-12-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mingw: Add --disable-full-test-suite to gnutls configure options

2021-11-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Move syntax-check to CI
     
     * .gitlab-ci.yml: Add `make syntax-check` to Full runner.
     * Makefile.am: Remove syntax-check from `make check`.

2021-11-18 Dmitry Marakasov <amdmi3@amdmi3.ru>

     * configure.ac: Fix OpenSSL library name
     
     If pkg-config check fails (which is the case on FreeBSD where system openssl does not have pkgconfig files), check for libssl library instead of incorrect libopenssl.
     
     Copyright-paperwork-exempt: Yes

2021-11-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Error if xattr have been requested but are not available

2021-11-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Don't build with lzma on default

2021-11-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Don't build with bzip2 on default

2021-11-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix fallback to AC_SEARCH_LIBS

2021-10-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mingw.static: New script to build a static wget2.exe

2021-10-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Replace gnutls_free() with free()
     
     I did this after having issues to build a static MinGW Wget2.exe.
     gnutls_free() was not properly exported by libgnutls.a.

2021-10-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c: Replace gnutls_free() with free()
     
     I did this after having issues to build a static MinGW Wget2.exe.
     gnutls_free() was not properly exported by libgnutls.a.

2021-10-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Update MinGW build script
     
     * .gitlab-ci.yml: Remove copying pthread_sigmask.c.mingw.
     * contrib/mingw: Update for latest dependency versions.
     * pthread_sigmask.c.mingw: Remove file.

2021-09-28 orbea <orbea@riseup.net>

     contrib: Remove unused libtool patch
     
     After the previous commit it now uses -Wl,--no-whole-archive
     instead of patching libtool in the build system. This is more
     portable for other libtool implementations other than the one
     by GNU.

2021-09-28 orbea <orbea@riseup.net>

     build: Use -Wl,--no-whole-archive
     
     This fixes the build with slibtool which does not have
     -no-whole-archive and avoids having to patch libtool
     in the build system.
     
     Since this is a linker argument and not a libtool argument
     it should be passed explicitly to the linker with -Wl.

2021-09-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Don't escape double quotes in AC_MSG_ERROR

2021-09-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix bashism == in if expression

2021-09-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix --without-lzip

2021-09-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * Makefile.am: Add contrib/libtool.patch to EXTRA_DIST

2021-09-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/announce_2.0.0.txt: Add list of noteworthy changes

2021-09-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/release: Add symlink for latest tarball [skip ci]

2021-09-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * NEWS: Set date + month of 2.0.0 release

2021-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     NEWS: Prepare for release v2.0.0

2021-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/announce_2.0.0.txt: New file

2021-09-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Update versions

2021-08-07 Jeffrey Marius <getjff@gmail.com>

     Fix issue #467 Adding wiki as submodule to repo
     
     * bootstrap.conf: Add clone_wiki() and call it from
       bootstrap_post_import_hook().
     
     Signed-off-by: Jeffrey Marius <getjff@gmail.com>

2021-08-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test--page-requisites.c: Add tests for new rel parsing

2021-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix the rel attribute handling for link tags

2021-07-07 Michael Roosz <michael.roosz@check24.de>

     * libwget/http.c (wget_http_response_cb): Fix chunked transfer

2020-11-22 Sergei Litvin <litvindev@gmail.com>

     Fix parsing comments in <style> content
     
     * libwget/xml.c: Add new function getStyleContent(),
       (parseXML): Use getStyleContent() instead of getContent(),
       update link in comment.

2021-05-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/libwget_html_url_fuzzer.dict: Add 'data:' to dictionary

2021-05-30 Michael Roosz <michael.roosz@check24.de>

     * libwget/html_url.c (html_get_url): Support data: URL in srcset attribute

2021-05-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/wget2.md: Mention that -P creates the prefix directory

2021-05-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c: Free memory in test_parse_header_line()

2021-05-16 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix request path escaping
     
     * include/wget/wget.h: Remove function wget_iri_isunreserved_path().
     * libwget/iri.c: Remove function wget_iri_isunreserved_path().
       (iri_ctype): Extend array with unreserved characters.
       (wget_iri_isunreserved): Simplify code.
       (wget_iri_escape): Use macro iri_isunreserved instead of wget_iri_isunreserved().
       (wget_iri_escape_path): Add RFC links to function comment,
       Fix check whether char needs percent-encoding or not,
       Use macro iri_isunreserved instead of wget_iri_isunreserved().

2021-03-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c: Remove old comment from RFC 2183.

2021-03-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Add test case for Content-Disposition
     
     * libwget/http_parse.c: Update comment with BNF of RFC 6266.
     * unit-tests/test.c: Add test for a filename containing space.

2021-02-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Drop manywarnings and SSL support on FreeBSD CI

2021-02-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Include openssl/asn1.h for ASN1* functions.

2021-02-07 Michael Roosz <michael.roosz@check24.de>

     * src/wget.c (prepare_file): Skip file name filter if config.filter_urls is active

2021-02-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix building without TLS library
     
     This changes configure semantics to fail if no TLS library
     is found and no --with-ssl=none was explicitly requested.
     It protects users from accidentally building without TLS.
     
     * .gitlab-ci.yml: Tarball build using --with-ssl=none.
     * configure.ac: Stop with error if no TLS was found and --with-ssl
       was not used.
     * tests/libtest.c: Fix issues with conditionally declared variables.

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Allow failure for FreeBSD runner

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Fix for openssl/clang

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-ocsp-server.c: Skip cert revocation check for WolfSSL

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-post-handshake-auth.c (main.c): Fix warning when building with non-gnutls libraries

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Separate GnuTLS in wget2 and in test suite
     
     * configure.ac: Separate GnuTLS in wget2 and in test suite.
     * tests/libtest.c: Use WITH_GNUTLS_OCSP insteadof WITH_OCSP.

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Improve searching for SSL/TLS libraries

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2021-02-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (get_tls_version): Fix error in case construct for LibreSSL

2021-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-chunked.c: Extend test with hand-crafted chunked pattern

2021-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_get_response_cb): Remove superfluous space in debug msg

2021-01-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hsts.c (hsts_db_add_entry): Fix possible NULL access

2021-01-24 Michael Roosz <michael.roosz@check24.de>

     * libwget/http.c (wget_http_get_response_cb): Fix NULL ptr access

2021-01-24 Michael Roosz <michael.roosz@check24.de>

     * libwget/http.c (wget_http_response): Fix buffer overflow

2021-01-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Detect unresolved AX_ macros

2021-01-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Use noyywrap for AC_PROG_LEX

2020-12-29 Michael Roosz <michael.roosz@check24.de>

     Fixed error log for non-fatal inflate() return code Z_BUF_ERROR
     
     * libwget/decompressor.c (gzip_decompress): Return 0 for Z_BUF_ERROR.

2021-01-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix for autoconf 2.70

2021-01-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap: Update from gnulib

2021-01-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2021-01-22 Darshit Shah <darnir@gnu.org>

     Update copyright year

2021-01-03 Darshit Shah <git@darnir.net>

     Update POTFILES.in

2021-01-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Add Michael Heerklotz [skip ci]

2021-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Add Michael Roosz [skip ci]

2021-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * .travis.yml: Remove unneeded packages for Linux

2021-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Small cleanups

2021-01-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Remove superfluous 'x' ahead of variables

2020-12-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix combination of redirections with --retry-on-http-error
     
     * src/wget.c: Move some code logic around.
     * tests/test-interrupt-response.c: Correct expected wget2 exit status.
     * tests/test-redirection.c: Add tests for --retry-on-http-error.
     
     Reported-by: Sergei Litvin

2020-12-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (print_version): Print https and ssl properly for OpenSSL and WolfSSL

2020-12-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Reduce duplicated code in check_status_code_list().
     
     * src/wget.c (check_status_code_list): Call check_statuscode_list().

2020-12-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (downloader_thread): Add check_statuscode_list() for readability

2020-12-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename config.http_retry_on_error to config.retry_on_http_error
     
     * src/options.c (options,deinit): Rename.
     * src/wget.c (downloader_thread): Rename.
     * src/wget_options.h (struct config): Rename.

2020-12-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test): Add --tries=1 to wget2 command line

2020-12-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Add Sergei Litvin

2020-12-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test_start_server): Fix warning 'break will never be executed'

2020-12-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test_start_server): Fix unused variable warning

2020-12-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Use AC_CONFIG_MACRO_DIR only once
     
     This fixes #547 (autotools 2.70 is more restrictive).
     Reported by: Gabriele Balducci

2020-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix clang 11 warnings in WolfSSL code.
     
     * libwget/hashfile.c (wget_hash_fast): Cast size_t to unsigned int.
       (wget_hash): Likewise.
     * libwget/ssl_wolfssl.c (ShowX509): Use XFREE without trailing semicolon.
       (wget_ssl_open): Use 64bit to 32bit casts to pacify clang 11.

2020-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix findings from scan-build 11
     
     * libwget/dns.c (wget_dns_resolve): 'rc' was set but not used.
     * libwget/http.c (wget_http_get_response_cb): 'rc' was set but not used.
     * libwget/net.c (wget_tcp_connect): 'rc' was set but not used.
     * libwget/ssl_gnutls.c (send_ocsp_request): 'rc' was set but not used.

2020-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix findings from scan-build 11
     
     * examples/batch_loader.c (_normalize_location): 'rc' was set but not used.
     * examples/check_url_types.c (_normalize_location): 'rc' was set but not used.

2020-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix findings from scan-build 11
     
     * src/job.c (job_validate_file): 'rc' was set but not used.
     * src/options.c (parse_proxy): Fix return value.
     * src/wget.c (input_thread): 'rc' was set but not used.

2020-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix findings from scan-build 11
     
     * tests/libtest.c (_parse_hostname): Fix += into +.
       (_answer_to_connection): Limit scope of body_len.

2020-12-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c (wget_http_parse_response_header): Fix (harmless !?) UB

2020-12-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Add -Wno-implicit-int-float-conversion for clang >= 11

2020-12-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix type warnings on 32bit systems
     
     * libwget/http.c (wget_http_get_response_cb): Fix printf format from %lX to %zX.
     * libwget/ssl_openssl.c (wget_ssl_deinit): Fix sesslen to size_t.
     * src/stats_site.c (print_csv_entry): Use %lld and cast to long long.

2020-10-31 Tim Rühsen <tim.ruehsen@gmx.de>

     Test for bashisms in Debian Testing

2020-10-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix configure.ac bashisms
     
     Reported-by: Brian Inglis

2020-10-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Remove python as dependency
     
     /usr/bin/python don't exist here any more. 'python2' and 'python3' do
     exist.

2020-10-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2020-10-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix contrib/mingw

2020-10-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * .travis.yml: libunistring0 -> libunistring

2020-10-11 Tim Rühsen <tim.ruehsen@gmx.de>

     Use brew upgrade for Travis CI OSX

2020-10-11 Tim Rühsen <tim.ruehsen@gmx.de>

     Update Travis CI to bionic

2020-10-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * .travis.sh: Output tail -1000 of test logs

2020-10-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashmap.c (wget_hashmap_iterator_next): Fix segfault

2020-08-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Implement --download-attr=[strippath|usepath]
     
     * docs/wget2.md: Amend docs.
     * src/options.c: Add parse_download_attr(),
       amend option --download-attr.
     * src/wget.c (queue_url_from_remote): Strip path if
       DOWNLOAD_ATTR_STRIPPATH is set.
     * src/wget_options.h: Add enum download_attr_mode.
     * tests/test-download-attr.c: Test strippath and usepath.

2020-08-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Fix indentation, remove leading _ from variable

2020-06-06 Ander Juaristi <a@juaristi.eus>

     Update OCSP responses and certs
     
     tests/certs/ocsp/*: Fix the cert stack for the testing HTTPS+OCSP server.

2020-06-06 Ander Juaristi <a@juaristi.eus>

     libtest: send normal cert chain in OCSP stapling HTTPS server
     
      * tests/libtest.c (_ocsp_stap_cert_callback): rename variable
        'pcert' -> 'certs'.
        (_http_server_start): send normal cert chain in responses.

2020-05-23 Ander Juaristi <a@juaristi.eus>

     OpenSSL: Enable test-ocsp-stap
     
     This commit enables the test `test-ocsp-stap`
     
     It was previously skipped for OpenSSL since OCSP stapling was not
     yet implemented in OpenSSL.
     
     This commit also modifies these tests to pass the --no-ocsp-date flag to
     wget2.
     
      * tests/test-ocsp-stap.c (main): remove ifdef clause; pass
        --no-ocsp-date flag.

2020-05-09 Ander Juaristi <a@juaristi.eus>

     OpenSSL: Implement OCSP stapling
     
     * libwget/ssl_openssl.c (ocsp_resp_cb): new function: stapled OCSP
       response callback.
       (check_ocsp_response): do not check OCSP nonce here.
       (verify_ocsp): check OCSP nonce here.
       (openssl_init): set stapled OCSP callback function, ocsp_resp_cb.
       (openssl_open): send status_request extension in handshake.
     * tests/libtest.c (_http_server_start): Fix callback macro

2020-08-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Create /usr/bin/python before bootstrap

2020-08-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2020-07-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Fix MHD 0.97.1 ABI/API breakage

2020-07-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (init): Fix spelling

2020-06-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c: Fix crash introduced in fa3c71c85

2020-05-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/decompressor.c (zstd_decompress): Avoid calls to sink with 0 length
     
     Calls to sink() with length == 0 made -S output the header several times when
     Content-Encoding was zstd.

2020-05-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (wget_ssl_init): Add debug msgs regarding system cert store

2020-04-26 huangzsh7 <huangzsh7@gmail.com>

     Delete obsolete code comment
     
     * src/wget.c (test_modify_hsts): Delete obsolete code comment

2020-04-22 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove CR and LF from URLs
     
     * libwget/iri.c (iri_unescape_inline): Remove CR/LF from URL.
     * tests/test-base.c: Add CR+LF into URL.
     
     References
     https://gitlab.com/gnuwget/wget2/-/issues/522

2020-04-19 huangzsh7 <huangzsh7@gmail.com>

     Create test cases
     
     * tests/test-wget-1.c (main): Create test cases for --chunk-size with --progress

2020-04-19 huangzsh7 <huangzsh7@gmail.com>

     Add name in AUTHORS for CommitCheck

2020-04-19 huangzsh7 <huangzsh7@gmail.com>

     Fix segmentation faults when chunk-size and progress=bar are present
     
     * src/wget.c (http_send_request): Keep the received response header when use chunk-size and progress=bar

2020-04-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix warning when converting void * to function pointer
     
     * unit-tests/test-dl.c (test_fn_check): Add #pragma to suppress
       -pedantic when converting void * to function pointer.
     
     POSIX requires a conversion from 'void *' into a function pointer to work.
     But -pedantic throws 'ISO C forbids conversion of object pointer to function
     pointer type'.

2020-04-11 Andreas Schwab <schwab@suse.de>

     Fix strict aliasing violation
     
     * unit-tests/test-dl.c (test_fn_check): Avoid strict aliasing
     violation.

2020-04-11 Andreas Schwab <schwab@suse.de>

     Fix undefined behaviour in test_buffer_printf
     
     * unit-tests/test.c (test_buffer_printf): Cast argument to printf
     function to correct type.

2020-03-25 Ander Juaristi <a@juaristi.eus>

     test-ocsp-stap: Skip
     
     OCSP stapling is not yet supported in OpenSSL.
     
      * tests/test-ocsp-stap.c (main): skip this test in OpenSSL

2020-01-12 Ander Juaristi <a@juaristi.eus>

     OpenSSL: Update stats
     
      * libwget/ssl_openssl.c (openssl_revocation_check_fn): update stats
        (wget_ssl_open): update stats

2019-09-16 Ander Juaristi <a@juaristi.eus>

     OpenSSL: Add OCSP support
     
      * libwget/ssl_gnutls.c: replace _config with config
      * libwget/ssl_openssl.c (wget_ssl_set_config_int): new options
        WGET_SSL_OCSP_NONCE and WGET_SSL_OCSP_DATE.
        (openssl_revocation_check_fn): implement OCSP in the OpenSSL backend,
        and update stats
        (ssl_set_alpn_selected_protocol): update stats
        (verify_hpkp): update stats
        (wget_ssl_open): update stats

2019-10-19 Ander Juaristi <a@juaristi.eus>

     Include serverAuth extension in OCSP certificates
     
     Since the OCSP tests use the same certificate chain for both the OCSP server and
     the HTTPS server, the 'serverAuth' flags needs to be added, in addition to the OCSP flags.
     
     OpenSSL will refuse to run a TLS handshake for HTTPS if that flag is not present.
     
      * tests/certs/ocsp/demoCA/*, tests/certs/ocsp/*.pem: change testing certificates
      * tests/certs/ocsp/ocsp_resp_revoked.der,
        tests/certs/ocsp/ocsp_stapled_resp.der
        tests/certs/ocsp/ocsp_resp_ok.der: update OCSP responses to contain
        the new certificates
      * tests/certs/ocsp/interm.cnf: add the serverAuth extension
      * tests/certs/ocsp/root-template.txt: likewise

2019-09-16 Ander Juaristi <a@juaristi.eus>

     Adapt configure.ac to support multiple SSL/TLS backends
     
     This patch modifies `configure.ac` to support GnuTLS, OpenSSL and wolfSSL as the SSL/TLS backends.
     
     Either of these can be enabled at compile time the `configure` switch `--with-ssl`. Example:
     
         ./configure --with-ssl=openssl
     
     If `--with-ssl` is omitted, the default behavior will be to build with GnuTLS if available, and without
     TLS if not. TLS can be explicitly disabled with `--without-ssl`.
     
     Regardless of which specific backend has been selected, the TLS and OCSP tests will always be built with GnuTLS,
     as that is the only backend currently supported in the test suite.
     
     It renames the constant `HAVE_GNUTLS_OCSP_H` to a more generic `WITH_OCSP`, that captures
     the notion that OCSP has been enabled at compile-time, hiding the specific backend.
     
     Changed files
     
      * configure.ac: honor --with-ssl option, but keep on testing for GnuTLS
        for the test suite.
      * libwget/ssl_gnutls.c: replace HAVE_GNUTLS_OCSP_H with WITH_OCSP
      * libwget/ssl_openssl.c: likewise
      * tests/libtest.c: replace HAVE_GNUTLS_OCSP_H with WITH_OCSP.
        Check for WITH_GNUTLS_IN_TESTSUITE.

2020-03-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Remove undefining FILE_SYSTEM_PREFIX_LEN

2020-03-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/dns_cache.c (wget_dns_cache_add): Fix bitwise to logical OR (cppcheck)

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h (wget_hsts_host_match_fn): Fix argument names (cppcheck)

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Work around redundant define in gnulib

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c (struct _stats_data_t): Remove unused struct

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/metalink.c (add_mirror): Code cleanup

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/metalink.c (metalink_parse): Check return value of wget_strmemcpy_a

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/html_url.c (html_get_url): Check return value of wget_strmemcpy_a

2020-03-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c (wget_tcp_set_bind_address): Simplify code

2020-03-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (options): Fix indentation and alignment

2020-03-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix indentation for some tests
     
     * tests/test-parse-css.c: Fix indentation.
     * tests/test-parse-html-css.c: Likewise.
     * tests/test-parse-rss.c: Likewise.

2020-03-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Add tests for --download-attr
     
     * tests/Makefile.am: Add tests/test-download-attr.c.
     * tests/test-download-attr.c: New file.

2020-03-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new option --download-attr
     
     * src/options.c (options): Add new option --download-attr.
     * src/wget.c (html_parse): Check for config.download_attr.
     * src/wget_options.h (struct config): Add new member download_attr.

2020-03-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Implement HTML download attribute
     
     * bootstrap.conf: Add gnulib module 'filename'.
     * src/blacklist.c (get_local_filename_real): Remove const from return type.
       (get_local_filename): Likewise.
     * src/wget.c: Include "filename.h".
       (queue_url_from_remote): Add param 'download_name'.
       (queue_url_from_remote): Change local filename to that given by 'download' tag.
       (html_parse): Create C string from 'download' value.
     * src/wget_blacklist.h (blacklist_entry): Remove const from local_filename.

2020-02-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Parse HTML download attribute
     
     * examples/print_html_urls.c: Print download attribute.
     * include/wget/wget.h (wget_html_parsed_url): Add download member.
     * libwget/html_url.c (html_get_url): Parse download attribute.

2020-03-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_send_request): Fix unused variable without WITH_LIBNGHTTP2

2020-02-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Implement data upload for HTTP/2

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/printf.c (wget_vsnprintf): Fix size in call to wget_buffer_init

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/xml.c (parseXML): Remove use of VLA

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c (wget_ssl_open): Safer code with wget_strmemcpy_a

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/printf.c (wget_printf): Optimize code

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c (wget_tcp_set_bind_address): Safer code with wget_strmemcpy_a

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/metalink.c (add_mirror): Safer code with wget_strmemcpy_a

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (parse_proxies): Safer code with wget_strmemcpy

2020-02-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/html_url.c (html_get_url): Simplify code with wget_strmemcpy_a

2020-02-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/valgrind-suppressions: Add GnuTLS suppression

2020-02-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (sitemap_parse_text): Simplify code by using wget_strmemcpy_a

2020-02-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (struct optionw): Use fixed length for long_name
     
     This reduces reallocations in the executable, reducing size by ~4k (stripped).

2020-02-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new function wget_strmemcpy_a
     
     * include/wget/wget.h: Add prototype of wget_strmemcpy_a.
     * src/mem.c: Implement wget_strmemcpy_a.
     * libwget/http_parse.c (wget_http_parse_header_line): Use wget_strmemcpy_a.
     * src/utils.c (mkdir_path): Likewise.

2020-02-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Let wget_strmemcpy return the number of copied bytes
     
     * include/wget/wget.h: Set return type of wget_strmemcpy to size_t.
     * libwget/mem.c (wget_strmemcpy): Return length of destination string.
     * unit-tests/test.c: Amend tests of wget_strmemcpy.

2020-02-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml (Scan-Build/Debian): Do not use security checker
     
     The security checker complains about not using the C11 _s functions.
     We don't want to use them, see also
     http://www.open-std.org/jtc1/sc22/wg14/www/docs/n1969.htm

2019-12-09 Suhas K S <suhasks123@gmail.com>

     Add option --bind-interface
     
     * libwget/net.h (wget_tcp_st): New variable
       const char *bind_interface.
     * libwget/net.c: Add function wget_tcp_bind_interface().
       (set_socket_options): Add parameter wget_tcp *tcp and
       implement binding of tcp to bind_interface.
     * libwget/init.c (wget_global_init): Call wget_tcp_bind_interface().
     * include/wget/wget.h: Add wget_tcp_bind_interface() and
       WGET_BIND_INTERFACE.
     * src/options.c: Add --bind-interface handling.
       (init): Call wget_tcp_bind_interface().
     * src/wget2_options.h (config): Add const char *bind_interface.
     * docs/wget2.md: Add documentation for --bind-interface.
     
     This finishes task #430

2020-02-21 Tim Rühsen <tim.ruehsen@gmx.de>

     tests/valgrind-suppressions: Add GnuTLS suppression

2020-02-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Amend docs regarding -q -O- [skip ci]

2020-02-16 Tim Rühsen <tim.ruehsen@gmx.de>

     New configure switch --disable-manylibs
     
     * NEWS: Add --disable-manylibs
     * configure.ac: Implement --disable-manylibs
     * libwget/Makefile.am: Likewise
     
     This switches off building small libraries from libwget functionality groups.

2019-08-22 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_decompress
     
     * libwget/Makefile.am: Add libwget_decompress.la
     * libwget/test_linking_compress.c: New file

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_netrc
     
     * libwget/Makefile.am: Add libwget_netrc.la
     * libwget/test_linking_netrc.c: New file

2019-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_metalink
     
     * libwget/Makefile.am: Add libwget_metalink.la
     * libwget/test_linking_metalink.c: New file

2019-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_xml
     
     * libwget/Makefile.am: Add libwget_xml.la
     * libwget/test_linking_xml.c: New file

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_http_parse
     
     * libwget/Makefile.am: Add libwget_http_parse.la
     * libwget/test_linking_htp_parse.c: New file

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_tls_session
     
     * libwget/Makefile.am: Add libwget_tls_session.la
     * libwget/test_linking_tls_session.c: New file

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_ocsp
     
     * libwget/Makefile.am: Add libwget_ocsp.la
     * libwget/test_linking_ocsp.c: New file

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_hsts
     
     * libwget/Makefile.am: Add libwget_hsts.la
     * libwget/test_linking_hsts.c: New file

2019-06-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_robots
     
     * libwget/Makefile.am: Add libwget_robots.la

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_dns
     
     * libwget/Makefile.am: Add libwget_dns.la
     * libwget/test_linking_dns.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_dnscache
     
     * libwget/Makefile.am: Add libwget_dnscache.la
     * libwget/test_linking_dnscache.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_logger
     
     * libwget/Makefile.am: Add libwget_logger.la
     * libwget/test_linking_logger.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_hpkp_db
     
     * libwget/Makefile.am: Add libwget_hpkp_db.la
     * libwget/test_linking_hpkp_db.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_hashfile
     
     * libwget/Makefile.am: Add libwget_hashfile.la
     * libwget/test_linking_hashfile.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_io
     
     * libwget/Makefile.am: Add libwget_io.la
     * libwget/test_linking_io.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_progress
     
     * libwget/Makefile.am: Add libwget_progress.la
     * libwget/test_linking_progress.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_thread
     
     * libwget/Makefile.am: Add libwget_thread.la
     * libwget/test_linking_thread.c: New file

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_css
     
     * libwget/Makefile.am: Add libwget_css.la
     * libwget/test_linking_css.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_iri
     
     * libwget/Makefile.am: Add libwget_iri.la
     * libwget/test_linking_iri.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_encoding
     
     * libwget/Makefile.am: Add libwget_encoding.la
     * libwget/test_linking_encoding.c: New file

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_common
     
     * libwget/Makefile.am: Add libwget_common.la
     * libwget/test_linking_common.c: New file

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_ip
     
     * libwget/Makefile.am: Add libwget_ip.la

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Generate library libwget_alloc
     
     * libwget/Makefile.am: Add libwget_alloc.la

2019-05-16 Tim Rühsen <tim.ruehsen@gmx.de>

     Patch libtool to add -no-whole-archive
     
     * cfg.mk: Exclude contrib/libtool.patch from 'make syntax-check'
     * configure.ac: Patch libtool
     * contrib/libtool.patch: New file
     * lib/Makefile.am: Unset $LIBS
     * libwget/Makefile.am: Use -no-whole-archive
     
     This patch keeps the libwget libraries short by not adding
     *everything* from lib/libgnu.a.

2020-02-12 Rohan Fletcher <rohfle@gmail.com>

     Skip HTTP/2 testing for test-interrupt-response
     
     * tests/test-interrupt-response.c: Set WGET_TEST_SKIP_H2

2020-02-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * README.md: Fix badge for Build Status [skip ci]

2020-02-11 Tim Rühsen <tim.ruehsen@gmx.de>

     Build own badges for coverage and fuzz-coverage
     
     * contrib/make-coverage-badge: Add script to create badges
     * .gitlab-ci.yml: Create coverage and fuzz-covrage badges
     * README.md: Display badges

2020-02-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/*_fuzer.in/*: Update OSS-Fuzz corpora from upstream

2020-02-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/Makefile.am: Remove -all-static from AM_LDFLAGS

2020-02-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/README.md: Update docs

2020-02-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add 'linux' to 'tags:'

2020-02-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Make more use of 'restrict' keyword

2020-02-04 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (safe_ctime): Suppress -Wformat-y2k around strftime %c

2020-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (http_receive_response): Set mtime to last_modified-1 on partial download

2020-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-interrupt-response.c: Fix for wget2, add one more test

2020-01-29 Rohan Fletcher <rohfle@gmail.com>

     Added test simulations of aborts while sending response body
     
     * tests/Makefile.am: add tests/test-interrupt-response test
     * tests/libtest.c (_callback_interruptable, _answer_to_connection):
       add interruptable response callback, enable in wget_test_url_t
       settings
     * tests/libtest.h: added interrupt_response_mode and
       interrupt_response_after_nbytes to wget_test_url_t
     * tests/test-interrupt-response.c: add test for interruptable
       responses and interrupt of responses while timestamping active

2020-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/gpg/pubring.kbx: Update

2020-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test): Reduce timeout from 10s to 3s

2020-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test): Amend error output to be more informative / prominent

2020-01-31 Tim Rühsen <tim.ruehsen@gmx.de>

     Amend retry strategy for job failures
     
     This introduces retries and and pauses for JOBs.
     Formerly, we only had a host failure strategy.
     
     * src/wget_job.h (struct JOB): Add retry_ts and failures
     * src/host.c (_search_queue_for_free_job): Check for pause after failure
     * src/wget.c (downloader_thread): Rearrange code for job retry strategy

2020-01-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Add Rohan Fletcher [skip ci]

2020-01-27 Suhas K S <suhasks123@gmail.com>

     Add --background support for Windows
     
     * src/wget.c: Add function make_section_name(),
       fake_fork_child(), fake_fork(), fork_to_background().
       Add struct fake_fork_info.
     * docs/wget2.md: Remove [Not Supported on Windows yet]
       from --background.
     
     Closes issue #457
     
     Copyright-paperwork-exempt: Yes

2020-01-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Use tag 'linux' instead 'docker'

2020-01-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Update gnulib to fix FreeBSD CI runner
     
     * gnulib: Update
     * .gitlab-ci.yml: Remove --enable-threads=isoc from ./configure

2020-01-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update to fix use-after-free in glob()
     
     This fixes OSS-Fuzz issue 20176.

2020-01-10 Darshit Shah <darnir@gnu.org>

     * Update copyright year to 2020

2020-01-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.-yml: Add --enable-threads=isoc to FreeBSD configure run

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Do not use -Werror for ./configure run

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Update Makefile.am for latest gnulib
     
     * examples/Makefile.am: Amend LDADD assignment
     * fuzz/Makefile.am: Likewise
     * libwget/Makefile.am: Likewise
     * src/Makefile.am: Likewise
     * tests/Makefile.am: Likewise
     * unit-tests/Makefile.am: Likwise

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix clang warning '-Wunreachable-code' in tests/
     
     * tests/test--https-enforce-hard3.c: Ignore warning via #pragma
     * tests/test--https-enforce-soft2.c: Likewise

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Suppress clang warning '-Watomic-implicit-seq-cst'

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/css_tokenizer.lex: Suppress clang warning '-Wextra-semi-stmt'

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: CFLAGS_DEFAULT: -O1 -g -ggdb3
     
     The sanitizer does not work with -O0, changed to -O1.

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Remove manual copying of gnulib directory

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2020-01-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Move sanitizer CI runner to Debian unstable

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Enable more sanitizer options for UBSAN and ASAN

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/bitmap.c: Fix clang sanitizer's false positive (buffer overflow)

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/gpgme.c: Fix implicit conversion

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Fix implicit conversion

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Fix implicit conversion -1 to size_t

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c: Fix implicit conversions -1 to size_t

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer_printf: Fix implicit conversionsi (use unsigned flag values)

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer_printf: Fix implicit conversions

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_get_response_cb): Fix implicit conversion -1 to size_t

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (parse_numbytes): Fix 8.35133e+19 outside long long range

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/base64.c (wget_base64_decode): Fix implicit conversion 218 to char

2020-01-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (wget_iri_parse_base): Fix implicit conversion -1 to size_t

2019-12-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (parse_numbytes): Fix implicit conversion to double

2019-12-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c (test_mem): Fix buffer overflow in test

2019-12-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/commit-check: Don't say 'not found' if found [skip ci]

2019-12-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Fix old types in comments [skip ci]

2019-12-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-cut-get-vars.c: Add three more test variations

2019-12-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix --cut-file-get-vars creating dirs on single file download
     
     * tests/test-cut-get-vars.c: Amend to reproduce issue #490.
     * src/blacklist.c (get_local_filename_real): Generate basename
       instead of filename, without query.
     * include/wget/wget.h: Add flag WGET_IRI_WITH_QUERY.
       Add param 'flags' to wget_iri_get_basename.
     * libwget/iri.c: Add param 'flags' to wget_iri_get_basename.
       Implement flag WGET_IRI_WITH_QUERY.
     * fuzz/libwget_iri_fuzzer.c (test): Use WGET_IRI_WITH_QUERY.
     
     Closes #490

2019-12-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/Makefile.am: Add test-cut-get-vars

2019-12-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_iri_get_filename -> wget_iri_get_basename
     
     * fuzz/libwget_iri_fuzzer.c: Likewise.
     * include/wget/wget.h: Likewise.
     * libwget/iri.c: Likewise.
     * src/blacklist.c: Likewise.

2019-12-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix OpenSSL for Win32
     
     * libwget/ssl_openssl.c (wget_ssl_open): Use FD_TO_SOCKET to
       convert POSIX fd to WIN32 socket.
       (ssl_transfer): Use SOCKET_TO_FD to convert WIN32 socket to POSIX fd.
     
     Reported-by: Gisle Vanem

2019-12-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Code cleanup
     
     * src/plugin.c (plugin_db_forward_downloaded_file):
       Change size from uint64_t to int64_t.
     * src/wget_plugin.h (plugin_db_forward_downloaded_file):
       Likewise.
     * src/wget.c (process_response): Likewise.
       Remove n_recurse_iris.

2019-12-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Add two new tests for -c
     
     * tests/test-wget-1.c: Test -c with existing empty file.
       Test -c with existing complete file.

2019-12-03 TheAlakazam <piyushjaipuriyar@gmail.com>

     Fix -c with existing zero-length file
     
     * src/wget.c (prepare_file): Replace `> 0` by `>= 0`.
       (wget_http_request): Likewise.
     
     Copyright-paperwork-exempt: Yes

2019-12-01 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove usage of strerror_r due to diverting GNU/POSIX behavior
     
     * libwget/http_highlevel.c: Likewise
     * libwget/net.c: Likewise
     * src/wget.c: Likewise

2019-11-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update
     
     Fixes #492 (library -lnsl-lintl: not found)

2019-11-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Replace strerror() by strerror_r() in multi-threaded code
     
     * libwget/http_highlevel.c: Likewise
     * libwget/net.c: Likewise
     * src/wget.c: Likewise

2019-11-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix for 'Error on unknown value for --with-ssl'

2019-11-15 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix for LibreSSL
     
     * libwget/ssl_openssl.c: Some small fixes for LibreSSL
     
     For LibreSSL you need to './configure --with-ssl=openssl'.

2019-11-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Error on unknown value for --with-ssl

2019-11-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * NEWS: Update

2019-11-05 Darshit Shah <darnir@gnu.org>

     Support terminal hyperlinks in output
     
     Some terminal emulators now allow printing hyperlinks through escape
     sequences. See
     https://gist.github.com/egmontkob/eb114294efbcd5adb1944c9f3cb5feda for
     more information.
     
     Hyperlink support cannot be gauged accurately. And while most terminals
     just ignore the extra escape sequences, older versions of vte actually
     print the URI along with some garbage. So, in this patch, the hyperlink
     support is disabled by default and used only if the user explicitly
     requests it. Once there is a way to query for feature support in
     terminals, this can be intelligently enabled automatically.
     
     * bootstrap.conf: Add new module xgethostname
     * src/wget_options.h: Add a new option hyperlink and a global variable
       hostname
     * src/options.c: Add a new command line option --hyperlink. This is the
       same option name as `ls` from coreutils for consistency across
       programs
       (init): If the user requests hyperlink support, get the hostname and
       store it. This is to prevent having to get the hostname for each
       downloaded file
     * src/wget.c (prepare_file): Print the filename with a hyperlink if the
       user requests it.
     * docs/wget2.md: Add documentation entry for hyperlinks

2019-10-28 Archit Pandey <archpndy@gmail.com>

     Added --convert-file-only handling
     
     * src/options.c: Add --convert-file-only handling
     * src/wget_options.h (config): Add bool convert_file_only
     * src/wget.c (html_parse): conversions initialized when
     convert_file_only is set
     (main): Call convert_links when config.convert_file_only
     (convert_links): move conversion logic to convert_link_whole and
     convert_link_file_only
     New function convert_link_whole: convert whole URL
     New function convert_link_file_only: convert filename part of URLs
     * tests/test-convert-file-only.c: testcase for --convert-file-only
     with -E
     * tests/Makefile.am: add test-convert-file-only object
     * docs/wget2.md: Removed [unimplemented-option] from
     --convert-file-only

2019-11-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix

2019-11-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test): Fix output, make use of wget_read_file()

2019-11-02 Archit Pandey <archpndy@gmail.com>

     Add --ignore-length handling
     
     * include/wget/wget.h (wget_http_request): Add bool
     response_ignorelength
     (wget_http_response): Add bool length_inconsistent
     * src/options.c: Add --ignore-length handling
     * src/wget_options.h (config): Add bool ignore_length
     (exit_status_e): Add WGET_EXIT_INCONSISTENT_LENGTH
     * libwget/http.c (wget_http_response_cb): Set length_inconsistent
     when mismatch with Content-Length
     * src/wget.c (wget_send_request): Set ignore-length in request
     * tests/test-ignore-length.c: test --ignore-length
     * tests/Makefile.am: add test-ignore-length
     * docs/wget2.md: Removed [unimplemented-option] from
     --ignore-length

2019-10-20 Darshit Shah <darnir@gnu.org>

     src/libwget.doxy.in: Update doxygen file

2019-10-20 Darshit Shah <darnir@gnu.org>

     Explicitly set the FILE_PATTERNS for doxygen
     
     * docs/libwget.doxy.in: Set FILE_PATTERNS to workaround bug in doxygen
       1.8.16
     
     Fix-by: Tim Ruehsen <rockdaboot@gmail.com>

2019-10-03 Darshit Shah <darnir@gnu.org>

     Add license text to files

2019-09-13 Darshit Shah <darnir@gnu.org>

     Fix license of all tests
     
     All the tests in tests/ are part of Wget2 the binary, not libwget. Fix
     the license and copyright information accordingly.
     
     * tests/libtest.c: libwget -> Wget. LGPLv3+ -> GPLv3+
     * tests/test--accept.c: Same
     * tests/test--filter-mime-type.c: Same
     * tests/test--follow-tags.c: Same
     * tests/test--https-enforce-hard1.c: Same
     * tests/test--https-enforce-hard2.c: Same
     * tests/test--https-enforce-hard3.c: Same
     * tests/test--https-enforce-soft1.c: Same
     * tests/test--https-enforce-soft2.c: Same
     * tests/test--https-enforce-soft3.c: Same
     * tests/test--page-requisites.c: Same
     * tests/test--post-file.c: Same
     * tests/test--save-content-on.c: Same
     * tests/test--spider-r.c: Same
     * tests/test-E-k.c: Same
     * tests/test-auth-basic.c: Same
     * tests/test-auth-digest.c: Same
     * tests/test-bad-chunk.c: Same
     * tests/test-base.c: Same
     * tests/test-c-r.c: Same
     * tests/test-chunked.c: Same
     * tests/test-compression.c: Same
     * tests/test-cut-dirs.c: Same
     * tests/test-cut-get-vars.c: Same
     * tests/test-directory-clash.c: Same
     * tests/test-ftp.c: Same
     * tests/test-ftps.c: Same
     * tests/test-gpg-bad.c: Same
     * tests/test-gpg-invalid.c: Same
     * tests/test-gpg-missing.c: Same
     * tests/test-gpg-save-failed.c: Same
     * tests/test-gpg-styles.c: Same
     * tests/test-gpg-valid.c: Same
     * tests/test-gpg-verify-no-file.c: Same
     * tests/test-gzip.c: Same
     * tests/test-i-http.c: Same
     * tests/test-i-https.c: Same
     * tests/test-idn-cmd.c: Same
     * tests/test-idn-meta.c: Same
     * tests/test-idn-robots.c: Same
     * tests/test-include-and-exclude-directories.c: Same
     * tests/test-iri-disabled.c: Same
     * tests/test-iri-forced-remote.c: Same
     * tests/test-iri-list.c: Same
     * tests/test-iri-percent.c: Same
     * tests/test-iri-subdir.c: Same
     * tests/test-iri.c: Same
     * tests/test-k.c: Same
     * tests/test-limit-rate-http2.c: Same
     * tests/test-limit-rate.c: Same
     * tests/test-meta-robots.c: Same
     * tests/test-metalink.c: Same
     * tests/test-np.c: Same
     * tests/test-ocsp-server.c: Same
     * tests/test-ocsp-stap.c: Same
     * tests/test-p-nc.c: Same
     * tests/test-parse-css.c: Same
     * tests/test-parse-html-css.c: Same
     * tests/test-parse-rss.c: Same
     * tests/test-plugin-dummy.c: Same
     * tests/test-plugin-failure.c: Same
     * tests/test-plugin-interception.c: Same
     * tests/test-plugin-nonexistance.c: Same
     * tests/test-plugin.c: Same
     * tests/test-post-handhshake-auth.c: Same
     * tests/test-redirection.c: Same
     * tests/test-restrict-ascii.c: Same
     * tests/test-robots.c: Same
     * tests/test-stats-dns.c: Same
     * tests/test-stats-ocsp.c: Same
     * tests/test-stats-server.c: Same
     * tests/test-stats-site.c: Same
     * tests/test-stats-tls.c: Same
     * tests/test-timestamping.c: Same
     * tests/test-unlink.c: Same
     * tests/test-wget-1.c: Same

2019-09-13 Darshit Shah <darnir@gnu.org>

     * README: Symlink to README.md

2019-09-13 Darshit Shah <darnir@gnu.org>

     * README.md: Add license information

2019-10-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h (wget_bar_slot_begin): Set 'filename' not NONNULL

2019-10-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Switch off Content-Length sanity checks in MHD

2019-10-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test_start_server): Print MHD info

2019-10-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_http_server_start): Fix checks for MHD options

2019-10-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_send_request): Fix hard-coded GET for HTTP/2

2019-10-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Fix CI failure

2019-10-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_http_server_start): Make use of MHD_OPTION_SERVER_INSANITY

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Add wget_test_set_executable() to test suite
     
     * tests/libtest.h: Add declaration of wget_test_set_executable()
     * tests/libtest.c: Add definition of wget_test_set_executable(),
       add global variable 'global_executable',
       (wget_test): Use 'global_executable' to initialize 'executable',
       (wget_test): Use 'executable' if set

2019-10-27 Archit Pandey <archpndy@gmail.com>

     Added options --method, --body-data, --body-file
     
     * src/wget_options.h (config): Added method, body_data, body_file
     * src/options.c (options): Added --method, --body-data, --body-file
     handling
     * src/wget_job.h (JOB): New variable bool redirect_get
     * src/wget.c (http_create_request): Added support for user
     provided HTTP method and request body
     (process_response_header): Set redirect_get to TRUE for 30x
     response codes
     * tests/test-redirection.c: Added test for redirection with
     --method=POST
     * docs/wget2.md: Removed [unimplemented-option] for --method,
     --body-data, --body-file

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Add method check for test suite
     
     * tests/libtest.h: Add expected_method to wget_test_url_t
     * tests/libtest.c (_answer_to_connection): Check method against expected_method

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Free query.params

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix typo: test-post-handhshake-auth -> test-post-handshake-auth
     
     * tests/Makefile.am: Fix typo in handhshake -> handshake
     * tests/test-post-handhshake-auth.c: Rename to tests/test-post-handshake-auth.c

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): More code cleanup

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Simplify URL expansion

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Code cleanup

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-unlink.c (main): Remove double entry from urls

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Set given status code for response

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-metalink.c: Fix test for HTTP/2

2019-10-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-E-k.c: Fix for HTTP/2 test

2019-10-26 Tim Rühsen <tim.ruehsen@gmx.de>

     SKIP tests failing with MHD 0.9.67
     
     * tests/test--https-enforce-hard3.c: Likewise
     * tests/test--https-enforce-soft2.c: Likewise

2019-10-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c: Fix loading CA certs when 'system' is not supported

2019-10-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix cookie file header to be recognized by 'file'
     
     * libwget/cookie.c: Use uppercase 'Cookie' and 'File'
     * tests/test-cookies.c: Likewise

2019-10-26 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new test file test-E-k.c
     
     * tests/Makefile.am: Add test-E-k.c to tests
     * tests/test-E-k.c: New file

2019-10-26 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix conversion (-k) in combination with -E
     
     * src/wget.c (prepare_file): Adjust filename in blacklist if changed,
       (conversions): Change type to wget_stringmap,
       (convert_links): Use stringmap instead of vector,
       (hash_conversion): New function to hash conversion key,
       (compare_conversion): New function to compare conversion entries,
       (remember_for_conversion): Use stringmap instead of vector

2019-10-26 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new function blacklist_set_filename()
     
     * src/blacklist.c: Implement blacklist_set_filename()
     * src/wget_blacklist.h: Add declaration of blacklist_set_filename()

2019-10-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix type of 2nd param of wget_stringmap_iterator_next() to void **
     
     * include/wget/wget.h: Likewise
     * unit-tests/test.c: Likewise

2019-10-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Make metalink->iri 'const'
     
     * include/wget/wget.h: Make metalink->iri 'const'
     * libwget/metalink.c (add_mirror): Code cleanup
     * src/wget.c (establish_connection): Skip HTTP mirrors if HTTPS requested,
       (queue_url_from_local): Lock mutex a bit later

2019-10-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Move applying HSTS to queue_url*() functions
     
     * src/wget.c: Add new function test_modify_hsts(),
       (queue_url_from_local): Call test_modify_hsts(),
       (queue_url_from_remote): Call test_modify_hsts(),
       (try_connection): Remove code for applying HSTS

2019-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Use const wget_iri instances
     
     * src/wget_host.h (host_add, host_get): Add 'const' to param
     * src/host.c: Likewise
     * src/stats_site.c: Add 'const' to wget_iri types
     * src/wget.c: Likewise
     * src/wget_job.h (struct JOB): Add 'const' to 'iri'

2019-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Amend job_init() to take blacklist_entry instead of wget_iri
     
     * src/wget_job.h: Amend job_init() to take blacklist_entry instead of wget_iri
     * src/job.c: Likewise
     * src/host.c (host_add_robotstxt_job): Amend call to job_init()
     * src/wget.c (queue_url_from_local): Likewise,
       (queue_url_from_remote): Likewise

2019-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Deduplicate code for creating robots.txt jobs
     
     * src/wget.c (queue_url_from_local): Remove duplicated code,
       (queue_url_from_remote): Likewise,
       (set_file_metadata): Amend calling wget_iri_get_connection_part()
     * include/wget/wget.h (wget_iri_parse_base): Add 'const' to 'base' param,
       (wget_iri_get_connection_part): Add 'const' to 'iri' param,
       add second param 'buf'
     * fuzz/libwget_iri_fuzzer.c (test): Amend calling wget_iri_get_connection_part()
     * libwget/iri.c (wget_iri_get_connection_part): Add param 'buf',
       add 'const' to 'iri' param, amend docs,
       (wget_iri_relative_to_abs): Add 'const' to 'base' param,
       amend calling wget_iri_get_connection_part(),
       (wget_iri_parse_base): Add 'const' to 'iri' param
     * src/host.c (host_add_robotstxt_job): Add code removed in wget.c
     * src/wget_host.h: Don't include wget_blacklist.h,
       amend signature of host_add_robotstxt_job()
     * src/wget_job.h (struct JOB): Add 'const' to 'blacklist_entry'

2019-10-16 Tim Rühsen <tim.ruehsen@gmx.de>

     Blacklist changes
     
     * src/wget_main.h: Remove decalration of get_local_filename()
     * src/wget_job.h (struct JOB): Remove local_filename, add blacklist_entry
     * src/wget_host.h: Amend declaration of host_add_robotstxt_job()
     * src/wget_blacklist.h (struct blacklist_entry): Add const to iri,
       add const to param of blacklist_add(),
       add declaration of blacklist_get()
     * src/job.c (job_free): Do not free job->local_filename
     * src/host.c (host_add_robotstxt_job): Param blacklist_entry instead of wget_iri
     * src/gpgme.c (determine_base_file): Fix calls to determine_base_file()
     * src/blacklist.c: Add new function blacklist_get(),
       (blacklist_add): Add const to param, call get_local_filename(),
       (blacklist_init): Amend destructors,
       Remove free_key(),
       Add free_value(),
       Add function get_local_filename(),
       Add function get_local_filename_real()
     * src/wget.c: Remove function get_local_filename(),
       Remove function get_local_filename_real(),
       Use blacklist_entry instead of local_filename

2019-10-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Rename add_url() -> queue_url_from_remote()

2019-10-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Rename add_url_to_queue() -> queue_url_from_local()

2019-10-15 Tim Rühsen <tim.ruehsen@gmx.de>

     Cleanup blacklist code
     
     * src/wget_blacklist.h: Add new structure 'blacklist_entry',
       change return type of blacklist_add() to 'blacklist_entry *'
     * src/blacklist.c: Store 'blacklist_entry' instead of 'wget_iri',
       remove mutexes
     * src/wget.c: Amend code in add_url_to_queue() and add_url()

2019-10-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget_blacklist.h: Remove unused declaration of in_blacklist()

2019-10-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Add pkg-config support for GPGME

2019-10-22 Archit Pandey <archpndy@gmail.com>

     Using --robots=off downloads robots.txt
     
     * src/wget.c (add_url_to_queue): remove config.robots check,
       (add_url): add config.robots check when disallowing URLs
     * tests/test-robots-off.c: New file to test --robots=off behavior
     * tests/Makefile.am: Added test-robots-off
     * tests/test-iri-percent.c: Add check for robots.txt
     * docs/wget2.md: Describe --robots=off behaviour

2019-10-21 Archit Pandey <archpndy@gmail.com>

     Moved WGET_E_GPG_* definitions out of libwget
     
     * libwget/error.c (wget_strerror): Remove WGET_E_GPG_* symbols
     * include/wget/wget.h (wget_error): Remove WGET_E_GPG_* symbol definitions
     * src/wget_gpgme.h: New enum wget_gpg_error to hold WGET_E_GPG_* symbol definitions
     * AUHOTRS: Add archpndy [at] gmail.com
     
     Copyright-paperwork-exempt: Yes

2019-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (prepare_file): Fix regression from commit 3c6f61a8

2019-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (prepare_file): Check '.htm' for -E/--adjust-extension

2019-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (prepare_file): Simplify code to append extension (-E)

2019-10-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add automated coverity scan
     
     This only works on a branch called 'coverity-scan'

2019-10-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test_check_file_system): Use memcmp() instead of strcmp()

2019-10-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Add WGET_GCC_UNUSED_RESULT to wget_hashmap_get and wget_stringmap_get

2019-10-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/stats_site.c (stats_site_add): Check return value of wget_stringmap_get()

2019-10-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (in_directory_pattern_list): Return false if fname is NULL

2019-10-09 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix NULL dereference in html_parse()
     
     * src/wget.c (html_parse): Add 'filename' to list of params
     
     Under certain conditions (--convert-links) existing files are
     scanned for URLs with 'job' being NULL. We still need a filename
     without getting it from job->local_filename, which would cause a
     NULL pointer dereference.

2019-10-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hsts.c (new_hsts): Check memory allocation

2019-10-08 Tim Rühsen <tim.ruehsen@gmx.de>

     libwget/http.c (wget_http_get_response_cb): Don't ignore response body on header callback failure

2019-10-08 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix directory clash with --no-clobber
     
     * src/wget.c: New functions is_file() and is_directory(),
       (prepare_file): Tune clash checks
     * tests/test-directory-clash.c: Add two more tests

2019-10-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c (wget_http_parse_connection): Allow list of tokens
     
     This change detects the keep-alive flag in headers like
       Connection: Upgrade, Keep-Alive

2019-10-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (html_parse): Limit to page requisites only for leaf pages

2019-10-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename --retry-on-http-status to --retry-on-http-error
     
     * docs/wget2.md: Likewise
     * libwget/http.c: Likewise
     * src/options.c: Likewise
     * src/wget.c: Likewise
     * src/wget_options.h: Likewise
     
     Needed for backward compatibility with Wget 1.x.

2019-09-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-compression.c: Replace malloc() by fixed size array

2019-10-03 Darshit Shah <darnir@gnu.org>

     * configure.ac: Update minimum required version

2019-10-03 Darshit Shah <darnir@gnu.org>

     Update Gnulib
     
     * gnulib: Update submodule
     * bootstrap.conf: Add module access

2019-09-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix bug in wget_dns_cache_add()
     
     * libwget/dns_cache.c (wget_dns_cache_add):
       wget_hashmap_get() gets a cache_entry, not a addrinfo

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove leading WG_ from exit_status_e enums
     
     * src/wget_options.h: Likewise
     * src/wget.c: Likewise
     * src/options.c: Likewise

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Introduce enum type gpg_verify_mode
     
     * src/wget_options.h: Add enum type gpg_verify_mode,
       remove leading WGET_ from GPG_VERIFY enums
     * src/options.c: Use new enum type
     * src/wget.c: Likewise

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget_options.h (struct config): Move members from char to bool

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget_options.h: Use bool for ocsp_date and ocsp_nonce

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Introduce enum type https_enforce_mode
     
     * src/options.h: Add enum type https_enforce_mode,
       remove leading WGET_ from HTTPS_ENFORCE enums
     * src/options.c: Use new enum type
     * src/wget.c: Likewise

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget_stats.h: Remove unused macros

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/stats_site.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/plugin.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/log.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/job.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/gpgme.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/bar.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/xml.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/utils.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c: Improve C99 compliancy

2019-09-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/io.c: Rely on gnulib poll module

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/sitemap_url.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/rss_url.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/random.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/logger.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/log.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/io.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/init.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_highlevel.c: Improve C99 compliancy

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Use int64_t for time_t to fix 32bit time_t limitations
     
     * include/wget/wget.h: Use int64_t instead of time_t
     * libwget/hpkp.c: Likewise
     * libwget/hsts.c: Likewise
     * libwget/http_parse.c: Likewise
     * libwget/ocsp.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/tls_session.c: Likewise
     * src/options.c: Likewise
     * src/stats_site.c: Likewise
     * src/wget.c: Likewise
     * tests/libtest.c: Likewise
     * tests/libtest.h: Likewise
     * tests/test-plugin-dummy.c: Likewise
     * unit-tests/test.c: Likewise

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/decompressor.c (lzip_decompress): Fix warning

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix http date functions to use int64_t instead of time_t
     
     * include/wget/wget.h: Change time_t -> int64_t for wget_http_print_date()
       and for wget_http_parse_full_date()
     * libwget/http_parse.c: Likewise

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (wget_test): Print expected+real content of diverting files

2019-09-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix time_t to int64_t in cookie code
     
     * libwget/cookie.c: Likewise
     * libwget/cookie.h: Likewise

2019-09-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test-dl.c: Add missing len param to plugin function call

2019-09-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add Valgrind/i386 runner

2019-09-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Add unit test test-decompress.c
     
     * unit-tests/Makefile.am: Add test-decompress.c
     * unit-tests/test-decompress.c: New file

2019-09-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/decompressor.c (wget_decompress_open): Fix xz decompression

2019-09-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Modify wget_decompress() 2nd arg to const
     
     * include/wget/wget.h: Likewise
     * libwget/decompressor.c: Likewise

2019-09-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/decompressor.c: Make use LZ_decompress_finish()

2019-09-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * README.md: Add OSS-Fuzz badge [skip ci]

2019-09-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Implement Accept-Encoding: lzip including decompressor
     
     * README.md: Mention lzip
     * configure.ac: Detect lzip
     * docs/wget2.md: Document 'lzip'
     * include/wget/wget.h: Add wget_content_encoding_lzip
     * libwget/decompressor.c: Implement lzip decompression
     * libwget/http_parse.c (wget_http_parse_content_encoding): Add "lzip"
     * src/options.c: Add code to support lzip
     * src/wget.c (http_create_request): Add lzip to Accept-Encoding: if available
     * tests/test-compression.c: Add test vector for lzip decompression

2019-09-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mk_authors: Simplify getting the latest git tag [skip ci]

2019-09-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mk_authors: Fix getting the latest git tag [skip ci]

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/html_url.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashmap.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashfile.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/dns_cache.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/dns.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/css_url.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/console.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer_printf.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/base64.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove use of !! in src/
     
     * src/host.c: Change return type of _search_host_for_free_job() to bool
     * src/options.c (selftest_options): Make use of bool
     * src/stats_site.c (stats_site_add): Use '!= 0' instead of !!
     * src/wget.c: (_get_local_filename): Change type of directories to bool
     * src/wget_options.h (struct config): Change type of recursive to bool

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/bar.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/atom_url.c: Improve C99 compliancy

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change type to bool for wget_tcp_set_ssl/wget_tcp_get_ssl
     
     * include/wget/wget.h: Likewise
     * libwget/net.c: Likewise

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Use '!= 0' instead of 'git commit --amend' in libwget/ssl_gnutls.c
     
     * include/wget/wget.h (wget_tls_stats_data): Change type of tfo and false_start to bool
     * libwget/ssl_gnutls.c: Use bool in _session_context,
       remove use of !!

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change return type of wget_tcp_get_tls_false_start() to bool
     
     * include/wget/wget.h: Likewise
     * libwget/net.c: Likewise

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change second param type of wget_tcp_set_tls_false_start() to bool
     
     * include/wget/wget.h: Likewise
     * libwget/net.c: Likewise
     * src/wget_options.h (struct config): Change type of tls_false_start to bool

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change return type of wget_tcp_get_tcp_fastopen() to bool
     
     * include/wget/wget.h: Likewise
     * libwget/net.c: Likewise

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change second param type of wget_tcp_set_tcp_fastopen() to bool
     
     * include/wget/wget.h: Likewise
     * libwget/net.c: Likewise
     * libwget/init.c (wget_global_init): Fix param type to wget_tcp_set_tcp_fastopen()
     * src/wget_options.h (struct config): Change type of tcp_fastopen to bool

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/logger.c: Use '!= 0' instead of !!

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/init.c: Use '!= 0' instead of !!

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Use '!= 0' instead of !!

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Use bool instead of char in HSTS code
     
     * include/wget/wget.h: Change param to bool in wget_hsts_db_add_fn(),
       (struct wget_http_response_st): Use bool for hsts_include_subdomains and keep_alive,
       change param to bool in wget_http_parse_strict_transport_security(),
       change param to bool in wget_http_parse_connection()
     * libwget/hsts.c: change param to bool in new_hsts(),
       change param to bool in wget_hsts_db_add()
     * libwget/http_parse.c: change param to bool in wget_http_parse_strict_transport_security(),
       change param to bool in wget_http_parse_connection()
     * tests/test-plugin-dummy.c: change param to bool in test_hsts_db_add()
     * unit-tests/test.c (test_hsts): Change type of include_subdomains to bool

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change return type of wget_str_needs_encoding() to bool
     
     * include/wget/wget.h: Likewise
     * libwget/encoding.c: Likewise

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/cookie_parse.c (cookie_normalize_cookie): Use '!= 0' instead of !!

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Use bool param for wget_cookie_set_keep_session_cookies()
     
     * include/wget/wget.h: Change second param of wget_cookie_set_keep_session_cookies() to bool
     * libwget/cookie.c: Likewise
     * libwget/init.c (struct _CONFIG): Use bool for cookies_enabled, keep_session_cookies

2019-09-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/base64.c (_isbase64): Use '!= 0' instead of !!

2019-09-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new cookie test
     
     * tests/Makefile.am: Add test-cookies
     * tests/test-cookies.c: New file

2019-09-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new wget_test() option WGET_TEST_CLEAN_DIRECTORY
     
     * tests/libtest.c: Implement WGET_TEST_CLEAN_DIRECTORY
     * tests/libtest.h: Add WGET_TEST_CLEAN_DIRECTORY

2019-09-16 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix for reproducible builds
     
     * .gitignore: Remove src/version-text.h
     * cfg.mk: Add rule to update copyright in src/options.c
     * configure.ac: Remove YEAR
     * src/Makefile.am: Remove version-text.h.in
     * src/options.c: Add version text
     * src/version-text.h.in: Deleted
     
     Reported-by: Bernhard M. Wiedemann

2019-09-14 Darshit Shah <darnir@gnu.org>

     * libwget/cookie_parse.c: Fix spelling issue

2019-09-13 Darshit Shah <darnir@gnu.org>

     Don't call libwget as Wget / Wget2.
     
     Functions in Libwget may be called from other client applications as
     well. They should not report that the job was done by Wget / Wget2, but
     instead they should state that it was doen by libwget.
     
     * libwget/bar.c(_bar_update): Remove reference to Wget
     * libwget/list.c: Same
     * libwget/cookie.c(cookie_db_save): Wget -> libwget
     * libwget/error.c(wget_strerror): Same
     * libwget/hpkp_db.c(hpkp_db_save): Same
     * libwget/hsts.c(hsts_db_save): Same
     * libwget/ocsp.c(ocsp_db_save_hosts): Same
     * libwget/printf.c: Same
     * libwget/ssl_gnutls.c(wget_ssl_open: Same
     * libwget/tls_session.c(tls_session_db_save): Same

2019-09-12 Ander Juaristi <a@juaristi.eus>

     OpenSSL: Release cert chain (more memleaks)
     
      * libwget/ssl_openssl.c (_openssl_revocation_check_fn): free
        cert chain in all error paths

2019-09-04 Ander Juaristi <a@juaristi.eus>

     OpenSSL: fix memory leaks

2019-09-11 Darshit Shah <darnir@gnu.org>

     Remove gettext support in tests/
     
     * tests/libtest.h: Remove gettext support entirely
     * tests/test-iri-subdir.c: Needs the string.h header
     * tests/test-limit-rate-http2.c: Same
     * tests/test-limit-rate.c: Same
     * tests/test-metalink.c: Same
     * tests/gpg-test-util.h: Same
     * tests/test-gpg-save-failed.c: Same
     * tests/test-include-and-exclude-directories.c: Same

2019-09-10 Darshit Shah <darnir@gnu.org>

     Use gnulib's update-copyright module
     
     * bootstrap.conf: Add update-copyright module
     * cfg.mk: Setup environment for update-copyright
     * contrib/update_copyright: Remove script no longer used
     * libwget/ssl_openssl: Fix copyright year
     * tests/test-post-handshare-auth.c: Fix copyright years
     * contrib/commit-check: Add copyright and license
     * contrib/mail.sh: Same
     * src/version-text.h.in: Same

2019-09-08 Darshit Shah <darnir@gnu.org>

     Update Copyright statements to be compatible with update-copyright module

2019-09-10 Darshit Shah <darnir@gnu.org>

     Update cfg.mk. Add comments for future
     
     * cfg.mk: Multiple changes.
       (sc_GPL_version): Don't exclude all files when only one has a parsing
       issue
       (sc_po_check): Tests should always output English. Their output is for
       developers, not users
       (sc_prohibit_magic_number_exit): tests/test-plugin.c has a parsing
       issue that has been reported to gnulib. Others should be checked.
       (sc_trailing_blank): Fixed the relevant files instead of ignoring them
       (sc_two_space_separator_in_usage): Doesn't seem to trigger on removal
       (sc_prohibit_empty_lines_at_EOF): Same
       (sc_prohibit_sprintf): Same
       (sc_prohibit_printf): Re-arrange within file
       (sc_prohibit_free): Same
       (sc_prohibit_alloc): Same
       (sc_gettext_printf): Same
     * docs/DoxygenLayout.xml: Remove trailing whitespaces
     * docs/libwget.doxy.in: Same
     * tests/libtest.c: Don't internationalize test suite strings
     * tests/test-*.c: Use EXIT_FAILURE and EXIT_SUCCESS instead of 1 and 0

2019-09-10 Darshit Shah <darnir@gnu.org>

     * cfg.mk: We don't cast arguments to free anywhere

2019-09-10 Tim Rühsen <tim.ruehsen@gmx.de>

     Revert "* cfg.mk: We don't need to exclude gnulib from syntax-check" [ci skip]
     
     This reverts commit 074983606b3536d0cf2677beb0ed523dd43145e3.
     
     Also added a comment in cfg.mk to explain why

2019-08-22 Ander Juaristi <a@juaristi.eus>

     * libwget/ssl_openssl.c: Implement ALPN

2019-09-07 Darshit Shah <darnir@gnu.org>

     * cfg.mk: We don't need to exclude gnulib from syntax-check

2019-09-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/init.c (wget_global_get_ptr): Fix return type for WGET_COOKIE_DB

2019-09-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/dns.c: Add constructor & destructor for global mutex

2019-09-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * examples/http_get.c: Use https:// instead of http://

2019-09-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_html_parsed_url.dir -> wget_html_parsed_url.tag
     
     * include/wget/wget.h: Rename wget_html_parsed_url.dir -> wget_html_parsed_url.tag
     * examples/print_html_urls.c: Likewise
     * libwget/html_url.c: Likewise
     * src/wget.c: Likewise

2019-09-01 Ander Juaristi <a@juaristi.eus>

     OpenSSL: Fix CRL checking
     
     Check CRLs properly on the OpenSSL backend. CRLs were previously bypassed
     because OpenSSL's internal certificate verification function was being overridden.
     
     We need to provide our own verification callback for HPKP and OCSP, but this callback is now
     introduced later in the verification chain, so that it does no longer override OpenSSL's checks.
     
     This commit also re-enables a CRL test on OpenSSL, which would previously only run on the GnuTLS backend.
     
     * libwget/ssl_openssl.c (openssl_init): Register verification callback, rather than revocation one.
       (_openssl_revocation_check_fn): Adhere to verification callback interface.
     * tests/test-i-https.c: Enable CRL test for OpenSSL (but keep it disabled for wolfSSL)
     
     Signed-off-by: Ander Juaristi <a@juaristi.eus>

2019-08-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Add script to generate list of authors by # of commits
     
     * .mailmap: Map authors when using different names/email addresses
     * contrib/mk_authors: Create list of authors sorted by # of commits
     * contrib/release: Mention contrib/mk_authors

2019-08-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Release 1.99.2 (beta)

2019-08-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Only use clang's Nullability feature with enabled manywarnings

2019-08-21 Darshit Shah <darnir@gnu.org>

     * bootstrap.conf: Add gnulib modules for non-portable function calls

2019-08-21 Darshit Shah <darnir@gnu.org>

     Remove portability warnings from configure
     
     * configure.ac: Don't warn when we use GNU Make extensions.
     We have already dug into this by disabling the relevant syntax-check
     rule as well. The recent commit adding support for gcov based code
     coverage adds more GNU make specific rules.

2019-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix hashing with Gcrypt backend

2019-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix hashing with Nettle backend

2019-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix hashing with OpenSSL backend

2019-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix hashing with GnuTLS backend
     
     * libwget/hashfile.c: Fix the GnuTLS functions

2019-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashfile.c (wget_hash_file_fd): Do not close fd on error

2019-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix hashing with WolfTLS backend
     
     * include/wget/wget.h: Change param for wget_hash_init(),
       change param and return type for wget_hash_deinit()
     * libwget/hashfile.c: Rewrite hashing functions for WITH_LIBWOLFCRYPT
     * unit-tests/test.c: Add tests for incremental hashing

2019-08-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix TLS/hashing detection

2019-08-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-i-https.c: CRL test only for GnuTLS

2019-08-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Update test suite certs and build script
     
     * tests/certs/revoked-template.txt: New file
     * tests/certs/ca-template.txt: Update
     * tests/certs/generate_certs.sh: Use revoked-template.txt
     * tests/certs/server-template.txt: Update
     * tests/certs/*.pem: Update, generated by generate_certs.sh

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Fix some assignment warnings

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Apply fixes due to rebasing

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashfile.c: Make use of WGET_E_UNSUPPORTED

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/error.c (wget_strerror): Add WGET_E_UNSUPPORTED

2019-08-22 Ander Juaristi <ajuaristi@gmx.es>

     Add more hash backends

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Do not translate debug messages

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (verify_hpkp): Add switch default

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Fix indentation

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (openssl_load_trust_files_from_directory): Cleanup

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add OpenSSL runner

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Fix WolfSSL CI build

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c (openssl_load_trust_file): Use buffer printf instead of VLA

2019-07-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_openssl.c: Rebase for new stats API

2019-06-17 Ander Juaristi <a@juaristi.eus>

     Rebase wolfssl branch
     
     * configure.ac: Pretty print 'SSL/TLS support'
     * libwget/Makefile.am: Cleanup logic

2019-06-15 Ander Juaristi <a@juaristi.eus>

     * configure.ac: Add SSL/TLS option wolfssl

2018-09-16 Ander Juaristi <a@juaristi.eus>

     SSL/TLS: Add OpenSSL support
     
     * configure.ac: Add --with-ssl=[no,openssl,gnutls], remove --without-gnutls
     * libwget/Makefile.am: Add ssl_openssl.c
     * libwget/ssl_openssl.c: New file
     * po/POTFILES.in: Add libwget/ssl_openssl.c

2019-08-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Add -Wno-used-but-marked-unused to GNULIB_WARN_FLAGS

2019-08-27 DalmeGNU <dalmemail@gmail.com>

     * benchmarks/sources/curl.bench.sh: Build curl with GnuTLS, in order to have SSL support

2019-08-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (_preload_dns_cache): Don't wait for stdin while testing

2019-08-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/spell-checker: Do not check tests/certs/README.md

2019-08-25 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/certs/README.md: Added README for certificate generation

2019-08-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Regenerating certificates for openssl compatibility
     
     * tests/certs/generate_certs.sh: Script for certificate generation
     * tests/certs/x509-ca-cert.pem: CA certificate
     * tests/certs/x509-ca-key.pem: CA key
     * tests/certs/x509-server-cert.pem: Server certificate
     * tests/certs/x509-server-key.pem: Server key
     * tests/certs/x509-server-crl.pem: CRL for the server certificate
     * tests/certs/ca-template.txt: Template for CA Certificate
     * tests/certs/server-template.txt: Template for Server Certificate

2019-08-23 DalmeGNU <dalmemail@gmail.com>

     Recursive mode now works with -N --no-if-modified-since
     
     * src/wget.c: Likewise
     * tests/test-timestamping.c: Added tests for -N -r (with If-Modified-Since) and amended the ones without If-Modified-Since
     * tests/test-include-and-exclude-directories.c: Amended tests that use -N --no-if-modified-since -r
     * tests/test--filter-mime-type.c: Amended tests that use -N --no-if-modified-since -r

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Update NEWS

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Fix typos

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/spell-checker: Abort on error (set -e)

2019-08-22 DalmeGNU <dalmemail@gmail.com>

     Consider files as 'application/octet-stream' if MIME is not present
     
     * src/wget.c: Likewise, following RFC 7231
     * tests/test--filter-mime-type.c: Added tests to ensure this behavior is present
     * docs/wget2.md: Added this new behavior to the docs

2019-08-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.h: Include netdb.h for struct addrinfo [skip ci]

2019-08-18 DalmeGNU <dalmemail@gmail.com>

     Implement --no-if-modified-since
     
     * src/options.c: Added new option --if-modified-since, and prevented certain combination of flags
     * src/wget.c: Added -N --no-if-modified-since implementation itself
     * src/wget_job.h: Added bool 'recursive_send_head' to JOB structure
     * src/wget_options.h: Added char 'if_modified_since' to config structure
     * tests/test--accept.c: Added tests that make use of -N --no-if-modified-since
     * tests/test--filter-mime-type.c: Added tests that make use of -N --no-if-modified-since
     * tests/test-include-and-exclude-directories.c: Added tests that make use of -N --no-if-modified-since
     * tests/test-timestamping.c: Added tests for -N --no-if-modified-since
     * docs/wget2.md: Unmarked --no-if-modified-since as "Not Implemented Yet"

2019-08-17 DalmeGNU <dalmemail@gmail.com>

     * src/options.c: Prevent certain combination of flags with -N (as in wget1.x)

2019-08-15 DalmeGNU <dalmemail@gmail.com>

     Move -N mode tests into a separate file
     
     * tests/test-wget-1.c: Removed -N (timestamping) tests
     * tests/test-timestamping.c: Added -N tests from tests/test-wget-1.c
     * tests/Makefile.am: Added tests/test-timestamping.c to Makefile

2019-08-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Use --disable-threads on FreeBSD instead MinGW CI runner

2019-08-20 DalmeGNU <dalmemail@gmail.com>

     * tests/libtest.c: Create directories if needed when creating WGET_TEST_EXISTING_FILES

2019-08-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/utils.c (mkdir_path): Do not write 'fname' param

2019-08-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/Makefile.am: Add -DMALLOC_RETURNS_NONNULL to AM_CFLAGS

2019-08-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: AC_SUBST BZ2_LIBS

2019-08-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/decompressor.c: Improve C99 compliance, check memory allocation

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_insert_ports): Fix for reject_https_connection

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix --https-enforce tests
     
     * tests/test--https-enforce-hard3.c: Add --default-http-port={{port}}
     * tests/test--https-enforce-soft1.c: Use WGET_TEST_HTTPS_REJECT_CONNECTIONS
     * tests/test--https-enforce-soft2.c: Use WGET_TEST_HTTP_REJECT_CONNECTIONS
     * tests/test--https-enforce-soft3.c: Remove space (cleanup only)

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test--https-enforce-hard2.c: Allow error code 4 and 5

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Add WGET_TEST_EXPECTED_ERROR_CODE2

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test--https-enforce-hard3.c: Make test behave stable

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test--https-enforce-hard2.c: Make test behave stable

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Add WGET_TEST_HTTP_REJECT_CONNECTIONS to test suite
     
     * tests/libtest.h: Add WGET_TEST_HTTP_REJECT_CONNECTIONS
     * tests/libtest.c: Implement WGET_TEST_HTTP_REJECT_CONNECTIONS

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (wget_iri_set_scheme): Fix amending https port

2019-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/Makefile.am: Fix 'make code-coverage-capture' for gcc 9

2019-08-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer.c (wget_buffer_deinit): Fix NONNULL issue

2019-08-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (sitemap_parse_xml_gz): Use stack memory for wget_buffer

2019-08-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/xml.c (wget_xml_parse_file): Use stack memory for wget_buffer

2019-08-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/css.c (wget_css_parse_file): Use stack memory for wget_buffer

2019-08-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer.c: Add examples to documentation

2019-08-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Cleanup + amend return vales of buffer functions
     
     * include/wget/wget.h: Add wget_buffer.error
     * libwget/buffer.c: Amend docs,
       change return type of wget_buffer_init(),
       amend wget_buffer_alloc(),
       set buf.error in _buffer_realloc()
     * libwget/printf.c: Check buf.error, return (size_t)-1
     * unit-tests/test.c: Amend tests appropriately

2019-08-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/buffer.c (_buffer_realloc): Make use of realloc() if possible

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix more docs [skip ci]

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix docs for wget_bitmap_init() [skip ci]

2019-08-14 DalmeGNU <dalmemail@gmail.com>

     Improvements on the progress bar
     
     * docs/wget2.md: There is no default progress value
     * src/options.c: If no progress type specifier is given return an error
     * src/wget.c: Set global file size and already downloaded amount when continuing a download

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix checking return value of wget_vector_find()
     
     * src/options.c: Likewise
     * src/wget.c: Likewise

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Fix clang build on FreeBSD

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/bitmap.c: Small cleanup

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * examples/Makefile.am: Add -DMALLOC_RETURNS_NONNULL to AM_CFLAGS and AM_CPPFLAGS

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Introduce WGET_E_IO
     
     * include/wget/wget.h: Introduce WGET_E_IO
     * libwget/error.c: Add WGET_E_IO to wget_strerror()
     * libwget/hashfile.c: Make use of WGET_E_IO
     * libwget/io.c: Likewise

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_match_no_proxy): Check value from wget_vector_get()

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename WGET_E_OPEN_FILE -> WGET_E_OPEN
     
     * include/wget/wget.h: Rename WGET_E_OPEN_FILE -> WGET_E_OPEN
     * libwget/io.c: Likewise
     * libwget/netrc.c: Likewise

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Cleanup vector functions and docs

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/test_linking.c: Don't give NULL to wget_plugin_get_name()

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c (wget_http_parse_response_header): Check memory allocation

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_highlevel.c (wget_http_get): Check vector creation

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_create_request): Check memory allocation

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hpkp_db.c (hpkp_db_load): Check memory allocations

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/vector.c: Check memory allocation

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Add NULLABLE to more functions

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/io.c: Fix return values, add memory check

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/job.c (job_validate_file): Fix check for wget_truncate() return

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * gnulib: Update

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (wget_iri_parse): Avoid casts to suppress warning

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (wget_iri_parse): Return NULL on unknown scheme

2019-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (wget_iri_parse): Set scheme to -1 if unknown

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/netrc.c (wget_netrc_db_load): Check memory allocation

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c (wget_http_parse_header_line): Check memory allocation

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (_parse_no_proxies): Check memory allocation

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/cookie_parse.c (cookie_normalize_cookie): Check memory allocation

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * examples/batch_loader.c: Check return value of wget_strmemdup()

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * examples/check_url_types.c: Check return value of wget_strmemdup()

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Nullable wget_memdup, wget_strdup, wget_strmemdup

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml (Debian/HTTP2): Allow failure set to true

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/Makefile.am: Add -DMALLOC_RETURNS_NONNULL to AM_CFLAGS and AM_CPPFLAGS

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test-dl.c (string_vector_check): Fix va_list leak

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/tls_session.c: Check memory allocations

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c: Check memory allocations

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/netrc.c: Check memory allocations

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ocsp.c: Check memory allocations

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hsts.c: Check memory allocations

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/bar.c: Check memory allocations

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/io.c: Check memory allocations

2019-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/encoding.c (wget_memiconv): Check memory allocations, return WGET_E_* codes

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c (wget_tcp_init): Check malloc return value

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     Introduce nullability support for clang's static analyzer
     
     * configure.ac: Add -Wno-nullability-extension -Wno-nullability-completeness to WARN_CFLAGS
     * include/wget/wget.h: Add CLANG_VERSION_AT_LEAST,
       fix attribute defines for clang,
       make use of attributes by using static inline functions for wget allocation,
       define NULLABLE for clang
     * libwget/xalloc.c: Rename wget allocation function pointers
     * src/options.c: Likewise
     * unit-tests/test.c: Likewise

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_highlevel.c (wget_http_get): Fix va_list leakage

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Use clang and enable valist checker with scan-build

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/test_linking.c: Fix clang warning (needless semicolon)

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/test_linking.c: Make use of return value of wget_strdup()

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/Makefile.am: Add -DBUILDING_LIBWGET to AM_CFLAGS

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Define WGET_GCC_RETURNS_NONNULL for clang as well

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (wget_ssl_open): Avoid 0 size VLA

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (http_send_request): Fix possible NULL ptr issue

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_parse_hostname): Silence clang's scan-build

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml (FreeBSD.x86_64): Do not retry after failure

2019-05-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Add convenience library for src/utils.c
     
     * src/Makefile.am: Add libtest-utils.la
     * tests/Makefile.am: Add libtest-utils.la to libtest_la_LIBADD

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (_add_authorize_header): Print error if wget_netrc_db_load() fails

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/netrc.c: Code cleanup

2019-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new error code WGET_E_OPEN_FILE

2019-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/metalink.c: Make code more C99 compliant

2019-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Split hpkp.c into hpkp_db.c, hpkp.c and hpkp.h
     
     * libwget/Makefile.am: Add hpkp.h and hpkp_db.c
     * libwget/hpkp.c: Move HPKP database code to hpkp_db.c
     * libwget/hpkp.h: New file
     * libwget/hpkp_db.c: New file

2019-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Split cookie.c into cookie_parse.c, cookie.c and cookie.h
     
     * libwget/Makefile.am: Add cookie.h and cookie_parse.c
     * libwget/cookie.c: Move cookie parsing code to cookie_parse.c
     * libwget/cookie.h: New file
     * libwget/cookie_parse.c: New file

2019-08-14 DalmeGNU <dalmemail@gmail.com>

     * src/options.c: Don't accept negative numbers as a valid byte amount

2019-08-13 DalmeGNU <dalmemail@gmail.com>

     Implement --start-pos option
     
     * src/wget.c: Added --start-pos implementation
     * src/options.c: Added --start-pos option and resolved flag combination with --continue
     * src/wget_options.h: Added start_pos to the config structure
     * docs/wget2.md: Removed "Not Implemented Yet" label from --start-pos documentation

2019-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c: Cast enums to avoid warnings with clang

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Change return type of wget_hpkp_get_n_pins() to int
     
     * include/wget/wget.h: Change return type of wget_hpkp_get_n_pins() to int
     * libwget/hpkp.c: Likewise
     * unit-tests/test.c: Adjust code, cleanup

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove global wget_iri_schemes[], add wget_iri_scheme enum
     
     * include/wget/wget.h: Remove global wget_iri_schemes[],
       add wget_iri_scheme enum
     * libwget/iri.c: Add struct iri_scheme,
       remove wget_iri_schemes and iri_ports,
       new function wget_iri_scheme_get_name(),
       fix code
     * examples/check_url_types.c: Use comparison instead of wget_strcasecmp
     * fuzz/libwget_iri_fuzzer.c: Use WGET_IRI_SCHEME_HTTPS instead of string
     * libwget/http.c: Use wget_iri_scheme_get_name()
     * libwget/http.h: Change scheme from string to wget_iri_scheme
     * libwget/http_parse.c: Fix wget_http_get_scheme()
     * src/blacklist.c: Fix hash_iri()
     * src/host.c: Fix _host_hash()
     * src/options.c: Use WGET_IRI_SCHEME_* instead of string
     * src/stats_server.c: Use wget_iri_scheme for scheme member
     * src/wget.c: Fix code
     * src/wget_host.h: Use wget_iri_scheme fro scheme member
     * unit-tests/test.c: Fix tests

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Use more bool in HPKP code
     
     * include/wget/wget.h: Use bool for HPKP functions where possible
     * libwget/hpkp.c: Use bool where possible
     * libwget/http_parse.c: Use bool for HPKP functions

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     libwget/tls_session.c: Improve C99 compliance and cleanup

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Use more bool in OCSP code
     
     * include/wget/wget.h (wget_ocsp_db_add_fingerprint_fn): bool for last param
     * libwget/ocsp.c: Use bool where possible
     * libwget/ssl_gnutls.c: Use bool for OCSP functions

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     libwget/ocsp.c: Improve C99 compliance and cleanup

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     libwget/hsts.c: Improve C99 compliance and cleanup

2019-08-13 Tim Rühsen <tim.ruehsen@gmx.de>

     libwget/hpkp.c: Improve C99 compliance and cleanup

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add FreeBSD runner

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove variadic macro for wget_printf()
     
     * include/wget/wget.h: Remove variadic macro for wget_printf(),
       add prototype for wget_printf()
     * libwget/printf.c Implement wget_printf(),
       fix some wrongly documented return types

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Make post_handshake_auth static

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Move server stats code from library into wget2 tool
     
     * fuzz/Makefile.am: Add src/stats_server.c
     * src/Makefile.am: Likewise
     * unit-tests/Makefile.am: Likewise
     * include/wget/wget.h: Move `wget_server_stats_data` to src/stats_server.c,
       change wget_server_stats_callback,
       change wget_server_set_stats_callback(),
       add wget_tcp_get_ip(),
       remove host_ips_free()
     * libwget/http.c: Move stats code to src/stats_server.c
     * libwget/net.c: Add wget_tcp_get_ip()
     * src/options.c: Move _hpkp_string() and stats_callback_server() to src/stats_server.c
     * src/wget.c (main): Remove call to host_ips_free()
     * src/wget_stats.h: Add prototypes of stats_server_add, server_stats_init, server_stats_exit

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix variables to wget_stats_format
     
     * src/options.c (parse_stats): Use wget_stats_format instead of char
     * src/wget_options.h (stats_args): Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix variable types of wget_report_speed
     
     * src/options.c (parse_report_speed_type): Fix pointer type
     * src/wget_options.h (struct config): Amend type of report_speed

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Add typedef 'wget_transfer_encoding'
     
     * include/wget/wget.h: Add typedef 'wget_transfer_encoding'
     * libwget/http_parse.c: Make use of wget_transfer_encoding

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename HTTP parse callback types
     
     * include/wget/wget.h: Rename HTTP parse callback types
     * examples/getstream.c: Likewise
     * libwget/http.c: Likewise
     * libwget/http_highlevel.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_xml_callback_t -> wget_xml_callback
     
     * include/wget/wget.h: Rename wget_xml_callback_t -> wget_xml_callback
     * libwget/xml.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename CSS parse callback types
     
     * include/wget/wget.h: Rename CSS parse callback types
     * libwget/css.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_decompressor types
     
     * include/wget/wget.h: Rename wget_decompressor types
     * libwget/decompressor.c: Likewise
     * libwget/http.c: Likewise
     * src/options.c: Likewise
     * src/wget_options.h: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_stringmap types
     
     * include/wget/wget.h: Rename wget_stringmap types
     * unit-tests/stringmap_perf.c: Likewise
     * unit-tests/test.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_hashmap types
     
     * include/wget/wget.h: Rename wget_hashmap types
     * libwget/dns_cache.c: Likewise
     * libwget/hashmap.c: Likewise
     * libwget/hpkp.c: Likewise
     * libwget/hsts.c: Likewise
     * libwget/http.c: Likewise
     * libwget/netrc.c: Likewise
     * libwget/ocsp.c: Likewise
     * libwget/stringmap.c: Likewise
     * libwget/tls_session.c: Likewise
     * src/blacklist.c: Likewise
     * src/host.c: Likewise
     * src/wget.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_vector_destructor_t -> wget_vector_destructor
     
     * include/wget/wget.h: Rename wget_vector_destructor_t -> wget_vector_destructor
     * libwget/http.c: Likewise
     * libwget/http_parse.c: Likewise
     * libwget/vector.c: Likewise
     * src/options.c: Likewise
     * src/plugin.c: Likewise
     * unit-tests/test.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_vector_browse_t -> wget_vector_browse_fn
     
     * include/wget/wget.h: Rename wget_vector_browse_t -> wget_vector_browse_fn
     * libwget/hpkp.c: Likewise
     * libwget/vector.c: Likewise
     * src/stats_site.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_vector_find_t -> wget_vector_find_fn
     
     * include/wget/wget.h: Rename wget_vector_find_t -> wget_vector_find_fn
     * libwget/vector.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_vector_compare_t -> wget_vector_compare_fn
     
     * include/wget/wget.h: Rename wget_vector_compare_t -> wget_vector_compare_fn
     * libwget/cookie.c: Likewise
     * libwget/hpkp.c: Likewise
     * libwget/http_parse.c: Likewise
     * libwget/metalink.c: Likewise
     * libwget/vector.c: Likewise
     * src/options.c: Likewise
     * tests/test-plugin-dummy.c: Likewise
     * unit-tests/test-dl.c: Likewise
     * unit-tests/test.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_logger_func_t -> wget_logger_func
     
     * include/wget/wget.h: Rename wget_logger_func_t -> wget_logger_func
     * libwget/init.c: Likewise
     * libwget/logger.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h (wget_buffer): Fix typo

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_list_browse_t -> wget_list_browse_fn
     
     * include/wget/wget.h: Rename wget_list_browse_t -> wget_list_browse_fn
     * libwget/list.c: Likewise
     * src/host.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_update_(load|save)_t -> wget_update_(load|save)_fn
     
     * include/wget/wget.h: Rename wget_update_(load|save)_t -> wget_update_(load|save)_fn
     * libwget/cookie.c: Likewise
     * libwget/hpkp.c: Likewise
     * libwget/hsts.c: Likewise
     * libwget/io.c: Likewise
     * libwget/tls_session.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_global_get_func_t -> wget_global_func
     
     * include/wget/wget.h: Rename wget_global_get_func_t -> wget_global_func
     * libwget/init.c: Likewise

2019-08-12 Tim Rühsen <tim.ruehsen@gmx.de>

     examples/http_get2.c: Cleanup

2019-08-09 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/test-ocsp-server: Modified to test without OCSP responder's URL

2019-08-10 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Freed read response in-case no request is received by the responder

2019-08-09 Tim Rühsen <tim.ruehsen@gmx.de>

     Name unnamed enum to wget_report_speed
     
     * include/wget/wget.h: Name unnamed enum to wget_report_speed,
       use wget_report_speed for param of wget_bar_set_speed_type()
     * libwget/bar.c: use wget_report_speed for param of wget_bar_set_speed_type()

2019-08-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/error.c (wget_strerror): Add missing WGET_E_MEMORY handling

2019-08-09 Tim Rühsen <tim.ruehsen@gmx.de>

     wget_strerror(int) -> wget_strerror(wget_error)
     
     * include/wget/wget.h: wget_strerror(int) -> wget_strerror(wget_error)
     * libwget/error.c: Likewise

2019-08-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Rename wget_error_t -> wget_error

2019-08-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Remove unused commented code

2019-08-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Remove unused WGET_PREFIX

2019-08-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (wget_ssl_init): Print priorities correctly on error

2019-08-08 Tim Rühsen <tim.ruehsen@gmx.de>

     Changed G_GNUC_WGET prefix to WGET_GCC
     
     * include/wget/wget.h: Changed G_GNUC_WGET prefix to WGET_GCC
     * */*.[ch]: Likewise

2019-08-08 Tim Rühsen <tim.ruehsen@gmx.de>

     Add examples/relative_to_absolute_url.c

2019-08-08 Tim Rühsen <tim.ruehsen@gmx.de>

     Allow -1 as len parameter to wget_iri_relative_to_abs()
     
     * libwget/http_highlevel.c (wget_http_get): Use -1 as len
     * libwget/iri.c (wget_iri_parse_base): Likewise
     * src/wget.c (process_response_header): Likewise
     * unit-tests/test.c (test_iri_relative_to_absolute): Likewise

2019-08-07 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/test-ocsp-stap.c: Removed redundant comment

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Save coverage for HTTP/2 runner as artifact

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/Makefile.am: Add CODE_COVERAGE flags

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename stats types (remove trailing _t)
     
     * include/wget/wget.h: Rename stats types (remove trailing _t)
     * libwget/dns.c: Likewise
     * libwget/http.c: Likewise
     * libwget/net.h: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/ssl_none.c: Likewise
     * libwget/ssl_wolfssl.c: Likewise
     * src/options.c: Likewise

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Fix type in two comments

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_hsts_db_t -> wget_hsts_db
     
     * include/wget/wget.h: Rename wget_hsts_db_t -> wget_hsts_db,
     * fuzz/libwget_hsts_fuzzer.c: Likewise
     * libwget/hsts.c: Likewise
     * src/wget_options.h: Likewise
     * tests/test-plugin-dummy.c: Likewise
     * unit-tests/test.c: Likewise

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Replace outdated docs for plugins

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_hpkp_db_t -> wget_hpkp_db and wget_hpkp_t -> wget_hpkp
     
     * include/wget/wget.h: Rename wget_hpkp_db_t -> wget_hpkp_db,
       rename wget_hpkp_t -> wget_hpkp
     * fuzz/libwget_hpkp_fuzzer.c: Likewise
     * libwget/hpkp.c: Likewise
     * libwget/http_parse.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/ssl_wolfssl.c: Likewise
     * src/wget_options.h: Likewise
     * tests/test-plugin-dummy.c: Likewise
     * unit-tests/test.c: Likewise

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Rework HPKP DB plugin code
     
     * include/wget/wget.h: Add typedefs for HPKP DB functions,
       remove wget_hpkp_db_st,
       rewrite wget_hpkp_db_vtable,
       add wget_hpkp_set_plugin()
     * libwget/hpkp.c: Add one function table for all exposed functions,
       implement wget_hpkp_set_plugin(),
       call plugin functions if set
     * libwget/plugin.c: Remove wget_plugin_add_hpkp_db()
     * src/plugin.c: Remove impl_add_hpkp_db()
     * tests/test-plugin-dummy.c: Implement dummy hsts db API,
       initialize test_hpkp_db_vtable,
       call wget_hpkp_set_plugin() in plugin initializer

2019-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Rework OCSP DB plugin code
     
     * include/wget/wget.h: Add typedefs for OCSP DB functions,
       remove wget_ocsp_db_st,
       rewrite wget_ocsp_db_vtable,
       add wget_ocsp_set_plugin()
     * libwget/ocsp.c: Add one function table for all exposed functions,
       implement wget_ocsp_set_plugin(),
       call plugin functions if set
     * libwget/plugin.c: Remove wget_plugin_add_ocsp_db()
     * src/plugin.c: Remove impl_add_ocsp_db()
     * tests/test-plugin-dummy.c: Implement dummy hsts db API,
       initialize test_ocsp_db_vtable,
       call wget_ocsp_set_plugin() in plugin initializer

2019-08-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Rework HSTS DB plugin code
     
     * include/wget/wget.h: Ad typedefs for HSTS DB functions,
       remove wget_hsts_db_st,
       rewrite wget_hsts_db_vtable,
       add wget_hsts_set_plugin()
     * libwget/hsts.c: Add one function table for all exposed functions,
       implement wget_hsts_set_plugin(),
       call plugin functions if set
     * libwget/plugin.c: Remove wget_plugin_add_hsts_db()
     * src/plugin.c: Remove impl_add_hsts_db()
     * tests/test-plugin-dummy.c: Implement dummy hsts db API,
       initialize test_hsts_db_vtable,
       call wget_hsts_set_plugin() in plugin initializer

2019-08-05 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename plugin types
     
     * include/wget/wget.h: Rename plugin types
     * libwget/plugin.c: Likewise
     * src/plugin.c: Likeiwse
     * src/wget_plugin.h: Likewise
     * tests/test-plugin-dummy.c: Likewise

2019-08-05 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added support for ax_code_coverage version 32
     
     * Makefile.am: Add code coverage rules as documented in ax_code_coverage.m4
     * cfg.mk: Exclude m4 files from sc_GPL_version
     * configure.ac: Add AX_CODE_COVERAGE
     * fuzz/Makefile.am: Add coverage flags
     * libwget/Makefile.am: Likewise
     * src/Makefile.am: Likewise
     * tests/Makefile.am: Likewise
     * m4/ax_ac_append_to_file.m4: New file
     * m4/ax_ac_print_to_file.m4: New file
     * m4/ax_add_am_macro_static.m4: New file
     * m4/ax_am_macros_static.m4: New file
     * m4/ax_check_gnu_make.m4: New file
     * m4/ax_code_coverage.m4: New file
     * m4/ax_file_escapes.m4: New file

2019-08-04 DalmeGNU <dalmemail@gmail.com>

     Background support for fork() compatible OS
     
     * src/wget.c: Added fork_to_background(), in order to implement --background
     * src/options.c: Added "--background" to the options list
     * src/wget_options.h: Added background member to structure config
     * docs/wget2.md: Background option marked as "Not supported on Windows"

2019-08-04 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Changed validity time for OCSP Stapled Response
     
     * tests/certs/ocsp/generate_stap.sh: Modified to generate longer validity response
     * tests/certs/ocsp/ocsp_stapled_resp.der: Regenerated for longer validity

2019-07-27 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Resolved tests failure due to OCSP

2019-06-22 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Add test-limit-rate-http2
     
     * tests/Makefile.am: Added test-limit-rate-http2
     * tests/test-limit-rate-http2.c: Cloned 'test-limit-rate' to test for h2 only

2019-06-22 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * .gitlab-ci.yml: Add Gitlab CI runner for HTTP/2

2019-06-21 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Making failing tests work on Second Pass
     
     * tests/test--https-enforce-soft3.c:
     * tests/test-bad-chunk.c:
     * tests/test-chunked.c:
     * tests/test-limit-rate.c:
     * tests/test-post-handshake-auth.c: Skipped for Second Pass
     
     * tests/test-i-https.c: Added '--no-ca-certificate' in options for expected failure for h2
     
     * tests/test-idn-cmd.c:
     * tests/test-idn-meta.c:
     * tests/test-idn-robots.c: Dynamic port replacement for http/https proxies
     
     * tests/test-iri.c:
     * tests/test-parse-css.c:
     * tests/test-parse-html-css.c: Dynamic port replacement for hostname

2019-06-21 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Adding support for running both http/1.1 and h2 tests
     
     * configure.ac: Modified to have check for availability of MHD-http2
     * tests/libtest.c: Modified to run both protocols on existing tests
     * tests/libtest.h: Added macros for h2 and modified wget_test_url_t data structure

2019-06-20 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Modified Range Header key check to be case-insensitive

2019-06-20 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Modified to have compatibility with MHD-http2

2019-07-25 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/test-ocsp-server.c: Added Revoked OCSP test with --no-check-certificate

2019-07-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * examples/getstream.c: Fix call to wget_http_get()

2019-07-25 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix parsing Location header with trailign digits
     
     * libwget/http_parse.c (wget_http_parse_location): Replace
       c_isdigits() by c_isblank()

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/certs/ocsp/README.md: Added README for generating generating certificates and response

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Splitting certs/resp generator script
     
     * tests/certs/ocsp/generate_certs.sh: Added to generate certificates
     * tests/certs/ocsp/generate_resp.sh: Added to generate stapled response

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Removed redundant priority from MHD daemon initialization

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Added file loading checks for OCSP Stapling PEM/DER files

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Moved PEM/DER loading out of _ocsp_stap_cert_callback()

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Dynamically allocating 'privkey_stap'

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Enforced gnutls_certificate_retrieve_function3 type for _ocsp_stap_cert_callback()

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Removed ampersand from MHD_OPTION_HTTPS_CERT_CALLBACK2 value

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added templates, records, and script for OCSP stapling PEM/DER files
     
     * tests/certs/ocsp/demoCA/*: Openssl certificate signing records for root and intermediate
     * tests/certs/ocsp/generate_stap.sh: Added script for generating required certificates and response
     * tests/certs/ocsp/interm-template.txt: Added template for intermediate certificate
     * tests/certs/ocsp/interm.cnf: Added openssl config for intermediate certificate signing
     * tests/certs/ocsp/root-template.txt: Added template for root certificate
     * tests/certs/ocsp/server-template.txt: Added template for server certificate

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/libtest.c: Moved break into preprocessor else block

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added required certificates and response
     
     * tests/certs/ocsp/ocsp_stapled_resp.der: Added OCSP stapled response
     * tests/certs/ocsp/x509-interm-cert.pem: Added intermediate certificate
     * tests/certs/ocsp/x509-interm-key.pem: Added intermediate private key
     * tests/certs/ocsp/x509-root-cert.pem: Added root CA certificate
     * tests/certs/ocsp/x509-root-key.pem: Added root CA private key
     * tests/certs/ocsp/x509-server-cert.pem: Added server certificate
     * tests/certs/ocsp/x509-server-key.pem: Added server private key

2019-07-24 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added skeleton OCSP Stapling
     
     * tests/Makefile.am: Added test-ocsp-stap
     * tests/libtest.c: Added an MHD daemon to send OCSP stapled response
     * tests/libtest.h: Added macro WGET_TEST_FEATURE_OCSP_STAPLING
     * tests/test-ocsp-stap.c: Added test for OCSP stapling

2019-07-23 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     * tests/certs/ocsp/README.md: Added README for generating generating certificates and responses

2019-07-23 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Splitting certs/resps generator script
     
     * tests/certs/ocsp/generate_certs.sh: Added to generate certificates
     * tests/certs/ocsp/generate_resp.sh: Added to generate responses

2019-07-21 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Making OCSP Response Global
     
     * tests/libtest.c: Added 'struct ocsp_resp_t' and moved OCSP response to global scope

2019-07-21 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added templates, records, and script for OCSP Responder PEM/DER files
     
     * tests/certs/ocsp/demoCA/*: Openssl certificate signing records for root and intermediate
     * tests/certs/ocsp/generate_resp.sh: Added script for generating required certificates and responses
     * tests/certs/ocsp/interm-template.txt: Added template for intermediate certificate
     * tests/certs/ocsp/interm.cnf: Added openssl config for intermediate certificate signing
     * tests/certs/ocsp/root-template.txt: Added template for root certificate
     * tests/certs/ocsp/server-template.txt: Added template for server certificate

2019-07-21 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added required certificates and response
     
     * tests/certs/ocsp/ocsp_resp_ok.der: Added OCSP verified response
     * tests/certs/ocsp/ocsp_resp_revoked.der: Added OCSP revoked response
     * tests/certs/ocsp/x509-interm-cert.pem: Added intermediate certificate
     * tests/certs/ocsp/x509-interm-key.pem: Added intermediate private key
     * tests/certs/ocsp/x509-root-cert.pem: Added root CA certificate
     * tests/certs/ocsp/x509-root-key.pem: Added root CA private key
     * tests/certs/ocsp/x509-server-cert.pem: Added server certificate
     * tests/certs/ocsp/x509-server-key.pem: Added server private key

2019-07-21 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added test-ocsp-server
     
     * tests/Makefile.am: Modified to run the test
     * tests/test-ocsp-server: Added for testing OCSP verified/revoked responses

2019-07-20 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added OCSP Responder to the test library
     
     * tests/libtest.c: Added the skeleton responder
     * tests/libtest.h: Added required macros and function prototype

2019-07-20 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added option --ocsp-date
     
     * docs/wget2.md: Added documentation for --ocsp-date
     * include/wget/wget.h: Added macro WGET_SSL_OCSP_DATE
     * libwget/ssl_gnutls.c: Modified to use option
     * src/options.c: Added option handler
     * src/wget_options.h: Declared bool for option

2019-07-20 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added option --ocsp-nonce
     
     * docs/wget2.md: Added documentation for --ocsp-nonce
     * include/wget/wget.h: Added macro WGET_SSL_OCSP_NONCE
     * libwget/ssl_gnutls.c: Modified to use option
     * src/options.c: Added option handler
     * src/wget_options.h: Declared bool for option

2019-07-20 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Added option --ocsp-server
     
     * docs/wget2.md: Added documentation for --ocsp-server
     * libwget/ssl_gnutls.c: Modified to use value from option parameter
     * src/options.c: Added option handler
     * src/wget_options.h: Declared storage for option parameter

2019-07-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (safe_ctime): Fix buffer size

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_console_color_t -> wget_console_color
     
     * include/wget/wget.h: Rename wget_console_color_t -> wget_console_color
     * libwget/console.c: Likewise
     * src/log.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_bar_t -> wget_bar
     
     * include/wget/wget.h: Rename wget_bar_t -> wget_bar
     * fuzz/libwget_bar_fuzzer.c: Likewise
     * libwget/bar.c: Likewise
     * src/bar.c: Likewise
     * src/wget_bar.h: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_robots_t -> wget_robots
     
     * include/wget/wget.h: Rename wget_robots_t -> wget_robots
     * fuzz/libwget_robots_parse_fuzzer.c: Likewise
     * libwget/robots.c: Likewise
     * libwget/test_linking_robots.c: Likewise
     * src/wget_host.h: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_metalink_*_t -> wget_metalink_*
     
     * include/wget/wget.h: Rename wget_metalink_*_t -> wget_metalink_*
     * libwget/metalink.c: Likewise
     * src/job.c: Likewise
     * src/wget.c: Likewise
     * src/wget_job.h: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_digest_algorithm_t -> wget_digest_algorithm
     
     * include/wget/wget.h: Rename wget_digest_algorithm_t -> wget_digest_algorithm
     * libwget/hash_printf.c: Likewise
     * libwget/hashfile.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_hash_hd_t -> wget_hash_hd
     
     * include/wget/wget.h: Rename wget_hash_hd_t -> wget_hash_hd
     * libwget/hashfile.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_http_connection_t -> wget_http_connection
     
     * include/wget/wget.h: Rename wget_http_connection_t -> wget_http_connection
     * examples/check_url_types.c: Likewise
     * examples/http_get.c: Likewise
     * examples/http_get2.c: Likewise
     * examples/http_multi_get.c: Likewise
     * examples/websequencediagram.c: Likewise
     * examples/websequencediagram_high.c: Likewise
     * fuzz/libwget_http_client_fuzzer.c: Likewise
     * libwget/http.c: Likewise
     * libwget/http_highlevel.c: Likewise
     * libwget/http_parse.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * src/wget.c: Likewise
     * src/wget_job.h: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_http_request_t -> wget_http_request
     
     * include/wget/wget.h: Rename wget_http_request_t -> wget_http_request
     * examples/http_get2.c: Likewise
     * examples/http_multi_get.c: Likewise
     * examples/websequencediagram.c: Likewise
     * fuzz/libwget_http_client_fuzzer.c: Likewise
     * libwget/http.c: Likewise
     * libwget/http_highlevel.c: Likewise
     * libwget/http_parse.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * src/wget.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_http_response_t -> wget_http_response
     
     * include/wget/wget.h: Rename wget_http_response_t -> wget_http_response
     * examples/batch_loader.c: Likewise
     * examples/check_url_types.c: Likewise
     * examples/getstream.c: Likewise
     * examples/http_get.c: Likewise
     * examples/http_get2.c: Likewise
     * examples/http_multi_get.c: Likewise
     * examples/websequencediagram.c: Likewise
     * examples/websequencediagram_high.c: Likewise
     * fuzz/libwget_http_client_fuzzer.c: Likewise
     * fuzz/libwget_http_parse_fuzzer.c: Likewise
     * libwget/http.c: Likewise
     * libwget/http_highlevel.c: Likewise
     * libwget/http_parse.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * src/gpgme.c: Likewise
     * src/stats_site.c: Likewise
     * src/wget.c: Likewise
     * src/wget_gpgme.h: Likewise
     * src/wget_stats.h: Likewise
     * tests/test-cookies-http_state.c: Likewise
     * unit-tests/test-cookies-http_state.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename transfer_encoding_* -> wget_transfer_encoding_*
     
     * include/wget/wget.h: Rename transfer_encoding_* -> wget_transfer_encoding_*
     * libwget/http.c: Likewise
     * libwget/http_parse.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_http_challenge_t -> wget_http_challenge
     
     * include/wget/wget.h: Rename wget_http_challenge_t -> wget_http_challenge
     * libwget/http.c: Likewise
     * libwget/http_parse.c: Likewise
     * src/options.c: Likewise
     * src/wget.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_http_digest_t -> wget_http_digest
     
     * include/wget/wget.h: Rename wget_http_digest_t -> wget_http_digest
     * libwget/http_parse.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_http_link_t -> wget_http_link
     
     * include/wget/wget.h: Rename wget_http_link_t -> wget_http_link
     * libwget/http_parse.c: Likewise
     * src/wget.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_http_header_param_t -> wget_http_header_param
     
     * include/wget/wget.h: Rename wget_http_header_param_t -> wget_http_header_param
     * libwget/http.c: Likewise
     * libwget/http_highlevel.c: Likewise
     * libwget/http_parse.c: Likewise
     * src/options.c: Likewise
     * src/wget.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_tcp_t -> wget_tcp
     
     * include/wget/wget.h: Rename wget_tcp_t -> wget_tcp
     * libwget/http.h: Likewise
     * libwget/net.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/ssl_none.c: Likewise
     * libwget/ssl_wolfssl.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_dns_t -> wget_dns
     
     * include/wget/wget.h: Rename wget_dns_t -> wget_dns
     * libwget/dns.c: Likewise
     * libwget/net.c: Likewise
     * libwget/net.h: Likewise
     * src/options.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_dns_cache_t -> wget_dns_cache
     
     * include/wget/wget.h: Rename wget_dns_cache_t -> wget_dns_cache
     * libwget/dns.c: Likewise
     * libwget/dns_cache.c: Likewise
     * libwget/init.c: Likewise
     * src/options.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_html_tag_t -> wget_html_tag
     
     * include/wget/wget.h: Rename wget_html_tag_t -> wget_html_tag
     * libwget/html_url.c: Likewise
     * src/options.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_html_parsed_result_t -> wget_html_parsed_result
     
     * include/wget/wget.h: Rename wget_html_parsed_result_t -> wget_html_parsed_result
     * examples/check_url_types.c: Likewise
     * examples/print_html_urls.c: Likewise
     * fuzz/libwget_html_url_fuzzer.c: Likewise
     * libwget/html_url.c: Likewise
     * src/wget.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_html_parsed_url_t -> wget_html_parsed_url
     
     * include/wget/wget.h: Rename wget_html_parsed_url_t -> wget_html_parsed_url
     * examples/check_url_types.c: Likewise
     * examples/print_html_urls.c: Likewise
     * libwget/html_url.c: Likewise
     * src/wget.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_string_t -> wget_string
     
     * include/wget/wget.h: Rename wget_string_t -> wget_string
     * examples/batch_loader.c: Likewise
     * examples/check_url_types.c: Likewise
     * examples/print_html_urls.c: Likewise
     * libwget/atom_url.c: Likewise
     * libwget/robots.c: Likewise
     * libwget/rss_url.c: Likewise
     * libwget/sitemap_url.c: Likewise
     * src/host.c: Likewise
     * src/wget.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_css_parsed_url_t -> wget_css_parsed_url
     
     * include/wget/wget.h: Rename wget_css_parsed_url_t -> wget_css_parsed_url
     * examples/print_css_urls3.c: Likewise
     * libwget/css_url.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_netrc_t -> wget_netrc
     
     * include/wget/wget.h: Rename wget_netrc_t -> wget_netrc
     * libwget/netrc.c: Likewise
     * src/wget.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_netrc_db_t -> wget_netrc_db
     
     * include/wget/wget.h: Rename wget_netrc_db_t -> wget_netrc_db
     * fuzz/libwget_netrc_fuzzer.c: Likewise
     * libwget/netrc.c: Likewise
     * src/wget_options.h: Likewise
     * unit-tests/test.c: Likewise

2019-07-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_ocsp_db_t -> wget_ocsp_db
     
     * include/wget/wget.h: Rename wget_ocsp_db_t -> wget_ocsp_db
     * examples/http_multi_get.c: Likewise
     * fuzz/libwget_ocsp_fuzzer.c: Likewise
     * libwget/ocsp.c: Likewise
     * libwget/plugin.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/ssl_wolfssl.c: Likewise
     * src/plugin.c: Likewise
     * src/wget_options.h: Likewise
     * src/wget_plugin.h: Likewise
     * tests/test-plugin-dummy.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_tls_session_db_t -> wget_tls_session_db
     
     * include/wget/wget.h: Rename wget_tls_session_db_t -> wget_tls_session_db
     * fuzz/libwget_tlssess_fuzzer.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/ssl_wolfssl.c: Likewise
     * libwget/tls_session.c: Likewise
     * src/wget_options.h: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_tls_session_t -> wget_tls_session
     
     * include/wget/wget.h: Rename wget_tls_session_t -> wget_tls_session
     * libwget/tls_session.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_cookie_t -> wget_cookie
     
     * include/wget/wget.h: Rename wget_cookie_t -> wget_cookie
     * fuzz/libwget_cookie_fuzzer.c: Likewise
     * libwget/cookie.c: Likewise
     * libwget/http_parse.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_cookie_db_t -> wget_cookie_db
     
     * include/wget/wget.h: Rename wget_cookie_db_t -> wget_cookie_db
     * examples/http_get2.c: Likewise
     * fuzz/libwget_cookie_fuzzer.c: Likewise
     * libwget/cookie.c: Likewise
     * libwget/http_highlevel.c: Likewise
     * libwget/init.c: Likewise
     * src/wget_options.h: Likewise
     * tests/test-cookies-http_state.c: Likewise
     * unit-tests/test-cookies-http_state.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_iri_t -> wget_iri
     
     * include/wget/wget.h: Rename wget_iri_t -> wget_iri
     * examples/*.c: Likewise
     * fuzz/*.c: Likewise
     * libwget/*.c: Likewise
     * src/*.c: Likewise
     * tests/*.c: Likewise
     * unit-tests/*.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_decompressor_t -> wget_decompressor
     
     * include/wget/wget.h: Rename wget_decompressor_t -> wget_decompressor
     * libwget/decompressor.c: Likewise
     * libwget/http.c: Likewise
     * src/wget.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_thread_cond_t -> wget_thread_cond
     
     * include/wget/wget.h: Rename wget_thread_cond_t -> wget_thread_cond
     * libwget/thread.c: Likewise
     * src/wget.c: Likewise
     * src/wget_job.h: Likewise
     * unit-tests/test-cond.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_thread_mutex_t -> wget_thread_mutex
     
     * include/wget/wget.h: Rename wget_thread_mutex_t -> wget_thread_mutex
     * libwget/*.c: Likewise
     * src/*.c: Likewise
     * unit-tests/test-cond.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_thread_id_t -> wget_thread_id
     
     * include/wget/wget.h: Rename wget_thread_id_t -> wget_thread_id
     * libwget/thread.c: Likewise
     * src/host.c: Likewise
     * src/wget_job.h: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_thread_t -> wget_thread
     
     * include/wget/wget.h: Rename wget_thread_t -> wget_thread
     * examples/batch_loader.c: Likewise
     * libwget/thread.c: Likewise
     * src/*.c: Likewise
     * unit-tests/test-cond.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_stringmap_iterator_t -> wget_stringmap_iterator
     
     * include/wget/wget.h: Likewise
     * unit-tests/test.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_stringmap_t -> wget_stringmap
     
     * include/wget/wget.h: Rename wget_stringmap_t -> wget_stringmap
     * libwget/stringmap.c: Likewise
     * src/options.c: Likewise
     * src/plugin.c: Likewise
     * src/wget.c: Likewise
     * unit-tests/stringmap_perf.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_hashmap_iterator_t -> wget_hashmap_iterator
     
     * include/wget/wget.h: Rename wget_hashmap_iterator_t -> wget_hashmap_iterator
     * libwget/hashmap.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_hashmap_t -> wget_hashmap
     
     * include/wget/wget.h: Rename wget_hashmap_t -> wget_hashmap
     * libwget/*.c: Likewise
     * src/*.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_vector_t -> wget_vector
     
     * include/wget/wget.h: Rename wget_vector_t -> wget_vector
     * examples/print_css_urls3.c: Likewise
     * fuzz/*.c: Likewise
     * libwget/*.c: Likewise
     * src/*.c: Likewise
     * tests/*.c: Likewise
     * unit-tests/*.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_logger_t -> wget_logger
     
     * include/wget/wget.h: Rename wget_logger_t -> wget_logger
     * libwget/log.c: Likewise
     * libwget/logger.c: Likewise
     * libwget/logger.h: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_buffer_t -> wget_buffer
     
     * include/wget/wget.h: Rename wget_buffer_t -> wget_buffer
     * examples/*.c: Likewise
     * fuzz/libwget_iri_fuzzer.c: Likewise
     * libwget/*.c: Likewise
     * src/*.c: Likewise
     * tests/*.c: Likewise
     * unit-tests/*.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_bitmap_t -> wget_bitmap
     
     * include/wget/wget.h: Likewise
     * libwget/bitmap.c: Likewise
     * unit-tests/test.c: Likewise

2019-07-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename wget_list_t -> wget_list
     
     * include/wget/wget.h: Likewise
     * libwget/list.c: Likewise
     * libwget/test_linking.c: Likewise
     * src/wget_host.h: Likewise
     * src/wget_job.h: Likewise

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Add prototype for _get_body

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove wget_tcp_set_stats_site() function
     
     * include/wget/wget.h: Remove wget_stats_callback_t and
       wget_tcp_set_stats_site()
     * libwget/http.c: Remove wget_tcp_set_stats_site()

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_server_stats_callback_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/http.c: Amend casts and variable types

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_tls_stats_callback_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/ssl_gnutls.c: Amend casts and variable types
     * libwget/ssl_wolfssl.c: Likewise

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_ocsp_stats_callback_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/ssl_gnutls.c: Amend casts and variable types
     * libwget/ssl_wolfssl.c: Likewise

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_dns_stats_callback_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/dns.c: Amend casts and variable types

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef plugin functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/plugin.c: Amend casts and variable types
     * src/plugin.c: Likewise

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef http callback functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/http.c: Amend casts and variable types
     * libwget/http_highlevel.c: Likewise

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef XML parse functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/xml.c: Amend casts and variable types

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef CSS parse functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/css.c: Amend casts and variable types

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef decompressor functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/decompressor.c: Likewise, Amend casts

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add CI runner for Debian unstable

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef vector functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/*.c: Amend casts
     * src/*.c: Likewise
     * tests/*.c: Likewise
     * unit-tests/*.c: Likewise

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_logger_func_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/init.c: Amend va_arg params
     * libwget/logger.c: Amend function params

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_* alloc functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/xalloc.c: Amend declarations

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_list_browse_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/list.c: Amend wget_list_browse() argument
     * src/host.c: Amend cast

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_update_[load|save]_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/*.c: Amend casts

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef wget_global_get_func_t not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedef
     * libwget/init.c: Amend function definition

2019-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Typedef hashmap functions not as pointer
     
     * include/wget/wget.h: Remove '*' signature from function typedefs
     * libwget/*.c: Amend casts
     * src/*.c: Likewise
     * unit-tests/stringmap_perf.c: Likewise

2019-07-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/bar.c (_bar_update_speed_stats): Fix division by 0

2019-07-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/stats_site.c (site_stats_init): Always free resources

2019-07-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (parse_stats): Fix stats options
     
     Stats options wrote to stdout when a filename was given without format.

2019-07-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/*.in: Update fuzz corpora from OSS-Fuzz

2019-07-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/README.md: clang-6.0 -> clang

2019-07-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (init): Do not write stats to files when fuzzing

2019-07-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/Makefile.am: Add README.md to DISTCLEANFILES unconditionally

2019-07-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * .travis_setup.sh: Add GNU grep and gawk for OSX

2019-07-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * .travis.sh: Fix sed -i for OSX on TravisCI

2019-07-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c (test_mem): Fix buffer overflow detected by ASAN

2019-07-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c (wget_ssl_init): Exit gracefully on error

2019-07-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * cfg.mk: Add new syntax-check rule 'sc_gettext_printf'

2019-07-09 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix missing gettext/translation for string literals
     
     * libwget/robots.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/ssl_wolfssl.c: Likewise
     * src/gpgme.c: Likewise
     * src/host.c: Likewise
     * src/options.c: Likewise
     * src/wget.c: Likewise

2019-07-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * cfg.mk: Add new syntax-check rule 'sc_prohibit_gettext_debug'

2019-06-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/Makefile.am: Replace $< from explicit rule

2019-06-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/Makefile.am: Replace $< from explicit rule

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (_add_tag): Fix OSS-Fuzz issue 15526

2019-06-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Add pkg-config check for libnettle

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/utils.c (wget_strnglob): Return NULL if malloc fails

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Indentation cleanups

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_bar_st -> wget_bar_st
     
     * include/wget/wget.h: Likewise
     * libwget/bar.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_hash_hd_st -> wget_hash_hd_st
     
     * include/wget/wget.h: Likewise
     * libwget/hashfile.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_http_connection_st -> wget_http_connection_st
     
     * include/wget/wget.h: Likewise
     * libwget/http.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_netrc_db_st -> wget_netrc_db_st
     
     * include/wget/wget.h: Likewise
     * libwget/netrc.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_tls_session_db_st -> wget_tls_sessione_db_st
     
     * include/wget/wget.h: Likewise
     * libwget/tls_session.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_tls_session_st -> wget_tls_sessione_st
     
     * include/wget/wget.h: Likewise
     * libwget/tls_session.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Remove comment line

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_hpkp_st -> wget_hpkp_st
     
     * include/wget/wget.h: Likewise
     * libwget/hpkp.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_cookie_st -> wget_cookie_st
     
     * include/wget/wget.h: Likewise
     * libwget/cookie.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget_options.h (struct config): wget_cookie_db_st -> wget_cookie_db_t

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_cookie_db_st -> wget_cookie_db_st
     
     * include/wget/wget.h: Likewise
     * libwget/cookie.c: Likewise
     * src/wget_options.h: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_decompressor_st -> wget_decompressor_st
     
     * include/wget/wget.h: Likewise
     * libwget/decompressor.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_thread_cond_st -> wget_thread_cond_st
     
     * include/wget/wget.h: Likewise
     * libwget/thread.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_thread_mutex_st -> wget_thread_mutex_st
     
     * include/wget/wget.h: Likewise
     * libwget/thread.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_thread_st -> wget_thread_st
     
     * include/wget/wget.h: Likewise
     * libwget/thread.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_hashmap_iterator_st -> wget_hashmap_iterator_st
     
     * include/wget/wget.h: Likewise
     * libwget/hashmap.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_hashmap_st -> wget_hashmap_st
     
     * include/wget/wget.h: Likewise
     * libwget/hashmap.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_logger_st -> wget_logger_st
     
     * include/wget/wget.h: Likewise
     * libwget/logger.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename _wget_list_st -> wget_list_st
     
     * include/wget/wget.h: Likewise
     * libwget/list.c: Likewise

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Rename _WGET_PREFIX -> WGET_PREFIX

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Add G_GNUC_WGET_MALLOC to wget_read_file()

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/robots.c (wget_robots_parse): Fix corner-case memleak

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Check OOM in wget_http_add_header*()
     
     * include/wget/wget.h: Return int for wget_http_add_header(),
       return int for wget_http_add_header_param()
     * libwget/http.c; New static function http_add_header(),
       (wget_http_add_header_vprintf): Use http_add_header(),
       (wget_http_add_header): Return int, use http_add_header(),
       (wget_http_add_header_param): Return int, use http_add_header()

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_highlevel.c (wget_http_get): Check return value of wget_vector_add_memdup()

2019-06-27 Tim Rühsen <tim.ruehsen@gmx.de>

     Add memory checks to wget_http_add_header_vprintf()
     
     * include/wget/wget.h: return int for wget_http_add_header_vprintf(),
       return int for wget_http_add_header_printf()
     * libwget/http.c (wget_http_add_header_vprintf):
       check for memory allocations and return error code,
       (wget_http_add_header_printf): Return error code

2019-06-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/html_url.c (_html_get_url): Set url.link_inline

2019-06-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/html_url.c (_css_parse_uri): Use malloc + wget_vector_add

2019-06-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/sitemap_url.c (_sitemap_get_url): Use malloc + wget_vector_add

2019-06-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/rss_url.c (_rss_get_url): Use malloc + wget_vector_add

2019-06-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/css_url.c (_css_get_url): Use calloc + wget_vector_add

2019-06-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/atom_url.c (_atom_get_url): Use malloc + wget_vector_add

2019-06-26 Tim Rühsen <tim.ruehsen@gmx.de>

     Simplify vector API
     
     * libwget/vector.c: Use wget_free as default destructor,
       renamed _vec_insert_private() -> insert_element,
       (insert_element): removed args 'size' and 'alloc',
       removed the _noalloc() API,
       removed the 'size' argument from functions,
       added wget_vector_add_memdup() as convenience function,
       renamed _compare() -> compare_element
     * include/wget/wget.h: Removed _noalloc() functions
     * fuzz/libwget_cookie_fuzzer.c: Amended to new API
     * libwget/*.c: Likewise
     * src/*.c: Likewise
     * tests/*.c: Likewise
     * unit-tests/*.c: Likewise

2019-06-24 Gisle Vanem <gisle.vanem@gmail.com>

     * libwget/ssl_gnutls.c: Fix Doxygen indenting of bullet list
     
     Seems Doxgen gets confused unless all bullet-ed items in a list have the same number of spaced.
     And the generated HTML looks jagged.

2019-06-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Add Gisle Vanem

2019-06-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Add sc_prohibit_alloc to 'make syntax-check'
     
     * cfg.mk: Add sc_prohibit_alloc rule plus exceptions
     * src/options.c: Tag exceptions
     * unit-tests/test.c: Likewise
     
     This rule checks for calling malloc()/calloc()/realloc(). Instead, either
     use wget_malloc(), wget_calloc() or wget_realloc().

2019-06-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Add sc_prohibit_free to 'make syntax-check'
     
     * cfg.mk: Add sc_prohibit_free rule plus exceptions
     * examples/print_css_urls3.c: Remove unneeded comment
     * fuzz/libwget_base64_fuzzer.c: Use wget_free() instead of free()
     * fuzz/libwget_cookie_fuzzer.c: Likewise
     * fuzz/libwget_css_url_fuzzer.c: Likewise
     * fuzz/libwget_http_client_fuzzer.c: Likewise
     * fuzz/libwget_utils_fuzzer.c: Likewise
     * libwget/vector.c: Likewise
     * src/options.c: Likewise
     * src/wget_main.h: Likewise
     * tests/test-compression.c: Likewise
     * tests/test-cookies-http_state.c: Likewise
     * tests/test-metalink.c: Likewise
     * unit-tests/stringmap_perf.c: Likewise
     
     This rule checks for calling free(). Instead, either use wget_free() or
     the convenience macro xfree().

2019-06-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * m4/wget_manywarnings.m4: Remove -Werror-... options

2019-06-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/net.c: Fix compiler warning on MinGW

2019-06-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/wget_options_fuzzer.c: Fix compiler warning on MinGW

2019-06-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/Makefile.am: Avoid using unportable .o reference with libtool

2019-06-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove need for C11 thread local storage
     
     * configure.ac: Remove check for threads.h
     * libwget/ssl_gnutls.c: Remove need for C11 thread local storage

2019-06-23 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/libwget_http_client_fuzzer.c: Add emulation of freeaddrinfo()

2019-06-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Add const to conn_info

2019-06-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/Makefile.am: Use top_srcdir instead of .. to fix VPATH build

2019-06-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (deinit): Fix OSS-Fuzz issue 15443

2019-06-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (parse_stats): Fix OSS-Fuzz issue 15438

2019-06-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/Makefile.am: Use top_srcdir instead of .. to fix VPATH build

2019-06-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Inline most of stringmap API
     
     * include/wget/wget.h: Add stringmap API (mostly) as static inline functions
     * libwget/stringmap.c: Remove stringmap implementation (mostly)

2019-06-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Add memory checks and error return value to hashmap API
     
     * include/wget/wget.h: wget_hashmap_sethashfunc() returns int
     * libwget/hashmap.c: Check memory allocations
     * libwget/stringmap.c: wget_stringmap_sethashfunc() returns int

2019-06-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Simplify hashmap and stringmap API
     
     * include/wget/wget.h: Replace _put() by _put_noalloc() functions to
       keep memory allocations outside the library functions.
     * libwget/stringmap.c: Likewise
     * libwget/hashmap.c: Likewise
     * libwget/*.c: Likewise
     * src/*.c: Likewise
     * unit-tests/*.c: Likewise

2019-06-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Separate DNS and DNS caching
     
     * include/wget/wget.h: Rewrite parts of the DNS / DNS caching API
     * libwget/dns.c: Likewise
     * libwget/dns_cache.c: Likewise
     * libwget/init.c (wget_global_init): Amend WGET_DNS_CACHING
     * libwget/net.c: Cleanup and amend for the new API
     * libwget/net.h: Cleanup
     * src/options.c: Use DNS caching instance if caching is requested

2019-06-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove --stats-all
     
     * docs/wget2.md Remove docs for --stats-all
     * src/options.c: Remove --stats-all and parse_stats_all()
     * fuzz/wget_options_fuzzer.dict: remove --stats-all
     * tests/Makefile.am: Remove test-stats-all
     * tests/test-stats-all.c: Remove file

2019-06-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Rewrite Site statistics --stats-site
     
     * fuzz/Makefile.am: Remove ../src/stats_site.o
     * include/wget/wget.h: Remove wget_stats_type_t
     * po/POTFILES.in. Remove src/stats.c
     * src/Makefile.am: Remove stats_site.c
     * src/options.c (parse_stats_all): Remove site stats code,
       (init): Add DNS stats code,
       (deinit): Cleanup dns stats code
     * src/stats.c: Remove file
     * src/stats_site.c: iFix for new stats code
     * src/wget.c (main): stats_print -> site_stats_print,
       (add_statistics): config.stats_site -> config.stats_site_args,
       (process_response): Likewise
     * src/wget_options.h (struct config): Remove stats_site, add stats_site_args
     * src/wget_stats.h: Remove stats_opt_t,
       remove stats_print_func_t,
       remove stats_callback_setter_t,
       remove struct stats_opts,
       remove stats_site_opts,
       rename stats_init -> site_stats_init,
       rename stats_exit -> site_stats_exit,
       rename stats_print -> site_stats_print
     * unit-tests/Makefile.am: Remove ../src/stats.o

2019-06-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Amend --stats-* syntax
     
     * docs/wget2.md: Amend docs for --stats-*
     * src/options.c: Amend option syntax for --stats-*
     * tests/stats-test-util.h: Amend tests to succeed

2019-06-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Rewrite Server statistics --stats-server
     
     * fuzz/Makefile.am: Remove ../src/stats_server.o
     * include/wget/wget.h:
       remove wget_server_stats_t,
       rename wget_stats_callback_t -> wget_server_stats_callback_t,
       rename wget_tcp_set_stats_server -> wget_server_set_stats_callback,
       add wget_server_stats_data_t,
       add wget_server_stats_callback_t,
     * libwget/http.c: Remove _stats_data_t,
       add server_stats_callback,
       add server_stats_ctx
     * src/Makefile.am: Remove stats_server.c
     * src/options.c (parse_stats_all): Remove server stats code,
       add stats_callback_server(),
       (init): Add DNS stats code,
       (deinit): Cleanup dns stats code
     * src/stats.c (stats_print_func_t): Remove print_server[],
       remove WGET_STATS_TYPE_SERVER
     * src/stats_server.c: Remove file
     * src/wget_options.h (struct config): Remove stats_server, add stats_server_args
     * src/wget_stats.h: Remove stats_server_opts
     * unit-tests/Makefile.am: Remove ../src/stats_server.o

2019-06-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Rewrite TLS statistics --stats-tls
     
     * fuzz/Makefile.am: Remove ../src/stats_tls.o
     * include/wget/wget.h: Add wget_tls_stats_data_t,
       add wget_tls_stats_callback_t,
       add wget_ssl_set_stats_callback_tls,
       remove WGET_STATS_TYPE_TLS,
       remove wget_tls_stats_t,
       remove wget_tcp_set_stats_tls(),
       remove wget_tcp_get_stats_tls()
     * libwget/ssl_gnutls.c: Remove old stats code, add new stats code
     * libwget/ssl_none.c: Add/remove function stubs
     * libwget/ssl_wolfssl.c: Remove old stats code, add new stats code
     * src/Makefile.am: Remove stats_tls.c
     * src/options.c (parse_stats_all): Remove TLS stats code,
       add stats_callback_tls(),
       (init): Add TLS stats code,
     * src/stats.c (stats_print_func_t): Remove print_tls[],
       remove WGET_STATS_TYPE_TLS
     * src/stats_tls.c: Remove file
     * src/wget_options.h (struct config): Remove stats_tls, add stats_tls_args
     * src/wget_stats.h: Remove stats_tls_opts
     * unit-tests/Makefile.am: Remove ../src/stats_tls.o

2019-06-05 Tim Rühsen <tim.ruehsen@gmx.de>

     Rewrite OCSP statistics --stats-ocsp
     
     * fuzz/Makefile.am: Remove ../src/stats_ocsp.o
     * include/wget/wget.h: Add wget_ocsp_stats_data_t,
       add wget_ocsp_stats_callback_t,
       add wget_ssl_set_stats_callback_ocsp,
       remove WGET_STATS_TYPE_OCSP,
       remove wget_ocsp_stats_t,
       remove wget_tcp_set_stats_ocsp(),
       remove wget_tcp_get_stats_ocsp()
     * libwget/ssl_gnutls.c: Remove old stats code, add new stats code
     * libwget/ssl_none.c: Add/remove function stubs
     * libwget/ssl_wolfssl.c: Remove old stats code, add new stats code
     * src/Makefile.am: Remove stats_ocsp.c
     * src/options.c (parse_stats_all): Remove OCSP stats code,
       add stats_callback_ocsp(),
       (init): Add OCSP stats code,
     * src/stats.c (stats_print_func_t): Remove print_ocsp[],
       remove WGET_STATS_TYPE_OCSP
     * src/stats_ocsp.c: Remove file
     * src/wget_options.h (struct config): Remove stats_ocsp, add stats_ocsp_args
     * src/wget_stats.h: Remove stats_ocsp_opts
     * unit-tests/Makefile.am: Remove ../src/stats_ocsp.o

2019-06-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Rewrite DNS statistics --stats-dns
     
     * fuzz/Makefile.am: Remove ../src/stats_dns.o
     * include/wget/wget.h: Add wget_dns_stats_data_t,
       add wget_dns_stats_callback_t,
       add wget_dns_set_stats_callback,
       remove WGET_STATS_TYPE_DNS,
       remove wget_dns_stats_t,
       remove wget_dns_set_stats(),
       remove wget_dns_get_stats()
     * libwget/dns.c: Remove _stats_data_t,
       amend struct wget_dns_st,
       add wget_dns_set_stats_callback(),
       remove wget_dns_get_stats()
     * src/Makefile.am: Remove stats_dns.c
     * src/options.c (parse_stats_all): Remove DNS stats code,
       add stats_callback_dns(),
       (init): Add DNS stats code,
     * src/stats.c (stats_print_func_t): Remove print_dns[],
       remove WGET_STATS_TYPE_DNS
     * src/stats_dns.c: Remove file
     * src/wget_options.h (struct config): Remove stats_dns, add stats_dns_args
     * src/wget_stats.h: Remove stats_dns_opts
     * tests/stats-test-util.h: Remove "human"
     * unit-tests/Makefile.am: Remove ../src/stats_ocsp.o

2019-05-31 Tim Rühsen <tim.ruehsen@gmx.de>

     Put resolver/dns code into own source file
     
     * docs/Makefile.am: Add libwget-dns.3 man page
     * examples/batch_loader.c: Remove call to wget_tcp_set_dns_timeout()
     * examples/check_url_types.c: Use wget_dns_set_timeout()
     * include/wget/wget.h: Add wget_dns_ API
     * libwget/Makefile.am: Add dns.c
     * libwget/dns.c: New file
     * libwget/init.c: Use wget_dns_set_caching()
     * libwget/net.c: Remove DNS functions
     * libwget/net.h (wget_tcp_st): Add dns member
     * po/POTFILES.in: Add libwget/dns.c
     * src/options.c: Use new DNS API
     * src/stats.c: Add some checks
     * src/stats_dns.c: Use wget_dns_get_stats()

2019-05-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/thread.c: Manually inline wget_get_timemillis() into wget_thread_cond_wait()

2019-05-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Move wget_restrict_file_name() to src/utils.c
     
     * fuzz/libwget_utils_fuzzer.c: Remove test code for wget_restrict_file_name()
     * include/wget/wget.h: Remove wget_restrict_file_name() prototype
     * libwget/utils.c: Remove wget_restrict_file_name()
     * src/utils.c: Add wget_restrict_file_name()
     * src/wget_utils.h: Add wget_restrict_file_name() prototype
     * tests/Makefile.am: Add ../src/utils.c to libtest_la_SOURCES
     * tests/libtest.c: Include ../src/wget_utils.h

2019-06-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix several forgotten xmalloc -> wget_malloc
     
     * libwget/css.c (wget_css_parse_file): Rename xmalloc->wget_malloc
     * libwget/hashfile.c (wget_hash_init): Likewise
     * libwget/ssl_gnutls.c (_cert_verify_hpkp): Likewise
     * libwget/xml.c (wget_xml_parse_file): Likewise

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/hashmap.c (hashmap_rehash): Fix for wget_calloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove xrealloc define for wget_realloc
     
     * libwget/private.h: Remove #define
     * libwget/*.c: Replace xrealloc by wget_realloc

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove xcalloc define for wget_calloc
     
     * libwget/private.h: Remove #define
     * libwget/*.c: Replace xcalloc by wget_calloc

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove xmalloc define for wget_malloc
     
     * libwget/private.h: Remove #define
     * libwget/*.c: Replace xmalloc by wget_malloc

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/vector.c (wget_vector_create): Check result of malloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/thread.c: Check result of malloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/mem.c: Check result of malloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/list.c (wget_list_append): Check result of malloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (wget_iri_parse,wget_iri_clone): Check result of malloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (_server_stats_add): Check result of malloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/cookie.c (wget_cookie_create_request_header): Check result of malloc()

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Add LIBWGET_WARN_UNUSED_RESULT

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Don't ignore wget_malloc() return value
     
     * libwget/test_linking.c: Don't ignore wget_malloc() return value

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     Add G_GNUC_WGET_RETURNS_NONNULL in wget.h
     
     * include/wget/wget.h: Add G_GNUC_WGET_RETURNS_NONNULL
     * src/Makefile.am: Add -DMALLOC_RETURNS_NONNULL
     * src/options.c: Use G_GNUC_WGET_RETURNS_NONNULL for own alloc functions

2019-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/base64.c: Check for malloc failures

2019-06-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Amend buffer functions to handle failed memory allocations
     
     * include/wget/wget.h: wget_buffer_ensure_capacity() returns int
     * libwget/buffer.c (wget_buffer_init): Return NULL if malloc fails,
       (_buffer_realloc): Return error if malloc fails
     * libwget/http.c (wget_http_get_response_cb): Check return value of
       wget_buffer_ensure_capacity()
     * unit-tests/test.c (test_buffer): Add asserts

2019-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Make wget allocation functions overridable function pointers
     
     * include/wget/wget.h: Remove allocation function prototypes,
       add function pointer types and 'extern' globals
     * libwget/private.h: Use wget_free() instead of free()
     * libwget/xalloc.c: Remove function definitions,
       add global function pointer variables
     * src/options.c: Add own allocation functions
     * unit-tests/test.c: Test that function pointers are overridable

2019-06-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change OOM callback implementation

2019-06-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix robots.txt code for stand-alone library API
     
     * fuzz/libwget_robots_parse_fuzzer.c: Amend API call
     * include/wget/wget.h: Amend wget_robots_parse() API
     * libwget/robots.c: Amend wget_robots_parse() API,
       check memory allocations
     * libwget/test_linking_robots.c: New file
     * src/wget.c (process_response): Amend call to wget_robots_parse()
     * unit-tests/test.c (test_robots): Amend call to wget_robots_parse()

2019-06-16 Tim Rühsen <tim.ruehsen@gmx.de>

     Add robots.txt functions, make wget_robots_t opaque

2019-05-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * cfg.mk: Fix syntax-check (bindtextdomain)

2019-06-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Cleanup bitmap API
     
     * wget.h: Add WGET_E_MEMORY = -2,
       amend function interface of wget_bitmap_allocate,
       rename wget_bitmap_allocate -> wget_bitmap_init
     * libwget/bitmap.c: Likewise
     * unit-tests/test.c: Amend bitmap tests appropriate

2019-06-18 Darshit Shah <darnir@gnu.org>

     * gnulib: Update gnulib

2019-06-15 Darshit Shah <darnir@gnu.org>

     Don't check for always true headers
     
     * cfg.mk: Enable checking for always_true_header_tests
     * libwget/http.c,net.c,ssl_gnutls.c: Don't check for HAVE_SYS_SOCKET_H.
       The gnulib module always provides it.
     * libwget/ssl_gnutls.c: Don't check for HAVE_SYS_UIO_H. The gnulib
       module always provides it.
     * bootstrap.conf: Add header sys_uio
     * configure.ac: Remove check for sys/uio.h

2019-06-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Add sc_prohibit_sprintf and sc_prohibit_printf and fix code
     
     * cfg.mk: New syntax rules sc_prohibit_sprintf and sc_prohibit_printf
     * fuzz/*.c: Apply rules
     * libwget/*.c: Likewise
     * src/*.c: Likewise
     * tests/*.[ch]: Likewise
     * unit-tests/*.c: Likewise

2019-06-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: #define wget_printf()

2019-06-15 Darshit Shah <darnir@gnu.org>

     * cfg.mk: Our makefiles make judicious use of $<, skip the check

2019-06-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Add gnulib module arpa_inet
     
     On Debian unstable, after updating gnulib there was:
     
     In file included from ../lib/arpa/inet.h:46,
                      from ip.c:27:
     /usr/include/arpa/inet.h:34:8: error: unknown type name 'in_addr_t'
      extern in_addr_t inet_addr (const char *__cp) __THROW;

2019-06-15 Darshit Shah <darnir@gnu.org>

     * bootstrap: Patch script to use the python tool

2019-06-15 Darshit Shah <darnir@gnu.org>

     * bootstrap: Update the bootstrap script from gnulib

2019-06-15 Darshit Shah <darnir@gnu.org>

     * gnulib: Update gnulib

2019-06-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Fix --https-enforce=hard for metalink

2019-06-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Make read_xattr_metadata() easier and safer to use

2019-06-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix -nc/--no-clobber
     
     * src/wget.c: New function parse_local_file(),
       (add_url_to_queue): Parse local file if needed,
       (add_url): Likewise
     
     Closes #451

2019-06-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Moev _fix_broken_server_encoding() outside HTTP/2 code

2019-06-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c: Fix call to _fix_broken_server_encoding() for HTTP/2

2019-06-06 Tim Rühsen <tim.ruehsen@gmx.de>

     Add --http2-only to resist on HTTP/2
     
     * docs/wget2.md: Document --http2-only
     * libwget/ssl_gnutls.c (wget_ssl_open): Error if server doesn't accept h2
     * src/options.c: Add --http2-only
     * src/wget_options.h: Add config.http2_only

2019-06-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Fix WolfSSL CI runner

2019-06-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Add WITH_TLS as define and conditional
     
     * configure.ac: Add WITH_TLS as define and conditional
     * tests/libtest.c: Use WITH_TLS for conditional code

2019-06-04 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-post-handhshake-auth.c: Check for WITH_GNUTLS

2019-05-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c: Enable SSL/TLS tests for WolfSSL

2019-05-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-i-https.c: Skip CRL test for WolfSSL

2019-05-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_wolfssl.c (wget_ssl_open): Fix return code for testing

2019-05-01 Tim Rühsen <tim.ruehsen@gmx.de>

     Add SSL/TLS engine 'none'
     
     * libwget/Makefile.am: Add building ssl_none.c
     * libwget/ssl_gnutls.c: Remove #ifdef WITH_GNUTLS
     * libwget/ssl_wolfssl.c: Likewise
     * libwget/ssl_none.c: Stub routines for 'no SSL/TLS support'

2019-05-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci-yml: Test WolfSSL build on Debian Unstable

2019-04-12 Tim Rühsen <tim.ruehsen@gmx.de>

     WolfSSL: Add ALPN and thus HTTP/2
     
     * libwget/ssl_wolfssl.c (wget_ssl_init): Fix setting minimal TLS version,
       (wget_ssl_open): Set ALPN for HTTP/2, add result to statistics

2019-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

     Initial implementation of WolfSSL as TLS backend
     
     * README.md: Mention WolfSSL
     * configure.ac: Check for WolfSSL
     * libwget/Makefile.am: Conditionally add WolfSSL to libwget
     * libwget/ssl_wolfssl.c: New file with WolfSSL implementation
     * po/POTFILES.in: Add libwget/ssl_wolfssl.c
     
     ./configure --without-gnutls --with-wolfssl

2019-05-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * .travis.sh: Set gettext version to 0.18.2

2019-05-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Publish tarball via Gitlab CI
     
     * .gitlab-ci.yml: Create https://gnuwget.gitlab.io/wget2/wget2-latest.tar.gz
     * README.md: Instruction to download and build wget2 from tarball

2019-05-24 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Explicitly set source_base and test_base

2019-05-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Update spell-checker and fix more typos
     
     * contrib/spell-checker: Update to python3 version of codespell
     * libwget/robots.c: Fix typo(s)
     * src/plugin.c: Likewise
     * src/wget_plugin.h: Likewise
     * tests/test-plugin-nonexistance.c: Likewise

2019-05-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * po/.gitignore: Update

2019-05-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Work around VPATH issue

2019-05-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/main.c: Fix paths for WIN32

2019-05-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Update gettext version to 0.19.3

2019-05-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix checks to include C11 threads.h
     
     * configure.ac: Check for threads.h
     * libwget/ssl_gnutls.c: Add check for HAVE_THREADS_H

2019-05-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c: Fix position of _Thread_local

2019-05-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/bar.c: Replace sprintf/snprintf by wget_ functions

2019-05-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/thread.c: Remove #include timespec.h

2019-05-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap: Fallback to gnulib-tool if python version errors

2019-05-10 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c: Use thread-safe ctime() replacement

2019-05-06 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Silence gcc-9 -Wchkp

2019-04-29 sebma <sebma@users.noreply.github.com>

     Test if doxygen OR pandoc is present to build the docs
     
     * configure.ac: Logically split checking for doxygen and pandoc
     
     Copyright-paperwork-exempt: Yes

2019-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new option --unlink
     
     * bootstrap.conf: Add gnulib module 'link'
     * docs/wget2.md: Remove the 'unimplemented' tag for --unlink
     * src/options.c: Add --unlink option
     * src/wget.c (_prepare_file): Unlink file if requested
     * src/wget_options.h (struct config): Add 'unlink' member
     * tests/Makefile.am: Add test-unlink
     * tests/libtest.c (wget_test): Implement hardlink feature
     * tests/libtest.h (wget_test_file_t): Add 'hardlink' member
     * tests/test-unlink.c: New file with tests for --unlink

2019-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c: Fix memleaks from XDG and homedir functions

2019-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (get_config_files): Fix memleaks

2019-04-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/wget2.md: Mark unimplemented options with '[Not implemented yet]'

2019-04-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-limit-rate.c: Increase tolerance from 200 to 500 ms
     
     Valgrind tests on Travis needed the higher value

2019-04-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/wget_options_fuzzer.c: Slightly change magic number
     
     Libfuzzer is too clever and detects the magic number used in the fuzzer.
     This leads to weird behavior and false positives.

2019-04-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/*.in: Update fuzz corpora from OSS-fuzz

2019-04-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/get_ossfuzz_corpora: mkdir *.in directories

2019-04-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/get_ossfuzz_corpora: Remove -f from unzip

2019-04-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/iri.c (_iri_unescape_inline): Fix integer overflow (harmless)

2019-04-18 Kumar Mallikarjuna <kumarmallikarjuna1@gmail.com>

     Add TLS 1.3 post-handshake authentication
     * tests/Makefile.am: Loading post-handshake-auth test
     * tests/libtest.c:
     Added execution of 'WGET_TEST_POST_HANDSHAKE_AUTH' key.
     Value: other than 0 (Check for post handshake authentication)
     Value: 0 (Don't check)
     * tests/libtest.h: Defined 'WGET_TEST_POST_HANDSHAKE_AUTH'
     * tests/test-post-handhshake-auth.c: Added to test post handshake authentication support

2019-04-24 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix heap buffer overflow introduced in previous commit
     
     * libwget/iri.c (_iri_unescape_inline): Add missing 'continue'
     
     Found by OSS-FUZZ (Issue 14428)

2019-04-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Add basic HTML entity decoding
     
     * libwget/iri.c (_iri_unescape_inline): Decode basic HTML entities
     * tests/test-base.c: Add test for &amp;, #ddd; and #xHH;
     
     This only cares for the basic HTML entities mentioned in RFC1866.
     This commit closes Gitlab issue 44, though it is not a full handling
     of entities. But not sure if anyone ever requests it.
     
     Fixes #44

2019-04-22 Rohan Fletcher <rohfle@gmail.com>

     Added tests for limit-rate
     
     * tests/test-limit-rate.c: new test file for limit-rate
     * tests/Makefile.am: added tests/test-limit-rate.c to build

2019-04-22 Rohan Fletcher <rohfle@gmail.com>

     Progress bar speed now calculated earlier
     
     * libwget/bar.c: added ring_used to _bar_slot_t.
       speed calculations now use the first slot while the ring is filling

2019-04-20 Rohan Fletcher <rohfle@gmail.com>

     Added limit-rate feature (#408)
     
     * src/options.c: new --limit-rate command-line args
     * src/wget_options.h: new config variable for limit-rate cli arg
     * src/wget.c: new limit_transfer_rate function. Added limit rate state
       vars to struct _body_callback_context
       (_get_body): add call to limit_transfer_rate when limit-rate enabled
       (http_send_request): init limit rate state vars

2019-04-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix parsing float values for CLI options
     
     * src/options.c: New function _parse_double_modifier(),
       (parse_numbytes): use _parse_double_modifier() instead of sscanf(),
       (parse_timeout): Likewise
     
     Fixes #432

2019-03-21 Kumar Mallikarjuna <kumarmallikarjuna314@gmail.com>

     Fix for -p -nc Bug
     
     * src/wget.c: Modified to stop redownload if document already exists
     * tests/test-p-nc.c: Added test for '-p -nc'
     * tests/Makefile.am: Modified to include test-p-nc.c while testing.
     
     Fixes #209

2019-04-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Add Kumar Mallikarjuna [ci skip]

2019-04-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Use buildenv-fedora for FEDORA_BUILD

2019-04-18 Tim Rühsen <tim.ruehsen@gmx.de>

     Change /builds/common to @@HOMEBREW_PREFIX@@

2019-04-15 Kumar Mallikarjuna <kumarmallikarjuna314@gmail.com>

     Fix for --stats-all not working
     * src/options.c: Modified 'parse_stats_all()' for 'val' to be non-null.

2019-04-14 Tim Rühsen <tim.ruehsen@gmx.de>

     Add TCP FastOpen Linux 4.11+ style
     
     * libwget/net.c: #define TCP_FASTOPEN_LINUX_411,
       (_set_socket_options): Set TCP_FASTOPEN_CONNECT socket option,
       (wget_tcp_connect): Add code for Linux 4.11+

2019-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mingw: Move WINPATH further up

2019-04-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mingw: Fix pkg-config and gnutls

2019-04-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/spell-checker: Fix for 'te' in example URL

2019-04-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Skip blacklisting URLs from STDIN + tty
     
     * src/wget.c: Add URL_FLG_NO_BLACKLISTING,
       (add_url_to_queue): New param 'flags', skip blacklisting
       when URL_FLG_NO_BLACKLISTING is given,
       (input_thread): Add description, use URL_FLG_NO_BLACKLISTING
     
     This change allows us to use interactive services like
      (b="http://te.ttr.is:8003"; echo $b; \
       while read -sN1 a; do echo "$b/$a"; done) | wget2 --input-file=- -qO-
     (h,j,k,l = left, down, turn, right; ctrl-c = stop)

2019-04-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (input_thread): Fix communication with main thread

2019-03-31 Darshit Shah <darnir@gnu.org>

     Add Last-Modified and Content-Type to CSV stats
     
     * src/stats_site.c(struct site_stats_t): Add members last_modified and
     mime_type to store the last modified time and content-type respectively
     (stats_site_add): Store the mime type and last modification time of the
     file into the stats
     (free_stats): Free the heap-allocated mime_type field
     (print_csv): Add columns for last-modified and content-type to CSV
     header
     (print_csv_entry): Add the data for the above two columns

2019-03-26 Darshit Shah <darnir@gnu.org>

     Support XDG Desktop Specification for config files
     
     Adds functionality to Wget2 to support the XDG Base Directory
     Specification[1]. Also marks as deprecated the old location of the
     config file.
     
     * docs/wget2.md: Explicitly mark `$HOME/.wget2rc` as deprecated.
     * po/potfiles.in: utils.c now has a translateable stirng
     * src/options.c(read_config): Use bool instead of int
     (get_config_files): Now takes config_home and user_home as input.
     `user_home` is only temporary and will be removed once support for
     ~/.wget2rc is removed.
     (get_xdg_data_home): Derives the location where the data files are to be
     stored according to [1].
     (get_xdg_config_home): Derives the location where the config files are
     to be stored according to [1].
     (init): Store all the data files in $XD_DATA_HOME
     * src/wget.c(mkdir_path): Move function to utils.c
     * src/utils.c(mkdir_path): Move function from wget.c. Can now handle
       both file and directory paths.
     * src/utils.h: Add declaration for mkdir_path
     
     [1]: https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html

2019-02-16 Darshit Shah <darnir@gnu.org>

     Improve handling of initialization files
     
     * docs/wget2.md: Add section on initialization files and the order in
     which they are read.
     * src/options.c(struct config config): Set system_config to the default
     value of "SYSCONFDIR/wget2rc"
     (struct optionw): --config now maps to config.user_config and update the
     value of the default path
     (read_config): Read the configuration for system and user configs, if
     they're set
     (get_config_files): New function that sets the values for
     config.system_config and config.user_config. For the system config it
     picks either the file in `$SYSTEM_WGET2RC` or at
     `@@HOMEBREW_PREFIX@@/etc/wget2rc`. For the user config, it picks the first file from
     `--config`, `$WGET2RC`, `$XDG_CONFIG_HOME/wget/wget2rc`,
     `~/.config/wget/wget2rc` or `$HOME/.wget2rc`.
     (init): Remove the code for finding all the config files and move it to
     `get_config_file`.
     (deinit): Free config.user_config and config.system_config. Remove
     config.config_files.
     * src/wget_options.h(struct config): New char * user_config and
     system_config. Remove config.config_files

2019-02-16 Darshit Shah <darnir@gnu.org>

     Get system wget2rc file
     
     * src/Makefile.am: Don't create a separate directory for Wget2 in
     SYSCONFDIR
     * src/options.c: If SYSTEM_WGET2RC is not set, then try to read the
     global Wget2rc from SYSCONFDIR

2019-03-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/encoding.c (wget_str_to_ascii): Use IDN2_USE_STD3_ASCII_RULES
     
     We convert hostnames and thus have to apply IDN2_USE_STD3_ASCII_RULES.
     If we don't do, the result could contain any ascii characters,
     e.g. 'evil.c\u2100.example.com' will be converted into
     'evil.ca/c.example.com', which seems no good idea.

2019-02-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/libwget_http_client_fuzzer.c: Fix for OpenBSD

2019-02-16 Darshit Shah <darnir@gnu.org>

     * docs/wget2.md: Fix typo in identation of --dns-cache

2019-02-16 Darshit Shah <darnir@gnu.org>

     * Pull gnulib forward

2019-02-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/wget2.md: Correct --logfile -> --output-file

2019-01-23 Leon Klingele <git@leonklingele.de>

     * docs/wget2.md: --no-cache also sets the 'Cache-Control: no-cache' header
     
     Copyright-paperwork-exempt: Yes

2019-01-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Don't enable valgridn tests for Arch runner

2019-01-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Do not call pacman -Q

2019-01-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Prerequisite 'rsync' removed

2019-01-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix YAML syntax error

2019-01-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Add Debian Testing CI runner

2019-01-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Really use Arch runner in CI

2019-01-04 Tim Rühsen <tim.ruehsen@gmx.de>

     * unit-tests/test.c (test_stringmap): Fix warning (shadowed variable)

2019-01-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix hashmap + stringmap docs
     
     * include/wget/wget.h: Add docs for hashmap/stringmap typedefs,
       fix argument of wget_hashmap_iterator_free()
     * libwget/hashmap.c: Add docs, fix wget_hashmap_iterator_free()
     * libwget/stringmap.c: Add docs
     * unit-tests/test.c: Fix call to wget_stringmap_iterator_free()

2019-01-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Add iterators for hashmap and stringmap
     
     * include/wget/wget.h: New functions wget_hashmap_iterator_alloc(),
       wget_hashmap_iterator_free(), wget_hashmap_iterator_next(),
       also for stringmap.
     * libwget/hashmap.c: Implementation of the above functions
     * libwget/stringmap.c: Add wget_stringmap_iterator_next()
     * unit-tests/test.c: Add tests using stringmap iterator
     
     This functionality is sometimes more handy than the *_browse() API
     with callback functions and context variables.

2019-01-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_add_credentials): Code cleanup

2019-01-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename container set functions
     
     * include/wget/wget.h:
       rename wget_vector_set_growth_policy() to wget_vector_set_resize_factor(),
       rename wget_hashmap_set_growth_policy() to wget_hashmap_set_resize_factor(),
       rename wget_hashmap_setloadfactor() to wget_hashmap_set_load_factor(),
       rename wget_stringmap_setloadfactor() to wget_stringmap_set_load_factor(),
       rename wget_stringmap_set_growth_policy() to wget_stringmap_set_resize_factor().
     * libwget/hashmap.c: Likewise
     * libwget/stringmap.c: Likewise
     * libwget/vector.c: Likewise

2019-01-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Simplify hasmap/stringmap/vector API
     
     * include/wget/wget.h: Remove wget_hashmap_get_null() and
       wget_stringmap_get_null(),
       change params and return value of wget_hashmap_get() and
       wget_stringmap_get().
     * libwget/hashmap.c: Remove wget_hashmap_get_null(),
       change params and return value of wget_hashmap_get(),
       simplify hashmap_find_entry().
     * libwget/stringmap.c: Remove wget_stringmap_get(),
       change params and return value of wget_stringmap_get().
     * libwget/dns_cache.c: Amend for new API
     * libwget/hpkp.c: Likewise
     * libwget/hsts.c: Likewise
     * libwget/http.c: Likewise
     * libwget/netrc.c: Likewise
     * libwget/ocsp.c: Likewise
     * libwget/tls_session.c: Likewise
     * src/host.c: Likewise
     * src/options.c: Likewise
     * src/plugin.c: Likewise
     * src/stats_site.c: Likewise
     * unit-tests/test.c: Likewise

2019-01-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Use float for container growth policy
     
     * include/wget/wget.h: Use float for *_set_growth_policy()
     * libwget/hashmap.c: Use float for wget_hashmap_set_growth_policy()
     * libwget/stringmap.c: Use float for wget_stringmap_set_growth_policy()
     * libwget/vector.c: Use float for wget_vector_set_growth_policy()
     
     Additionally, the +/- logic has been reversed in the above functions.

2019-01-02 Tim Rühsen <tim.ruehsen@gmx.de>

     Update copyrigght to 2019

2019-01-02 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/version-text.h.in: Use ASCII only chars

2018-12-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix xattr behavior (CVE-2018-20483)
     
     * src/options.c (config): Disable --xattr by default
     * src/wget.c (set_file_metadata): Store origin URL without user/pw,
       store referer just as scheme/host/port

2018-12-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Spell check

2018-12-28 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix typos found by contrib/spell-checker

2018-12-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/spell-checker: Add script for spell checking

2018-12-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/Makefile.am: Fix order of libraries for linking [skip ci]

2018-12-27 Rafael Fontenelle <rafaelff@gnome.org>

     Fix misspellings

2018-12-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * README.md: Add libzstd as optional dependency

2018-12-25 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/utils.c: Cleanup wget_match_tail(_nocase)

2018-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-redirection.c: Add test for Location URI with spaces in filename

2018-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Allow 3xx for redirection

2018-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (src/wget.c): Small code cleanups

2018-12-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http_parse.c (wget_http_parse_location): Being more lenient
     
     Some servers don't percent encode the URI in a Location: header.
     Having spaces in the URI leads to magled file names and likely 404.
     
     Fixes #420

2018-12-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Handle ldconfig for unprivileged users

2018-12-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Call 'ldconfig' at the end of 'make install'

2018-12-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Revert "Fix -k/--convert-links"
     
     This reverts commit 89ff57ee937e6c70d3927c00a9dda75f33947238.
     
     The commit fixed a bug by generating a regression at another place.
     See https://gitlab.com/gnuwget/wget2/issues/415#note_124641970

2018-12-12 Tim Rühsen <tim.ruehsen@gmx.de>

     libwget/http.c (wget_http_add_credentials): Compare case independent
     
     Fixes an issue with MHD 9.62 that uses a lowercase 'md5' string.

2018-12-03 Leif Ryge <leif@synthesize.us>

     * docs/wget2.md: Fix typo s/exists/exits
     
     Copyright-paperwork-exempt: Yes

2018-11-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget_xattr.h: Fix getxattr args on OSX/FreeBSD

2018-11-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/Makefile.am: Do remove css_tokenizer.c with 'make clean'

2018-11-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/check_options: Exit if not run in bash

2018-11-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add CI tarball build on basic Alpine

2018-11-17 Darshit Shah <darnir@gnu.org>

     Fix VPATH build broken in earlier commit
     
     * tests/Makefile.am: Add new file plugin_tests.h to DIST Files
     * tests/plugin_tests.h: Use BUILDDIR not SRCDIR for .libs location

2018-11-14 Darshit Shah <darnir@gnu.org>

     Fix bug in dns_cache_preload
     
     * src/options.c(options): --dns-cache-preload does expect a value. It is
     not an option.

2018-11-14 Darshit Shah <darnir@gnu.org>

     Use a common header file to deduplicate plugin test boilerplate
     
     * tests/test_plugin.h: Add the OBJECT_DIR and other defines in a single
     common file for all plugin tests
     * tests/test-plugin*.c: Remove boilerplate code and include
     "test_plugin.h"

2018-11-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/wget2.md: Ad -r to example for --filter-mime-type [skip ci]

2018-10-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Use extended file attributes for server's file timestamp
     
     * src/wget_xattr.h: Add fgetxattr definitions (Linux, Apple, FreeBSD)
     * src/wget.c (set_file_metadata): Save "user.last_modified" attribute,
      (read_xattr_metadata): Add function,
      (write_xattr_metadata): Cleanup code,
      (http_create_request): Get timestamp from xattr if available

2018-10-16 Josef Moellers <jmoellers@suse.de>

     Handle wide characters in download progress bar
     
     * bootstrap.conf: Add gnulib module 'wcwidth'
     * libwget/bar.c: New function inspect_multibyte(),
       (_bar_update_slot): Make use of inspect_multibyte()

2018-10-31 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (init): Avoid error msg if HSTS preload file isn't given

2018-10-31 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix -k/--convert-links
     
     When different URLs result in the same local file so that
     -k converts a file several times, that file becomes corrupted.
     
     This commit fixes it and adds a test case.
     
     Reported-by: rgpublic on Gitab.com
     Fixes #411

2018-10-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Add valgrind suppressions for TravisCI (due to old libidn)
     
     * fuzz/valgrind-suppressions: Add suppression
     * tests/valgrind-suppressions: Add suppression

2018-10-19 Tim Rühsen <tim.ruehsen@gmx.de>

     Suppress some leaks detected by valgrind in fuzz/
     
     * fuzz/main.c: Use --suppressions and --gen-suppressions
     * fuzz/valgrind-suppressions: New suppression file
     
     Some library's memory can't be freed. So we suppress what is needed
     to let the CIs survive.

2018-10-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/*_fuzzer.in/*: Update fuzzer copora from OSS-Fuzz

2018-10-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/get_ossfuzz_corpora: Use faster corpus download from OSS-Fuzz

2018-10-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitignore: Add fuzz/*_fuzer.new directories

2018-10-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (deinit): Free config.accept_regex and config.reject_regex

2018-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/csv2tree: Remove superfluous 'import json' [skip ci]

2018-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Fix documentation of HPKP return values

2018-10-18 Tim Rühsen <tim.ruehsen@gmx.de>

     * .lgtm.yml: Classify test directories

2018-10-18 Darshit Shah <darnir@gnu.org>

     Fix progress bar display in VTE Terminals
     
     GNOME VTE removed support for VT-100 sequences to save and restore
     cursor position that libwget progress display was using. Their suggested
     approach is to use the DECSC/DECRC sequences from VT-520 instead of the
     SCOSC/SCORC sequences from VT-100. Since the DECSC/DECRC sequences are
     also supported by all other terminal emulators, we make the switch here
     in order to suport VTE emulators as well.
     Upstream Report: https://gitlab.gnome.org/GNOME/vte/issues/48
     
     * libwget/bar.c(_bar_print_slot): Use ESC 7 (DECSC) instead of CSI s (SCOSC)
     (wget_bar_write_line): Same
     (_restore_cursor_position): Use ESC 8 (DECRC) instead of SCI u (SCORC)

2018-10-17 Darshit Shah <darnir@gnu.org>

     * benchmarks/benches/convert.gp: Add generated file warning
     
     [ci skip]

2018-10-14 Darshit Shah <darnir@gnu.org>

     Remove old benchmark scripts
     
     * benchmarks/bench_https_*: Deleted. Superceded by new scripts
     * benchmarks/benchmark.sh: Deleted. Superceded by new scripts
     * benchmarks/new_benchmark.sh: Renamed to benchmark.sh
     
     [ci skip]

2018-10-14 Darshit Shah <darnir@gnu.org>

     Add a small harness for Benchmarking code
     
     [ci skip]
     This set of script works through the new_benchmark.sh script.
     I've tried to keep everything modular, extensible and clean.
     
     * benchmarks/new_benchmark.sh: New benchmark harness
     * benchmarks/sources/*.bench.sh: Program specification files
     * benchmarks/benches/http{1,2}.sh: Benchmark specification files
     * benchmarks/benches/convert.gp: A gnuplot script to convert the 2
     column data into four columns for making the errorbars plot

2018-10-16 Darshit Shah <darnir@gnu.org>

     * .gitignore: Ignore version-text.h, a generated file

2018-10-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * .lgtm.yml: Exclude unit-tests/files

2018-08-17 jmoellers <jmoellers@suse.de>

     Fix issue with the number of bytes downloaded vs accounted for in the progress bar.
     
     * include/wget/wget.h(wget_bar_slot_begin): Now accepts another
     parameter, `new_file`.
     * libwget/bar.c(wget_bar_slot_begin): Support `new_file` parameter.
     Allows calling mehod multiple times for the same file.
     * src/bar.c(bar_slot_begin): Same
     * src/wget_bar.h: Same
     * src/wget.c(_get_body): Pass only the difference (number of bytes
     actually downloaded since last call) to the progress routines

2018-08-17 jmoellers <jmoellers@suse.de>

     Fix a bug in HTTP/2 downloads that caused incorrect progress display
     
     * libwget/bar.c(wget_bar_slot_begin): Display filename when only 1 file
     per slot. Else, display total number of files in that slot.
     (wget_bar_slot_downloaded): The length now represents an incremental
     value, not the absolute number of bytes.
     * src/wget.c(_get_body): Same.

2018-10-14 Darshit Shah <darnir@gnu.org>

     * .gitlab-ci.yml: Skip downloading po files during bootstrap

2018-10-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (deinit): Free config.hsts_preload_file

2018-10-13 Darshit Shah <darnir@gnu.org>

     * bootstrap: Update script from gnulib

2018-10-13 Darshit Shah <darnir@gnu.org>

     Update gnulib

2018-10-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Use rm -f to avoid error messages

2018-10-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Add copyright,license and mailing list info to --version
     
     * configure.ac: Add creating src/version-text.h from .in file
     * src/Makefile.am: Add version-text.h to wget2_SOURCES
     * src/options.c (print_version): Print text from version-text.h
     * src/version-text.h.in: New template file

2018-10-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Add zstd decompression (RFC8478)
     
     * README.md: Mention zstandard
     * configure.ac: Check for libzstd
     * docs/wget2.md: Document new --compression type
     * include/wget/wget.h: Add wget_content_encoding_zstd
     * libwget/decompressor.c: Implement the zstd decompressor
     * libwget/http_parse.c (wget_http_parse_content_encoding): Add zstd
     * src/options.c (print_version): Add +/-zstd for --version,
       (parse_compression): Check for wget_content_encoding_zstd,
       (options): Add zstd to help text
     * src/wget.c (http_create_request): Add zstd to Accept-Encoding:
     * tests/test-compression.c: Add test for zstd

2018-09-22 Darshit Shah <darnir@gnu.org>

     Remove support for libunistring and libidn2 < 0.14
     
     * configure.ac: Remove support for libidn2 < 0.14 and libunistring
     * libwget/encoding.c: Same
     * README.md: Same

2018-10-09 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/test-include-and-exclude-directories.c: Use double quote

2018-08-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/libtest.c (_answer_to_connection): Fix check for non-200 status codes

2018-07-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Add option --save-content-on
     
     * docs/wget2.md: Add docs for --save-content-on
     * src/options.c (options): Add "save-content-on"
     * src/wget.c:
     * src/wget_options.h (struct config): Add save_content_on member
     * tests/Makefile.am: Add tests/test--save-content-on.c
     * tests/test--save-content-on.c: New test file

2018-10-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Add support for Chromium's HSTS Preload List
     
     * README.md: Add libhsts as optional dependency
     * configure.ac: Add test for libhsts
     * docs/wget2.md: Add text for --hsts-preload and --hsts-preload-file
     * libwget/init.c:
     * src/options.c (print_version): Add +/-hsts for --version,
       (options): Add --hsts-preload and --hsts-preload-file,
       (init): Load the HSTS peload list,
       (deinit): Unload the HSTS preload list
     * src/wget.c (try_connection): Eventually change http to https
     * src/wget_options.h (config): Add hsts_preload and hsts_preload_file

2018-10-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * README.md: Add libpcre + libpcre2 as optional deps [skip ci]

2018-09-28 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (add_url): Fix -H / --span-hosts

2018-09-25 DalmeGNU <dalmemail@gmail.com>

     * docs/wget2.md: Fixed broken link on guide index
2018-09-23 Darshit Shah <darnir@gnu.org>

     * tests/valgrind-suppressions: Suppress issues from GPGME library

2018-09-21 Darshit Shah <darnir@gnu.org>

     * src/wget.c (process_response): Just an aesthetic improvement to the code

2018-09-21 Darshit Shah <darnir@gnu.org>

     Ensure that robots.txt is honoured even with -c
     
     There was a bug that prevented the robots.txt from being parsed when
     resuming an incomplete download. This would cause the robots rules to
     not be honoured when resuming a broken download.
     
     * src/wget.c (process_response): Move the robots check out of the
     conditional, so it runs in all valid cases
     (http_create_request): In case -c has been passed and we see an existing
     robots.txt, remove it. As a result, we will always download a fresh
     copy of the robots.txt file
     * tests/test-robots.c: Add a new test to ensure the robots file is
     always being parsed

2018-08-24 Darshit Shah <darnir@gnu.org>

     Add some debug messages when a URI is not added to queue
     
     * src/wget.c: Likewise
     * src/blacklist.c: Likewise

2018-09-21 Darshit Shah <darnir@gnu.org>

     Minor changes to the commit-check script

2018-09-19 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Fix searching for libpcre2

2018-09-19 DalmeGNU <dalmemail@gmail.com>

     Add Building with alternate GnuTLS version doc

2018-09-16 DalmeGNU <dalmemail@gmail.com>

     Add URL Encoding documentation

2018-09-16 DalmeGNU <dalmemail@gmail.com>

     Update TestSuite.md & fix pipeline

2018-09-16 DalmeGNU <dalmemail@gmail.com>

     Add test suite documentation

2018-09-14 DalmeGNU <dalmemail@gmail.com>

     Add Contributing Guide

2018-09-14 DalmeGNU <dalmemail@gmail.com>

     Add OptionHandling documentation

2018-09-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/options.c (options): List all TLS options for --secure-protocol

2018-09-16 Ander Juaristi <a@juaristi.eus>

     Fix SSL/TLS Doxygen documentation

2018-09-16 Ander Juaristi <a@juaristi.eus>

     Update AUTHORS file

2018-09-15 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/commit-check: Add support for companies (e.g. redhat.com)

2018-08-31 DalmeGNU <dalmemail@gmail.com>

     Update documentation about how to add a new command line option
     
     * src/options.c: Update comments on how to add a new option
     * docs/faq.md: Document how to add a new CLI-option

2018-09-01 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix buffer overflow in -X/-I parsing
     
     * src/options.c (set_char_prefix): Fix backslash handling
     * fuzz/wget_options_fuzzer.in/: Add reproducer
     
     This bug was introduced yesterday by commit
     756e470de942ec830a9a424a2340b7e986e9fe7c
     
     Found by oss-fuzz (issue 10163).

2018-09-01 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix buffer overflow in -X/-I parsing
     
     * src/options.c (set_char_prefix): Fix scratch buffer size
     * fuzz/wget_options_fuzzer.in/: Add reproducer
     
     This bug was introduced yesterday by commit
     756e470de942ec830a9a424a2340b7e986e9fe7c
     
     Found by oss-fuzz (issue 10159).

2018-04-10 Dan <dalmemail@gmail.com>

     Add -X/--exclude-directories and -I/--include-directories
     
     * docs/wget2.md: Add docs for -I/--include-directories=list
       and -X/--exclude-directories=list
     * src/options.c: New function _strchrnul_esc(),
       new function _strmemdup_esc(),
       (parse_stringlist_expand): Use new functions from above,
       new function set_char_prefix(), parse_included_directories()
       and parse_excluded_directories,
       (options): add exclude-directories and --include-directories
     * src/wget.c: New functions match_subdir() and in_directory_pattern_list(),
       (add_url): check if path matches directory patterns,
       (_prepare_file): add new param 'path',
     * src/wget_options.h (struct config): Add member 'exclude_directories'
     * tests/Makefile.am: Add 'test-include-and-exclude-directories'
     * tests/test-include-and-exclude-directories.c: New file

2018-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     Rename --dns-caching to --dns-cache (Wget1.x compatibility)
     
     * docs/wget2.md: --dns-caching -> --dns-cache
     * src/options.c (options): Likewise

2018-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/Makefile.am: Add README.md to DISTCLEANFILES

2018-08-29 Tim Rühsen <tim.ruehsen@gmx.de>

     Improve online documentation
     
     * README.md: Move some dev info to faq.md
     * docs/Makefile.am: Generate introduction from README.md
     * docs/faq.md: Started with User and Dev sections
     * docs/libwget.doxy.in: Remove mainpage, use README.md instead
     * docs/mainpage.md: Remove
     * docs/wget2.md: Amended intro to options that take lists

2018-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/libwget_base64_fuzzer.c: Silence scan-build

2018-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     Document wget_base64_get_(en|de)coded_length() and move to base64.c
     
     * include/wget/wget.h: Declare both function as pure
     * libwget/base64.c: Add both functions incl. documentation,
       (wget_base64_decode_alloc): Remove hard-coded calculation,
       (wget_base64_encode_alloc): Likewise.
     * libwget/tls_session.c (_tls_session_save):
       Use wget_base64_get_encoded_length() instead hard-coded calculation
     * fuzz/libwget_base64_fuzzer.c:
       Avoid both functions to be optimized out

2018-08-21 Tim Rühsen <tim.ruehsen@gmx.de>

     * po/POTFILES.in: Add libwget/error.c

2018-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c: Set tries to 1 on HTTPS errors when built without TLS support

2018-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/gpgme.c (_verify_detached_sig): Return WGET_E_GPG_VER_FAIL on signatue failure

2018-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     New function wget_strerror()
     
     * docs/Makefile.am: Add man page build for error functions
     * include/wget/wget.h: Make WGET_E_* an enum wget_error_t,
       declare new function wget_strerror()
     * libwget/Makefile.am: Add error.c
     * libwget/error.c: New file

2018-08-17 Darshit Shah <darnir@gnu.org>

     * src/wget_options.h: Add the const qualifier to valid options

2018-08-17 Darshit Shah <darnir@gnu.org>

     * libwget/http.c(_print_frame_type): Don't print anything when frame type is DATA

2018-08-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Add base64 URL/file safety
     
     * include/wget/wget.h: Add wget_base64_urlencode()
     * libwget/base64.c: New function wget_base64_urlencode(),
       new function _wget_base64_encode(),
       (base64_2_bin): add charactes '-' and '_'.

2018-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Fix name of Josef Möllers

2018-08-16 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/commit-check: Don't check the name
     
     The name can't easily be used as an identifier.
     E.g. my name is different through commits: 'Tim Ruehsen' or 'Tim Rühsen'
     
     Checking the email address used for the FSF assignment is enough.

2018-08-16 Darshit Shah <darnir@gnu.org>

     * AUTHORS: Josef Moellers has copyrights assigned
     
     [skip ci]

2018-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * Makefile: Perform checks in check-local unconditionally

2018-08-14 Tim Rühsen <tim.ruehsen@gmx.de>

     * Makefile.am: Fix local-check for VPATH build

2018-08-12 Darshit Shah <darnir@gnu.org>

     * Makefile.am: Make check-local fail on error

2018-08-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * AUTHORS: Add Aniketh Gireesh

2018-08-08 Tim Rühsen <tim.ruehsen@gmx.de>

     * docs/wget2.md: Add description for --dns-caching

2018-08-08 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new option --dns-cache-preload
     
     * include/wget/wget.h: New function wget_tcp_dns_cache_add()
     * libwget/dns_cache.c (wget_dns_cache_add): Fix docs
     * libwget/net.c (_wget_tcp_resolve): Changed params,
       new function wget_tcp_dns_cache_add()
     * src/options.c (options): Add --dns-cache-preload,
       new function _preload_dns_cache(),
       (init): Call _preload_dns_cache()
     * src/wget_options.h (struct config): Add member dns_cache_preload

2018-08-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (add_url): Don't follow redirects when --max-redirects=0

2018-08-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (process_response_header): Prevent read of uninitialized data

2018-08-05 DalmeGNU <dalmemail@gmail.com>

     Add information related to the build process in Haiku [skip ci]
2018-08-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Add example batch_loader
     
     * examples/Makefile.am: Add batch_loader.c
     * examples/batch_loader.c: New example code
     
     This example uses 500 threads to process domains / URLS from
     stdin. It downloads the URL and creates a stats entry in out.csv.
     Check the source for details.

2018-08-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove usage of getaddrinfo_a() and gai_* functions
     
     The glibc async functions turned out to be unstable and
     error-prone. They also use threads to implement timeouts.
     If we need DNS timeouts and/or async DNS lookups, we should
     have a look at external resolver libraries.

2018-08-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix calling error handler for uncompressing
     
     * ../libwget/decompressor.c (wget_decompress): Fix argument to
       error_handler()
     * ../libwget/http.c (_on_stream_close_callback): Set stream context
       to NULL when freeing

2018-08-04 Darshit Shah <darnir@gnu.org>

     * src/wget.c (main): Add comment explaining why there are nthreads+2 slots

2018-08-01 Darshit Shah <darnir@gnu.org>

     * src/options.c: Remove dot progress from help text

2018-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * README.md: Mention 'setarch x86' on Haiku [skip ci]

2018-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * configure.ac: Remove -Wabi, too loud with gcc 8

2018-07-29 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (downloader_thread): Fix buffer overflow

2018-07-29 Darshit Shah <darnir@gnu.org>

     Rewrte the speed reporting codepath
     
     * include/wget/wget.h (wget_human_readable): Function is not a const
     * libwget/bar.c (_BAR_SETTINGS): Remove SPEED_REDRAW_TIME
     (struct _speed_report): Remove and add relevant fields to _bar_slot_t
     (_bar_update_speed): Removed
     (_bar_update_speed_stats): New function to populate the speed ring and
     fill in the speed_buf buffer
     (_bar_set_progress): Remove old commented out code
     (_bar_update_slot): Speed computation is moved to
     `_bar_update_speed_stats`.
     (wget_bar_set_slots): No longer need to realloc speed ring buffers
     (wget_bar_slot_begin): Initialize the ring_pos and the speed rings
     (wget_bar_deinit): Variable `speed_r` no longer used
     
     In this implementation, I've made a few functional changes and some
     other design changes to how the speed report is computed. First, I've
     removed the assumption that the progress bar is updated every 125ms.
     This is part of the client side logic and we can't assume that in the
     library. Instead, the speed report is computed every time the progress
     bar is refreshed. The size of the speed ring and how the computation is
     done is documented to allow the library users to make a decision on how
     they want to use the progress bar.
     
     While, I've currently removed SPEED_REDRAW_TIME, I do plan to bring it
     back soon. This will most likely be done alongside support for computing
     the ETA of the download.
     
     In this commit, I have also made it such that the speed is shown only
     after the speed ring is filled in entirely. This most likely needs to
     change such that we show the speed immediately. However, we document
     that it will jitter a lot while the speed ring is being populated.

2018-07-26 Darshit Shah <darnir@gnu.org>

     * libwget/bar.c(_bar_update_speed): Get time only once

2018-07-23 Darshit Shah <darnir@gnu.org>

     * libwget/bar.c(_BAR_DECOR_SIZE): Account for extra space at end

2018-07-26 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/tls_session.c: Only update/write when really changed

2018-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove --gnutls-options
     
     * docs/wget2.md: Remove docs for --gnutls-options
     * include/wget/wget.h: Remove WGET_SSL_DIRECT_OPTIONS
     * libwget/ssl_gnutls.c: Remove use of WGET_SSL_DIRECT_OPTIONS
     * src/options.c: Remove --gnutls-options
     * src/wget_options.h: Remove config.gnutls_options
     
     This option was obsoleted by --secure-protocol where you can
     also set an explicit priority/cipher string.

2018-07-17 Tim Rühsen <tim.ruehsen@gmx.de>

     Add TLSv1_x to --secure-protocol
     
     * docs/wget2.md: Extend docs for --secure-protocol
     * libwget/ssl_gnutls.c (wget_ssl_init): Add priority handling
     
     This commit adds TLSv1_1, TLSv1_2 and TLSv1_3.

2018-07-15 Tim Rühsen <tim.ruehsen@gmx.de>

     Extend OOM handling
     
     * include/wget/wget.h: Amend type of wget_oom_callback_t
     * libwget/xalloc.c: Amend OOM handling
     * src/options.c (_no_memory): Return EXIT_FAILURE
     * unit-tests/test.c (main): Cast to avoid warning
     
     The OOM callback can now return 0 and the allocation function is tried again.

2018-07-05 Darshit Shah <darnir@gnu.org>

     * libwget/bar.c: Set the speed modifier globally
     
     This reduces the number of computations that need to be done on each bar
     slot update. The modifier is set only at startup, so we don't need to
     recompute it everytime

2018-07-05 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Increase version of cache

2018-07-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Add wget_bitmap_t
     
     * include/wget/wget.h: Add bitmap prototypes
     * libwget/Makefile.am: Add libwget/bitmap.c
     * libwget/bitmap.c: New file for bitmap implementation
     * docs/Makefile.am: Add man pages for bitmap functions
     * unit-tests/test.c: Add tests for bitmap functions
     
     First version was written by Aniketh Girish

2018-07-04 Darshit Shah <darnir@gnu.org>

     * libwget/bar.c: Use enums for constants instead of defines

2018-07-04 Darshit Shah <darnir@gnu.org>

     * libwget/bar.c: Add a space to empty speed report

2018-06-11 DalmeGNU <dalmemail@gmail.com>

     Implementation of the --retry-on-http-status option
     
     * src/wget_options.h: Add http_retry_on_status (wget_vector_t) to config structure
     * src/options.c: Add --retry-on-http-status option
     * src/wget.c: Modify downloader_thread() in order to retry a download following the --retry-on-http-status option
     * docs/wget2.md: Add documentation for the --retry-on-http-status option

2018-06-11 DalmeGNU <dalmemail@gmail.com>

     * libwget/bar.c: Don't print zero as speed when we can't calculate it

2018-06-22 Tim Rühsen <tim.ruehsen@gmx.de>

     Add new option --keep-extension
     
     * src/options.c: Add option --keep-extension
     * src/wget.c (_open_unique): Add code for --keep-extension
     * src/wget_options.h (struct config): Add keep_extension member
     * docs/wget2.md: Add docs for --keep-extension
     
     The new option --keep-extension changes the behavior for creating a
     unique filename if a file already exists.
     The standard (default) pattern is to generate <filename>.<N>, the new
     pattern is <basename>_<N>.<ext>.
     
     The idea is use such files without renaming when the use depends on the
     extension, like on Windows.

2018-06-22 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Allow MinGW runner to fail
     
     The MinGW runner fails due to GnuTLS randomizer failing.
     See https://gitlab.com/gnutls/gnutls/issues/486
     
     When fixed, we will revert this commit.

2018-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * .gitlab-ci.yml: Add config.h to MinGW artifacts

2018-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/http.c (wget_http_get_response_cb): Fix clang warning

2018-06-20 Tim Rühsen <tim.ruehsen@gmx.de>

     * src/wget.c (_add_authorize_header): Fix tests for auth scheme name
     
     Reported-by: @Con7e (gitlab.com)

2018-06-15 Tim Rühsen <tim.ruehsen@gmx.de>

     Fix http2 slowness issue
     
     We saw many WINDOW_UPDATE frames while debugging, so we tried to
     fix the window sizes for connection and stream windows to a large value.
     
     This patch also simplifies the receive loop.

2018-06-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (_verify_certificate_callback): Fix grammar of error msg
     
     Reported-by: Nicholas Sielicki

2018-06-10 DalmeGNU <dalmemail@gmail.com>

     * libwget/bar.c (wget_bar_slot_begin): Reset speed ring buffer
     
     This fixes wrong (huge) values for small files on the progress bar.

2018-05-27 Neil Locketz <neil@nlocketz.com>

     Document new arguments
     
     * docs/wget2.md: Document the change in behavior, and what each option
       means.

2018-05-31 Neil Locketz <neil@nlocketz.com>

     Add verify-sig missing signature file behavior test.
     
     * tests/Makefile.am: Add new test.
     * tests/test-gpg-verify-no-fail.c: Test behavior of the new missing
     signature stuff.

2018-05-27 Neil Locketz <neil@nlocketz.com>

     Add arguments fail / nofail to --verify-sig
     
     * src/options.c: Change flag to parse out the signature options.
     * src/wget_options.h: Change verify_sig to allow more information
       (selected option rather then a boolean value).
     * src/wget.c: Check for missing signature behavior before failing for
       missing signature.
     * src/job.c: Added additional memory cleanup
     * src/wget_job.h: Shuffled some fields to make new behavior cleaner and
       more convinient. Also added list for remaining signatures that need to
       be attempted.
     
     Allows fine-tuning Wget2's behavior when signature files are not found.

2018-06-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * bootstrap.conf: Enable syncing with translationproject.org

2018-06-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Do not localize debug_printf format strings
     
     * libwget/cookie.c: Likewise
     * libwget/css_url.c: Likewise
     * libwget/hsts.c: Likewise
     * libwget/ocsp.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/tls_session.c: Likewise
     * unit-tests/test.c: Likewise
     
     Reported-by: Rafael Fontenelle

2018-06-02 Yuri Chornoivan <yurchor@ukr.net>

     Fix minor typos
     
     * docs/wget2.md: sperated -> separated
     * src/bar.c (bar_init): progess -> progress
     
     Copyright-paperwork-exempt: Yes

2018-05-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mingw: Add libpsl build + cleanup

2018-05-07 Tim Rühsen <tim.ruehsen@gmx.de>

     Skip -np/--no-parent for CSS URLs
     
     * src/wget.c: Use URL_FLG_REQUISITE for all CSS URLs
     * tests/test--page-requisites.c: Add tests for @import and url() in CSS

2018-05-04 Tim Rühsen <tim.ruehsen@gmx.de>

     Add URL_FLG_REQUISITE to add_url()
     
     * src/wget.c: Add flag URL_FLG_REQUISITE, call add_url() with
       URL_FLG_REQUISITE in case of page requisites.

2018-05-03 Tsukasa OI <floss_wget@irq.a4lg.com>

     Add test case to fail -p with -np
     
     * tests/test--page-requisites.c: Add test case to fail

2018-05-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * cfg.mk: Escape dots in path components

2018-05-07 Tim Rühsen <tim.ruehsen@gmx.de>

     * po/POTFILES.in: Remove libwget/html_url.c

2018-05-06 sameeran joshi <joshisameeran17@gmail.com>

     * libwget/html_url.c(_urls_to_absolute): Remove unused function

2018-05-04 Darshit Shah <darnir@gnu.org>

     Update AUTHORS
     
     [skip-ci]

2018-05-04 Tsukasa OI <floss_wget@irq.a4lg.com>

     * contrib/commit-check: Detect Copyright-paperwork-exempt correctly

2018-05-03 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove unconditionally set warning flags for GCC
     
     * configure.ac: Add -W(no-)unused-macros and -Wno-missing-field-initializers
       to gcc/clang compiler flags
     * libwget/Makefile.am: Remove -Wno-unused-macros
     * tests/Makefile.am: Remove -Wno-missing-field-initializers
     * unit-tests/Makefile.am: Likewise
     
     Reported-by: Dagobert Michelsen

2018-05-03 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/Makefile.am: Add $(EXEEXT) where missing

2018-05-03 Tsukasa OI <floss_wget@irq.a4lg.com>

     Fix null-pointer dereference on -r -np
     
     * src/wget.c (add_url): Fix null-pointer dereference on -r -np
     * tests/test-np.c: Modify test case to detect this condition
     
     Copyright-paperwork-exempt: Yes

2018-05-01 Tim Rühsen <tim.ruehsen@gmx.de>

     * README.md: Small cleanup

2018-05-01 Darshit Shah <darnir@gnu.org>

     * libwget/bar.c(_bar_set_progress): Fix off by one error

2018-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Prepare Release 1.99.1 (alpha)

2018-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/fuzzer.h: Disable pedantic and unused warnings

2018-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Update copyright to 2018

2018-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/update_copyright: Update to 2018

2018-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Add scripts for testing on gcc and OpenCSW buildfarm
     
     * ci-test: New script with generic code
     * ci-test.d/gcc110.fsffrance.org.sh: Script with special code for gcc110 (CentOS 7.4)
     * ci-test.d/gcc70.fsffrance.org.sh: Script with special code for gcc70 (NetBSD 5.1)
     * ci-test.d/login.opencsw.org.sh: Script with special code for OpenCSW (Solaris)

2018-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     * Makefile.am: Don't do syntax-check + check_options in tarball build

2018-04-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * tests/valgrind-suppressions: Ignore pthread leak from gai_misc.c

2018-04-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Add G_GNUC_WGET_UNUSED to fuzz code
     
     * fuzz/libwget_xml_parse_buffer_fuzzer.c: Likewise
     * fuzz/main.c: Likewise

2018-04-13 Tim Rühsen <tim.ruehsen@gmx.de>

     * fuzz/Makefile.am: Remove hard-coded compiler flags

2018-04-13 Tim Rühsen <tim.ruehsen@gmx.de>

     Remove _GL_INLINE from functions
     
     * libwget/hashmap.c: Likewise
     * libwget/iri.c: Likewise
     * libwget/ssl_gnutls.c: Likewise
     * libwget/utils.c: Likewise
     
     Gcc 4.1.3 on NetBSD 5.1 errors when duplicate _GL_INLINE is given as a
     function attribute.
     From the gnulib manual: "C code ordinarily should not use inline. Typically it
     is better to let the compiler figure out whether to inline, as compilers are
     pretty good about optimization nowadays. In this sense, inline is like
     register, another keyword that is typically no longer needed"

2018-04-30 Tim Rühsen <tim.ruehsen@gmx.de>

     Exclude fuzz corpora from tarball
     
     * fuzz/Makefile.am: Do not include corpora in tarball
     * fuzz/main.c: SKIP if corpora directory isn't found (make check)
     
     The fuzz corpora are thousands of files, not needed for a standard build
     from a distribution tarball. The reproducers of former issues are being
     included for regression testing.

2018-04-23 Tim Rühsen <tim.ruehsen@gmx.de>

     Add --retry-connrefused
     
     * src/options.c: Add --retry-connrefused
     * src/wget.c (establish_connection): Skip final failure
     * src/wget_options.h (struct config): Add retry_connrefused

2018-04-27 Darshit Shah <darnir@gnu.org>

     * tests/valgrind-suppressions: Update suppressions for Glibc 2.27

2018-04-17 Tim Rühsen <tim.ruehsen@gmx.de>

     * contrib/mail.sh: Assume bash, print email to file if msmtp not found

2018-04-17 Darshit Shah <darnir@gnu.org>

     * contrib/mail.sh: File got deleted accidentally in an earlier commit

2018-04-16 Darshit Shah <darnir@gnu.org>

     Update the AUTHORS list

2018-04-12 Tim Rühsen <tim.ruehsen@gmx.de>

     * .lgtm.yml: Call ./bootstrap

2018-04-12 Tim Rühsen <tim.ruehsen@gmx.de>

     Dont't recognize %3A as colon in relative URLs
     
     * include/wget/wget.h: New function wget_iri_unescape_url_inline()
     * libwget/iri.c: Likewise
     * src/wget.c (_normalize_uri): Use wget_iri_unescape_url_inline()
     * examples/check_url_types.c: Likewise
     * tests/test-base.c: Add test case
     * unit-tests/test.c (test_iri_relative_to_absolute): Add test case
     
     Relative URLS like in href='foo%3A/' have been detected and parsed
     as absolute URL with (unknown) scheme 'foo:'.
     This commit fixes it.

2018-04-11 Bas van Schaik <github@s.traiectum.net>

     * .lgtm.yml: Remove unnneeded package installation and ./bootstrap
     
     - no need to install gnutls-dev; it's installed automatically during the
       build/analysis process
     - however, the lgtm.yml I used for setting wget2 up on lgtm.com does
       install two other packages that are not auto-detected: lzip and
       libgpgme11-dev
     - no need to run ./bootstrap either; LGTM will do that automatically :)

2018-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * .lgtm.yml: New file for static analysis on lgtm.com [ci skip]

2018-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/xml.c: Fix copyright date (test lgtm.com automatism) [ci skip]

2018-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * include/wget/wget.h: Fix header guard (found by lgtm.com)

2018-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/ssl_gnutls.c (_do_handshake): Fix error value for older GnuTLS on OSX

2018-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

     * libwget/Makefile: Make css_tokenizer.c generation more portable

2018-03-15 Jiading Guo <zingdle@gmail.com>

     Add --[no-]compression=TYPE
     
     * src/options.c: Add compression option support
     * src/wget.c: Generate 'Accept-Encoding' headers accordingly
     * src/wget_options.h: Add compression variables
     * libwget/decompressor.c: Add xz and "none" types
     * include/wget/wget.h: Add xz types
     * docs/wget2.md: Add compression option document
     * tests/Makefile.am: Add compression test
     * tests/libtest.c: Add request header test support
     * tests/libtest.h: Add request header test support
     * tests/test-compression.c: Add compression test

2018-04-11 Tim Rühsen <tim.ruehsen@gmx.de>

